package legpause;

use X11::GUITest qw(:ALL);

use Storable qw(dclone);
#use Clone qw(clone);

%configHash=();

$configHash{"square targeting node x"}=12;
$configHash{"square targeting node y"}=108;
$configHash{"hole node x"}=12;
$configHash{"hole node y"}=160;
$configHash{"hole node pause button x"}=273;
$configHash{"hole node pause button y"}=45;
$configHash{"hole node play button x"}=250;
$configHash{"hole node play button y"}=45;
$configHash{"exposure node x"}=12;
$configHash{"exposure node y"}=195;
$configHash{"exposure node pause button x"}=273;
$configHash{"exposure node pause button y"}=45;
$configHash{"exposure node play button x"}=250;
$configHash{"exposure node play button y"}=45;

# Delay on clicking, etc
$delay=500;
$keyDelay=1000;

$app_title = '^Leginon:';

sub setConfigHash{
  my ($hashRef, %hash);
  $hashRef=$_[0];
  %hash=%{$hashRef};
  %configHash=%{ dclone (\%hash) };
}

# Needs to be rewritten to have the information about
# positions of elements of the GUI stored in some fashion

sub doPause(){
  # WVN TEMP DEBUGGING
  print "Contents of config hash in doPause() are: ", %configHash, "\n";

  @windows = FindWindowLike($app_title);
                                                                                                       
  my $nwindows = scalar (@windows);
  # print "* Number of $app_title windows found: ", $nwindows, "\n";
                                                                                                       
  if( $nwindows == 0 ){
    # print "Error: no $app_title window found \n";
    exit -1;
  }
  elsif( $nwindows > 1 ){
    # print "Error: more than one $app_title window found \n";
  }
                                                                                                       
  my ($x, $y, $width, $height) = GetWindowPos($windows[0]);
                                                                                                       
  SetEventSendDelay($delay);
                                                                                                       
  my ($xmouse, $ymouse);
  # click top bar to bring window into focus
  $xmouse=$width/2;
  $ymouse=0;
  ClickWindow $windows[0], $xmouse, $ymouse;

  my $currTime = getLocalTime();
  #print "Pausing Leginon at ", $currTime, "\n";
  print STDERR "Pausing Leginon at ", $currTime, "\n";
                                                                                                       
  # click on Square Targeting node - this is to ensure that
  # clicking on the Hole node does not toggle it into inaction
  #$xmouse=12;
  #$ymouse=108;
  $xmouse=$configHash{"square targeting node x"};
  $ymouse=$configHash{"square targeting node y"};

  #TEMP DEBUGGING
  print "DEBUG: square targeting node x is: $xmouse\n";

  ClickWindow $windows[0], $xmouse, $ymouse;
                                                                                                       
  # click on Hole node
  #$xmouse=12;
  #$ymouse=160;
  $xmouse=$configHash{"hole node x"};
  $ymouse=$configHash{"hole node y"};
  ClickWindow $windows[0], $xmouse, $ymouse;
                                                                                                       
  # click on pause button
  # $xmouse=268;
  #$xmouse=273;
  #$ymouse=45;
  $xmouse=$configHash{"hole node pause button x"};
  $ymouse=$configHash{"hole node pause button y"};
  ClickWindow $windows[0], $xmouse, $ymouse;
  # click on Exposure node
  #$xmouse=12;
  #$ymouse=185;
  #$ymouse=195;
  # WVN 25/11/07 - changed again for Leginon 1.4.1
  # $ymouse=205;
  #$ymouse=195;
  $xmouse=$configHash{"exposure node x"};
  $ymouse=$configHash{"exposure node y"};
  ClickWindow $windows[0], $xmouse, $ymouse;

  # click on pause button
  # $xmouse=268;
  #$xmouse=273;
  #$ymouse=45;
  $xmouse=$configHash{"exposure node pause button x"};
  $ymouse=$configHash{"exposure node pause button y"};
  ClickWindow $windows[0], $xmouse, $ymouse;
}

sub doUnpause(){
  @windows = FindWindowLike($app_title);
                                                                                                       
  my $nwindows = scalar (@windows);
  # print "* Number of $app_title windows found: ", $nwindows, "\n";
                                                                                                       
  if( $nwindows == 0 ){
    # print "Error: no $app_title window found \n";
    exit -1;
  }
  elsif( $nwindows > 1 ){
    # print "Error: more than one $app_title window found \n";
  }
                                                                                                       
  my ($x, $y, $width, $height) = GetWindowPos($windows[0]);
                                                                                                       
  SetEventSendDelay($delay);
                                                                                                       
  my ($xmouse, $ymouse);
  # click top bar to bring window into focus
  $xmouse=$width/2;
  $ymouse=0;
  ClickWindow $windows[0], $xmouse, $ymouse;
                                                                                                       
  my $currTime = getLocalTime();
  #print "Unpausing Leginon at ", $currTime, "\n";
  print STDERR "Unpausing Leginon at ", $currTime, "\n";
                                                                                                       
  # click on Square Targeting node - this is to ensure that
  # clicking on the Hole node does not toggle it into inaction
  #$xmouse=12;
  #$ymouse=108;
  $xmouse=$configHash{"square targeting node x"};
  $ymouse=$configHash{"square targeting node y"};
  ClickWindow $windows[0], $xmouse, $ymouse;
                                                                                                       
  # click on Hole node
  #$xmouse=12;
  #$ymouse=160;
  $xmouse=$configHash{"hole node x"};
  $ymouse=$configHash{"hole node y"};
  ClickWindow $windows[0], $xmouse, $ymouse;
                                                                                                       
  # click on play button
  # $xmouse=245;
  $xmouse=250;
  $ymouse=45;
  $xmouse=$configHash{"hole node play button x"};
  $ymouse=$configHash{"hole node play button y"};
  ClickWindow $windows[0], $xmouse, $ymouse;

  # click on Exposure node
  #$xmouse=12;
  #$ymouse=185;
  #$ymouse=195;
  # WVN 25/11/07 - changed again for Leginon 1.4.1
  # $ymouse=205;
  #$ymouse=195;
  $xmouse=$configHash{"exposure node x"};
  $ymouse=$configHash{"exposure node y"};
  ClickWindow $windows[0], $xmouse, $ymouse;
                                                                                                       
  # click on play button
  # $xmouse=245;
  #$xmouse=250;
  #$ymouse=45;
  $xmouse=$configHash{"exposure node play button x"};
  $ymouse=$configHash{"exposure node play button y"};
  ClickWindow $windows[0], $xmouse, $ymouse;
}

sub doStop(){
  @windows = FindWindowLike($app_title);
                                                                                                       
  my $nwindows = scalar (@windows);
  # print "* Number of $app_title windows found: ", $nwindows, "\n";
                                                                                                       
  if( $nwindows == 0 ){
    # print "Error: no $app_title window found \n";
    exit -1;
  }
  elsif( $nwindows > 1 ){
    # print "Error: more than one $app_title window found \n";
  }
                                                                                                       
  my ($x, $y, $width, $height) = GetWindowPos($windows[0]);
                                                                                                       
  SetEventSendDelay($delay);
                                                                                                       
  my ($xmouse, $ymouse);
  # click top bar to bring window into focus
  $xmouse=$width/2;
  $ymouse=0;
  ClickWindow $windows[0], $xmouse, $ymouse;

  my $currTime = getLocalTime();
  # print "Stopping Leginon", $currTime, "\n";
  print STDERR "Stopping Leginon", $currTime, "\n";

  SetKeySendDelay($keyDelay);

  # SendKeys('%(f)x ');
  # WVN - "^(u)" is dirty hack to give Ctrl-U in order to
  # remove x's which are sent to new window with focus when
  # Leginon has quit
  SendKeys('%(f)x^(u)');

}

sub getLocalTime(){
  my @months = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
  my @weekDays = qw(Sun Mon Tue Wed Thu Fri Sat Sun);
  my $second, my $minute, my $hour, my $dayOfMonth, my $month, my $yearOffset, my $dayOfWeek, my $dayOfYear, my $daylightSavings;
  ($second, $minute, $hour, $dayOfMonth, $month, $yearOffset, $dayOfWeek, $dayOfYear, $daylightSavings) = localtime();
  my $year = 1900 + $yearOffset;
  my $theTime = "$hour:$minute:$second, $weekDays[$dayOfWeek] $months[$month] $dayOfMonth, $year";
  return $theTime;
}

1;
