<?php
/**
 *	The Leginon software is Copyright under 
 *	Apache License, Version 2.0
 *	For terms of the license agreement
 *	see  http://leginon.org
 *
 */

require_once "inc/particledata.inc";
require_once "inc/leginon.inc";
require_once "inc/project.inc";
require_once "inc/viewer.inc";
require_once "inc/processing.inc";
  
// check if coming directly from a session
$expId = $_GET['expId'];
if ($expId) {
        $sessionId=$expId;
        $formAction=$_SERVER['PHP_SELF']."?expId=$expId";
}
else {
        $sessionId=$_POST['sessionId'];
        $formAction=$_SERVER['PHP_SELF'];
}
$projectId=getProjectId();

$javascript = "<script src='../js/viewer.js'></script>\n";
$javascript.= editTextJava();

processing_header("3d Density Volume Summary","3d Density Volume Summary Page", $javascript);

// edit description form
echo "<form name='templateform' method='post' action='$formAction'>\n";

// --- Get Stack Data
$particle = new particledata();

// --- Get 3d Density Data
$showhidden = ($_POST['showHidden'] == 'show hidden') ? true: false;
$allDensityRuns = $particle->get3dDensitysFromSession($sessionId, $showhidden);
// --- Only show models
if ($allDensityRuns) {
	$densityRuns=array();
	foreach ($allDensityRuns as $drun) {
		if (!$drun['REF|ApRefineIterData|iterid']) $densityRuns[]=$drun;
	}
}
$densityRuns = $allDensityRuns;

if ($densityRuns) {

	$html = "<table class='tableborder' border='1' cellspacing='1' cellpadding='5'>\n";
	$html .= "<TR>\n";
	$display_keys = array ( 'defid', 'name', 'image', 'history', 'pixel size', 'box size', 'resolution', 'description', 'path', );
	foreach($display_keys as $key) {
		$html .= "<td><span class='datafield0'>".$key."</span> </TD> ";
	}

	foreach ($densityRuns as $densityrun) {
		$densityid = $densityrun['DEF_id'];

		if ($_POST['showHidden'] == 1 && $densityrun['hidden'] == 1) {
			$html .= "<td>$densityrun[DEF_id]\n";
			$html.= " <input class='edit' type='submit' name='unhideItem".$densityid."' value='unhide'>\n";
			$html .= "</td>\n";
			continue;	
		}

		// update description
		if ($_POST['updateDesc'.$densityid]) {
			updateDescription('Ap3dDensityData', $densityid, $_POST['newdescription'.$densityid]);
			$densityrun['description']=$_POST['newdescription'.$densityid];
			$html.= "<br/><font color='#cc0000'>HIDDEN</font>\n";
			$html.= " <input class='edit' type='submit' name='unhideItem".$densityid."' value='unhide'>\n";
		}

		if ($_POST['hideItem'.$densityid] == 'hide') {
			$particle->updateHide('Ap3dDensityData', $densityid, '1');
			$densityrun['hidden']=1;
		} elseif ($_POST['unhideItem'.$densityid] == 'unhide') {
			$particle->updateHide('Ap3dDensityData', $densityid, '0');
			$densityrun['hidden']=0;
		}

		// PRINT INFO
		$html .= "<TR>\n";

		# def id
		$html .= "<td>$densityrun[DEF_id]\n";
		if ($rctrun['hidden'] == 1 || $densityrun['hidden'] == 1) {
			$html.= "<br/><font color='#cc0000'>HIDDEN</font>\n";
			$html.= " <input class='edit' type='submit' name='unhideItem".$densityid."' value='unhide'>\n";
		} else $html .= "<br/><input class='edit' type='submit' name='hideItem".$densityid."' value='hide'>\n";
		$html .= "</td>\n";

		# name
		$modelfile = $densityrun['path']."/".$densityrun['name'];
		$html .= "<td><A HREF='densityreport.php?expId=$expId&densityId=$densityid'>$densityrun[name]</A>\n";
		$modellink = "<font size='-2'><a href='download.php?expId=$expId&file=$modelfile'>\n";
		$modellink .= "  <img style='vertical-align:middle' src='img/download_arrow.png' border='0' width='16' height='17' alt='download model'>\n";
		$modellink .= "</a></font>\n";
		$html .= $modellink."</td>\n";

		# sample image
		$giffile = $densityrun['path']."/".$densityrun['name'].".animate.gif";
		$pngfile = $densityrun['path']."/".$densityrun['name'].".1.png";

		if ($giffile && file_exists($giffile))
			$html .= "<td valign='center' align='center'><img src='loadimg.php?rawgif=1&filename=".$giffile."' height='128'></td>\n";
		elseif ($pngfile && file_exists($pngfile))
			$html .= "<td valign='center' align='center'><img src='loadimg.php?h=128&filename=".$pngfile."' height='128'></td>\n";
		else
			$html .= "<td></td>\n";


		if ($densityrun['REF|ApRctRunData|rctrun'])
			$html .= "<td><A HREF='rctreport.php?expId=$expId&rctId="
				.$densityrun['REF|ApRctRunData|rctrun']."'>rctrun #"
				.$densityrun['REF|ApRctRunData|rctrun']."</A></TD>\n";
		elseif ($densityrun['REF|ApRefineIterData|iterid'])
			$html .= "<td><A HREF='reconreport.php?expId=$expId&reconId="
				.$densityrun['refrun']."'> refine run #"
				.$densityrun['refrun']."</A></TD>\n";
		elseif ($densityrun['pdbid'])
			$html .= "<td><A HREF='http://www.rcsb.org/pdb/cgi/explore.cgi?pdbId="
				.$densityrun['pdbid']."'> PDB id "
				.$densityrun['pdbid']."&nbsp;<img src='img/external.png' BORDER='0' HEIGHT='10' WIDTH='10'>"
				."</A></TD>\n";
		elseif ($densityrun['emdbid'])
			$html .= "<td><A HREF='http://www.ebi.ac.uk/msd-srv/emsearch/atlas/"
				.$densityrun['emdbid']."_visualization.html'> EMDB id "
				.$densityrun['emdbid']."&nbsp;<img src='img/external.png' BORDER='0' HEIGHT='10' WIDTH='10'>"
				."</A></TD>\n";
		else
			$html .= "<td><I>unknown</I></TD>\n";

		$html .= "<td>".round($densityrun[pixelsize],2)."</TD>\n";
		$html .= "<td>$densityrun[boxsize]</TD>\n";
		$html .= "<td>".round($densityrun[resolution],2)."</TD>\n";

		# add edit button to description if logged in
		$descDiv = ($_SESSION['username']) ? editButton($densityid,$densityrun['description']) : $densityrun['description'];
		$html .= "<td>$descDiv</td>\n";

		$html .= "<td>$densityrun[path]</TD>\n";

		$html .= "</tr>\n";
	}

	$html .= "</table>\n";
	echo $html;
} else {
	echo "no 3d density volume information available";
}
//Hide hidden
$html = " <input class='edit' type='submit' name='showHidden' value='";
$html.= ($_POST['showHidden'] == 'show hidden' ) ? 'hide hidden': 'show hidden';
$html .= "'>\n";
echo $html;

processing_footer();
?>
