<?php
// $PUBLICATIONS an array holding constant information about the publications that are referenced in Appion.
// When adding a new processing package to Appion, this file should be updated with any associated publications
// for proper reference reporting.


$PUBLICATIONS['appion'] = array(
'title' => 'Appion: an integrated, database-driven pipeline to facilitate EM image processing.',
'year' => '2009',
'authorlist' => 'Lander GC, Stagg SM, Voss NR, et al.',
'journal' => 'J Struct Biol.',
'volume' => '166',
'issue' => '1',
'pmid' => '19263523',
'pmcid' => '2775544',
'doi' => '10.1016/j.jsb.2009.01.002',
'logo' => 'img/topbarbackgrnd.jpg',
'pages' => '95-102');

$PUBLICATIONS['eman'] = array(
'title' => 'EMAN: semiautomated software for high-resolution single-particle reconstructions.',
'year' => '1999',
'authorlist' => 'Ludtke SJ, Baldwin PR, Chiu W.',
'journal' => 'J Struct Biol.',
'volume' => '128',
'issue' => '1',
'pmid' => '10600563',
'pmcid' => '',
'doi' => '',
'logo' => 'img/eman_logo.png',
'pages' => '82-97');

$PUBLICATIONS['spider'] = array(
'title' => 'SPIDER and WEB: processing and visualization of images in 3D electron microscopy and related fields.',
'year' => '1996',
'authorlist' => 'Frank J, Radermacher M, Penczek P, Zhu J, Li Y, Ladjadj M, Leith A.',
'journal' => 'J Struct Biol.',
'volume' => '116',
'issue' => '1',
'pmid' => '8742743',
'pmcid' => '',
'doi' => '',
'logo' => 'img/spider_logo.png',
'pages' => '190-9');

$PUBLICATIONS['imagic'] = array(
'title' => 'A New Generation of the IMAGIC Image Processing System.',
'year' => '1996',
'authorlist' => 'van Heel M., Harauz G., Orlova E. V., Schmidt R. & Schatz M',
'journal' => 'J Struct Biol.',
'volume' => '116',
'issue' => '1',
'pmid' => '8742718',
'pmcid' => '',
'doi' => '',
'logo' => 'img/imagic_logo.png',
'pages' => '');

$PUBLICATIONS['xmipp'] = array(
'title' => 'XMIPP: a new generation of an open-source image processing package for electron microscopy',
'year' => '2004',
'authorlist' => 'Sorzano CO, Marabini R, Velázquez-Muriel J, Bilbao-Castro JR, Scheres SH, Carazo JM, Pascual-Montano A.',
'journal' => 'J Struct Biol.',
'volume' => '148',
'issue' => '2',
'pmid' => '15477099',
'pmcid' => '',
'doi' => '10.1016/j.jsb.2004.06.006',
'logo' => 'img/xmipp_logo.png',
'pages' => '');

$PUBLICATIONS['frealign'] = array(
'title' => 'FREALIGN: high-resolution refinement of single particle structures.',
'year' => '2007',
'authorlist' => 'Grigorieff, N.',
'journal' => 'J Struct Biol.',
'volume' => '157',
'issue' => '1',
'pmid' => '16828314',
'pmcid' => '',
'doi' => '10.1016/j.jsb.2006.05.004',
'logo' => 'img/grigorieff_lab.png',
'pages' => '');

$PUBLICATIONS['initmodel'] = array(
'title' => 'A toolbox for ab initio 3-D reconstructions in single-particle electron microscopy.',
'year' => '2010',
'authorlist' => 'Voss NR, Lyumkis D, Cheng A, et al.</i>',
'journal' => 'J Struct Biol.',
'volume' => '169',
'issue' => '3',
'pmid' => '20018246',
'pmcid' => '',
'doi' => '',
'logo' => 'img/topbarbackgrnd.jpg',
'pages' => '');
 
$PUBLICATIONS['imodweightedbackproj'] = array(
'title' => 'Dual-axis tomography: an approach with alignment methods that preserve resolution.',
'year' => '1997',
'authorlist' => 'D.N. Mastronarde',
'journal' => 'J Struct Biol.',
'volume' => '120',
'issue' => '3',
'pmid' => '9441937',
'pmcid' => '',
'doi' => 'doi:10.1006/jsbi.1997.3919',
'logo' => '',
'pages' => '');
 
$PUBLICATIONS['protomo'] = array(
'title' => 'Accurate marker-free alignment with simultaneous geometry determination and reconstruction of tilt series in electron tomography.',
'year' => '2006',
'authorlist' => 'Winkler H, Taylor KA',
'journal' => 'Ultramicroscopy',
'volume' => '106',
'issue' => '3',
'pmid' => '16137829',
'pmcid' => '',
'doi' => 'doi:10.1016/j.ultramic.2005.07.007',
'logo' => '',
'pages' => '');
 
$PUBLICATIONS['imod'] = array(
'title' => 'Computer visualization of three-dimensional image data using IMOD',
'year' => '1996',
'authorlist' => 'Kremer J.R., D.N. Mastronarde and J.R. McIntosh',
'journal' => 'J. Struct. Biol.',
'volume' => '116',
'issue' => '1',
'pmid' => '8742726',
'pmcid' => '',
'doi' => 'doi:10.1006/jsbi.1996.0013',
'logo' => '',
'pages' => '');
	
$PUBLICATIONS['ace'] = array(
'title' => 'ACE: automated CTF estimation.',
'year' => '2005',
'authorlist' => 'Mallick, Carragher, Potter, and Kriegman',
'journal' => 'Ultramicroscopy',
'volume' => '104',
'issue' => '1',
'pmid' => '',
'pmcid' => '',
'doi' => '',
'logo' => '',
'pages' => '8-29');
 
$PUBLICATIONS['roseman03'] = array(
'title' => 'Particle finding in electron micrographs using a fast local correlation algorithm.',
'year' => '2003',
'authorlist' => 'Roseman',
'journal' => 'Ultramicroscopy',
'volume' => '94',
'issue' => '3-4',
'pmid' => '',
'pmcid' => '',
'doi' => '',
'logo' => '',
'pages' => '225-36');

$PUBLICATIONS['roseman04'] = array(
'title' => 'FindEM--a fast, efficient program for automatic selection of particles from electron micrographs.',
'year' => '2004',
'authorlist' => 'Roseman',
'journal' => 'J. Struct. Biol.',
'volume' => '145',
'issue' => '1-2',
'pmid' => '15065677',
'pmcid' => '',
'doi' => '',
'logo' => 'img/findem.png',
'pages' => '91-9');

$PUBLICATIONS['sousa07'] = array(
'title' => 'Ab initio resolution measurement for single particle structures.',
'year' => '2007',
'authorlist' => 'Sousa and Grigorieff',
'journal' => 'J Struct Biol',
'volume' => '157',
'issue' => '1',
'pmid' => '',
'pmcid' => '',
'doi' => '',
'logo' => '',
'pages' => '201-10');

$PUBLICATIONS['leginon'] = array(
'title' => 'Automated molecular microscopy: the new Leginon system.',
'year' => '2005',
'authorlist' => 'Suloway, Pulokas, Fellmann, Cheng, Guerra, Quispe, Stagg, Potter, and Carragher',
'journal' => 'J Struct Biol',
'volume' => '151',
'issue' => '1',
'pmid' => '',
'pmcid' => '',
'doi' => '',
'logo' => '',
'pages' => '41-60');

$PUBLICATIONS['dog'] = array(
'title' => 'DoG Picker and TiltPicker: tools to facilitate particle selection in single particle electron microscopy.',
'year' => '2009',
'authorlist' => 'Voss, Yoshioka, Radermacher, Potter, and Carragher',
'journal' => 'J Struct Biol',
'volume' => '166',
'issue' => '2',
'pmid' => '',
'pmcid' => '',
'doi' => '',
'logo' => '',
'pages' => '205-13');

$PUBLICATIONS['scheres07'] = array(
'title' => 'Disentangling conformational states of macromolecules in 3D-EM through likelihood optimization.',
'year' => '2007',
'authorlist' => 'Scheres, S. H., H. Gao, et al.',
'journal' => 'Nat Methods',
'volume' => '4',
'issue' => '1',
'pmid' => '',
'pmcid' => '',
'doi' => '',
'logo' => 'img/xmipp_logo.png',
'pages' => '');

$PUBLICATIONS['scheres10'] = array(
'title' => 'Classification of structural heterogeneity by maximum-likelihood methods.',
'year' => '2010',
'authorlist' => 'Scheres, S. H.',
'journal' => 'Methods Enzymol',
'volume' => '482',
'issue' => '',
'pmid' => '',
'pmcid' => '',
'doi' => '',
'logo' => 'img/xmipp_logo.png',
'pages' => '');

$PUBLICATIONS['relion'] = array(
'title' => 'A Bayesian View on Cryo-EM Structure Determination.',
'year' => '2012',
'authorlist' => 'Scheres, S. H.',
'journal' => 'Journal of Molecular Biology',
'volume' => '415',
'issue' => '2',
'pmid' => '',
'pmcid' => '',
'doi' => 'doi:10.1016/j.jmb.2011.11.010',
'logo' => 'img/Relion_logo_v1_64x64.png',
'pages' => '406-418');

$PUBLICATIONS['simple'] = array(
'title' => 'SIMPLE: Software for ab initio reconstruction of heterogeneous single-particles',
'year' => '2012',
'authorlist' => 'Elmlund, D., Elmlund, H.',
'journal' => 'Journal of Structural Biology',
'volume' => '180',
'issue' => '3',
'pmid' => '22902564',
'pmcid' => '',
'doi' => 'doi: 10.1016/j.jsb.2012.07.010.',
'logo' => 'img/simplelogo.png',
'pages' => '420-427');

$PUBLICATIONS['optimod'] = array(
'title' => 'Optimod - An Automated Approach for Constructing and Optimizing Initial Models for Single-Particle Electron Microscopy',
'year' => '2013',
'authorlist' => 'Lyumkis, D., Vinterbo, S., Carragher, B., Potter., C.',
'journal' => 'Journal of Structural Biology',
'volume' => '184',
'issue' => '3',
'pmid' => '24161732',
'pmcid' => '3885246',
'doi' => 'doi:10.1016/j.jsb.2013.10.009',
'logo' => 'img/topbarbackgrnd.jpg',
'pages' => '417-426');

$PUBLICATIONS['gpudriftcorr'] = array(
'title' => 'Electron counting and beam-induced motion correction enable near-atomic-resolution single-particle cryo-EM',
'year' => '2013',
'authorlist' => 'Xueming Li,	 Paul Mooney,	 Shawn Zheng,	 Christopher R Booth,	 Michael B Braunfeld,	 Sander Gubbens,	 David A Agard	 & Yifan Cheng',
'journal' => 'Nature Methods',
'volume' => '10',
'issue' => '6',
'pmid' => '23644547',
'pmcid' => '3684049',
'doi' => 'doi:10.1038/nmeth.2472',
'logo' => 'img/topbarbackgrnd.jpg',
'pages' => '584-590');

$PUBLICATIONS['purduedriftcorr'] = array(
'title' => 'Motion correction for moview recorded using direct electron detectors',
'year' => '2015',
'authorlist' => 'Wen Jiang',
'journal' => "<a href=https://github.com/jianglab/motioncorr > https://github.com/jianglab/motioncorr </a>",
'volume' => '',
'issue' => '',
'pmid' => '',
'pmcid' => '',
'doi' => '',
'logo' => 'img/topbarbackgrnd.jpg',
'pages' => '');

$PUBLICATIONS['de_frame'] = array(
'title' => 'Movie-Mode Processing program DE_process_frames.py',
'year' => '2012-2015',
'authorlist' => 'Benjamin Bammes',
'journal' => "<a href=http://www.directelectron.com/products/software > Direct Electron website </a>",
'volume' => ' 2.7.1',
'issue' => '',
'pmid' => '',
'pmcid' => '',
'doi' => '',
'logo' => 'img/DE.png',
'pages' => '');

$PUBLICATIONS['isac'] = array(
'title' => 'Iterative stable alignment and clustering of 2D transmission electron microscope images',
'year' => '2012',
'authorlist' => 'Yang Z, Fang J, Chittuluru J, Asturias FJ, Penczek PA.',
'journal' => 'Structure',
'volume' => '20',
'issue' => '2',
'pmid' => '22325773',
'pmcid' => '3426367',
'doi' => 'doi: 10.1016/j.str.2011.12.007',
'pages' => '237-47');

$PUBLICATIONS['xmipp3CL2D'] = array(
'title' => 'A clustering approach to multireference alignment of single-particle projections in electron microscopy.',
'year' => '2010',
'authorlist' => 'Sorzano CO, Bilbao-Castro JR, Shkolnisky Y, Alcorlo M, Melero R, Caffarena-Fernández G, Li M, Xu G, Marabini R, Carazo JM.',
'journal' => 'J Struct Biol.',
'volume' => '171',
'issue' => '2',
'pmid' => '20362059',
'pmcid' => '',
'doi' => '',
'logo' => 'img/xmipp_logo.png',
'pages' => '');

$PUBLICATIONS['imodctf'] = array(
'title' => 'CTF determination and correction for low dose tomographic tilt series',
'year' => '2009',
'authorlist' => 'Quanren Xiong, Mary K. Morphew, Cindi L. Schwartz, Andreas H. Hoenger, David N. Mastronarde',
'journal' => 'J Struct Biol.',
'volume' => '168',
'issue' => '3',
'pmid' => '19732834',
'pmcid' => '',
'doi' => 'doi:10.1016/j.jsb.2009.08.016',
'logo' => '',
'pages' => '');

$PUBLICATIONS['dose_comp'] = array(
'title' => 'Measuring the optimal exposure for single particle cryo-EM using a 2.6 Å reconstruction of rotavirus VP6',
'year' => '2015',
'authorlist' => 'Timothy Grant, Nikolaus Grigorieff',
'journal' => 'eLife',
'volume' => '',
'issue' => '',
'pmid' => '26023829',
'pmcid' => '',
'doi' => 'doi:10.7554/eLife.06980',
'logo' => '',
'pages' => '');

$PUBLICATIONS['appion-protomo'] = array(
'title' => 'Automated batch fiducial-less tilt-series alignment in Appion using Protomo',
'year' => '2015',
'authorlist' => 'Alex J. Noble, Scott M. Stagg',
'journal' => 'J Struct Biol.',
'volume' => '',
'issue' => '',
'pmid' => '26455557',
'pmcid' => '',
'doi' => 'doi:10.1016/j.jsb.2015.10.003',
'logo' => '',
'pages' => '');

$PUBLICATIONS['tomo3d1'] = array(
'title' => 'Fast tomographic reconstruction on multicore computers',
'year' => '2011',
'authorlist' => 'J.I. Agulleiro, J.J. Fernandez',
'journal' => 'Bioinformatics',
'volume' => '',
'issue' => '',
'pmid' => '21172911',
'pmcid' => '',
'doi' => 'doi:10.1093/bioinformatics/btq692',
'logo' => '',
'pages' => '');

$PUBLICATIONS['tomo3d2'] = array(
'title' => 'Tomo3D 2.0 - Exploitation of Advanced Vector eXtensions (AVX) for 3D reconstruction',
'year' => '2015',
'authorlist' => 'J.I. Agulleiro, J.J. Fernandez',
'journal' => 'J Struct Biol.',
'volume' => '',
'issue' => '',
'pmid' => '25528570',
'pmcid' => '',
'doi' => 'doi:10.1016/j.jsb.2014.11.009',
'logo' => '',
'pages' => '');

$PUBLICATIONS['tomoctf'] = array(
'title' => 'CTF Determination and Correction in Electron Cryotomography',
'year' => '2006',
'authorlist' => 'J.J. Fernandez, S. Li, R.A. Crowther ',
'journal' => 'Ultramicroscopy',
'volume' => '106',
'issue' => '7',
'pmid' => '16616422',
'pmcid' => '',
'doi' => 'doi:10.1016/j.ultramic.2006.02.004',
'logo' => '',
'pages' => '587-596');

$PUBLICATIONS['rpp'] = array(
'title' => 'Alignment of cryo-EM movies of individual particles by optimization of image translations.',
'year' => '2015',
'authorlist' => 'Rubinstein JL, Brubaker MA',
'journal' => 'J Struct Biol.',
'volume' => '192',
'issue' => '2',
'pmid' => '26296328',
'pmcid' => '',
'doi' => 'doi:10.1016/j.jsb.2015.08.007',
'logo' => '',
'pages' => '188-195');

$PUBLICATIONS['gctf'] = array(
'title' => 'Gctf: real-time CTF determination and correction',
'year' => '2015',
'authorlist' => 'Kai Zhang',
'journal' => 'J Struct Biol.',
'volume' => '193',
'issue' => '1',
'pmid' => '26592709',
'pmcid' => '4711343',
'doi' => '10.1016/j.jsb.2015.11.003',
'logo' => '',
'pages' => '1-12');

$PUBLICATIONS['ctffind4'] = array(
'title' => 'CTFFIND4: Fast and accurate defocus estimation from electron micrographs.',
'year' => '2015',
'authorlist' => 'Rohou A, Grigorieff N.',
'journal' => 'J Struct Biol.',
'volume' => '192',
'issue' => '2',
'pmid' => '26278980',
'doi' => '10.1016/j.jsb.2015.08.008',
'pages' => '216-21');

?>
