/**
 * help key : value defined in javascript object notation
 */

var help = {
	'appion' : {
		'ampcontrast' : 'Value for the amplitude contrast',		
		'boxfiles' : 'Only the eman box files will be created',
		'runid' : 'Specifies the name associated with the processing results unique to the specified session and parameters.  An attempt to use the same run name for a session using different processing parameters will result in an error.',
		'preset' : 'Leginon preset if applicable',
		'runname' : 'Specifies the name associated with the processing results unique to the specified session and parameters.  An attempt to use the same run name for a session using different processing parameters will result in an error. The Default is automatically incremented',
		'description' : 'brief description attributed with the processing results',
		'descr' : 'brief description attributed with the processing results',
		'outdir' : 'The base output directory to which files will be stored.  If you are testing, switch \"appion\" to \"temp\".  A subdirectory of the run name will be appended for actual output',
		'checkimages' : 'Choose what images to process here.  Images can be inspected by Viewer or ImageAssessor.  BEST images include ones inspected as KEEP or as EXEMPLAR in the viewer.  NON-REJECTED images include the BEST images above-mentioned and the uninspected ones and therefore exclude only the REJECTED or HIDDEN images.',
		'nowait' : 'After processing all the images collected for this session, this will continue to check if new images have been acquired every 10 minutes.  If after 2 hours, no new images have been acquired, this job will terminate.',
		'background' : 'Minimizes the output when the program runs',
		'imgorder' : 'Change the order in which the images are process, shuffle: process in random order, reverse: process newest images first, normal: process oldest images first',
		'limit' : 'If you do not want to process all the images, enter a number and the program will only process this number of images.  Good for testing a few images before committing the results to the database.',
		'cont' : 'By default you ALWAYS want to continue, unless you are NOT committing to the database yet and you want to reprocess an image.',
		'commit' : 'Stores results to the database.  When testing do NOT commit, but once you are happy with the results start commiting the data, otherwise all information will be lost.',
		'diameter' : 'Particle diameter in &Aring;ngstr&ouml;ms, only used when displaying the picked particles in the web image viewers.',
		'minthresh' : 'Threshold for particle picking from the cross-correlation or dogpicker map.  Any values above this threshold are considered particles.<br/>For template correlation, this should be between 0.0 and 1.0, typically 0.4 to 0.6 is used.<br/>For dogPicker, the value is in terms of standard deviations from the mean divided by four.  Reasonable range from 0.4 to 3.0 with typical values falling between 0.7 and 1.0',
		'maxthresh' : 'Maximum threshold for particle picking from the cross-correlation or dogpicker map.  Any values above this threshold are rejected.<br/>For template correlation, you probably do not need this, but typical values would be between 0.7 and 0.8.<br/>For dogPicker, the values is in terms of standard deviations from the mean divided by four.  Reasonable range from 1.0 to 5.0 with typical values falling between 1.5 and 2.5',
		'maxpeaks' : 'This a feature limits the number of particles allowed in an image.  By default it is set to 1500, but if you want no more than 50 particles an image fill in this value',
		'lpval' : 'Low pass filtering of the image before picking.  This should be about 1/10 to 1/50 of the particle diameter, <I>e.g.</I> for a particle with diameter 150 &Aring;, a low pass of 5-10 &Aring; works pretty good',
		'tiltangle' : 'Tilt Angle of micrographs, exclude all images where tilt angle is not equal to specified value. <br><br> "large tilt angles" refers to positive AND negative tilt values above and including 30 degrees. "small tilt angles" refers to positive AND negative tilt values below 30 degrees. "negative tilt angles" and "positive tilt angles" will NOT include particles from micrographs with angles between -2.0 and +2.0 degrees. These values are used as defaults to account for a slight error in the measurement of the stage angle at a nominal value of 0 degrees.',
		'lpstackval' : 'Low pass filter applied to individual particles',
		'hpstackval' : 'High pass filter applied to individual particles',
		'hpval' : 'High pass filtering of the image before picking.  This removes any darkness gradients in the image.  Typically you could disable this by setting it equal to zero, otherwise 600 work pretty good.  Warning this feature typically normalizes the crud so more particles get picked from crud.',
		'medianval' : 'Median filtering of the image or volume. Unlike a low pass filter this filters removes any noise spikes in the image or volume. Typical values are less than 5. The bigger the number the more information is thrown away.',
		'binval' : 'Binning of the image.  This takes any integer value, but powers of 2 are recommended. Binning quickly shrinks the image to help make the processing faster.  Typically you want to use 4 or 8 for particle picking.',
		'ace2bin' : 'Binning of the image.  This takes any integer value, but powers of 2 are recommended. Typical is 1 or 2 for ace2 estimation if the pixel size is ~1.0-2.0 &Aring;ngstr&ouml;ms. This binning in real space has an effect of zooming in on the power spectra. Bins of greater than 2 can cause clipping of outer Thon rings in close to focus images and errors in the CTF estimation, but this handled by the confidence value',
		'partbin' : 'Binning of the particle images. This quickly shrinks the image to help make the processing faster.',
		'clipdiam' : 'Rescale the unbinned boxsize.',
		'stackbin' : 'Amount to bin the particles by after they are extracted from each image.  Note that this binning occurs AFTER boxing from the raw image, so that your box size must correspond to the UNBINNED micrograph.  Usually bin by 2.',
		'coranbin' : 'Binning of the particle images. The speed of coran goes as the number of pixels cubed. So bin by 2 and it goes 64 times faster, bin by 3 and it goes 729 times faster.',
		'defocpair' : 'Select this box if you are collecting defocal pairs.  This feature takes both of the en and ef images and aligns them, so you can use makestack later.',
		'maxsize' : 'Max size multiple of the particle peak.  When the peak is found in the thresholded image it has a size in pixels.  If that size is greater than (max peak area mult)*particle diameter, then the peak is rejected. The default value is 1.0, which implies that the correlation peak is the same size as the mask, which is very large. To reduce the amount of crud picked in the images, you can lower this value. 0.05 works well for templates and 0.2 for DoG peaks.',
		'overlapmult' : 'The overlap multiple specifies the minimum distance allowed between two peaks.  If two peaks are closer than overlapmult*particle diameter, then only the larger of the two peaks is retained.',
		'pixlimit' : 'Limit the values of the pixels to within this number of standard deviations from the mean.  0.0 turns this feature off.',
		'kfactor' : 'The k-factor for dogpicker defines the sloppiness in diameter of the picked particles.  A k-factor of 1.00001 gives only the exact diameter (1.0 is not allowed), but a k-factor of 5.0 will pick a wide range of sizes.  Cannot be used with multi-scale dogpicker: numslices or sizerange',
		'numslices' : 'Defines the number of different sizes (or slices) to break up the size range into for separating particles of different size.',
		'sizerange' : 'Defines the range of sizes for separating particles of different size. Particles will be picked as <i>diameter +/- sizerange</i>, so the <i>sizerange</i> is like the standard deviation of the particle size, where the diameter is defined at the top',
		'invert' : 'Mathematical pickers (e.g., DoG picker) always pick white particles. Also, if the density of your template is opposite the density of your micrographs, use this flag.',
		'nojpegs' : 'Do NOT write out the summary jpegs for image assessor.',
		'picklabel' : 'Give meaningful label to the particle selected.  This only works on particles defined by their center, not traced objects.',
		'edgethresh' : 'The threshold set for edge detection.  ACE searches a range of values to determine a good threshold, but this value should be increased if there are more edges in the power spectrum than in the ring.  Decrease if no edges are detected.',
		'pfact' : 'Location of the upper cutoff frequency.  If thon rings extend beyond the power spectrum cutoff frequency, increase this value.  In cases of low signal to noise ratio with few thon rings, decrease this value.',
		'drange' : 'Use in cases where the signal to noise ratio is so high that the edge detection is incorrect.',
		'resamplefr': 'Sets the sampling size of the CTF.  At high defoci or at higher magnifications, the first thon rings may be so close to the origin that they are not processed by ACE.  In these cases raise the resampling value (2.0 works well in these cases).<br/><br/><TABLE><TR><TD COLSPAN=2>typical values for defocus/apix</TD></TR><TR><TD>0.5</TD><TD>1.2</TD></TR><TR><TD>1.0</TD><TD>1.5</TD></TR><TR><TD>1.5</TD><TD>1.6</TD></TR><TR><TD>2.0</TD><TD>1.8</TD></TR><TR><TD>3.0</TD><TD>2.2</TD></TR><TR><TD>4.0</TD><TD>2.7</TD></TR></TABLE><br/>For example, with defocus = 2.0 (-2.0x10<SUP>-6</SUP> m) and apix (&Aring;/pixel) = 1.63<br/>then defocus/apix = 1.22 and you should use resamplefr=1.6<br/>(as long as its close it should work.)',
		'overlap' : 'During processing, micrographs are cut into a series of smaller images and averaged together to increase the signal to noise ratio.  This value (n) will result in successive images having an overlap of (1-n)*field size.  Increase in cases of very low signal to noise ratio.',
		'field' : 'During processing, micrographs are cut into a series of smaller images and averaged together to increase the signal to noise ratio.  This value refers to the width (in pixels) of the cropped images.',
		'fieldsize' : 'During processing, micrographs are cut into a series of smaller images and averaged together to increase the signal to noise ratio.  This value refers to the width (in pixels) of the cropped images.',
		'resmin' : 'This is the lowest resolution (in Angstroms) that will be considered when fitting the CTF.',
		'resmax' : 'This is the highest resolution (in Angstroms) that will be considered when fitting the CTF.',
		'defstep' : 'Step size (in Angstroms) used when searching for the defocus.',
		'ctffindBestdb' : 'Use best amplitude contrast, resolution max, and astigmatism difference from database',		
		'numstep' : 'Number of steps to search, really defines the search area as defocus_step times num_steps.',
		'dast' : 'Expected amount of astigmatism in Angstrom. This is an additional parameter that was added to CARD 4 to restrain the amount of astigmatism in the CTF fit. This makes the fitting procedure more robust, especially in cases where the Thon rings are not easily visible',
		'cs' : 'Spherical abberation, abbreviated as Cs, it corresponds to the imperfection produced by the lenses in the electron microscope.  This is a physical property of a microscope and does not change.',
		'hpmask': 'Optional filter that sets all signal below a low frequency set point to zero, and all signal above a high frequency set point passed at 100%.  Signal between these two points is linearly ramped.  This can be used mask out strong signal from particle structure that can cause the algorithm to fail.', 
		'hpzero': 'signal set to zero below this frequency. For example, use 60 &Aring;ngstr&ouml;m for negatively-stained GroEL where the particle structure signal drops off',
		'hpone': 'signal passed at 100% above this frequency. For example, use 30 &Aring;ngstr&ouml;m for negatively-stained GroEL where ctf dominates the signal.',
		'edge1': 'Canny edge parameters Blur Sigma. The value is used to Gaussian blur the power spectra before edge detection. Typical values are 6, 10 or 12. ',
		'edge2': 'Canny edge parameters Edge Treshold (0.0-1.0). The lower the number, the more edges are found. Typical values are 0.001 to 0.1. If using rotational blur, increase this value to about 0.1.',
		'rotblur': 'Rotational blur of power spectra before finding the edges. This is helpful for images with low constrast CTF. Typical value is 5-10 degrees. The larger the number, the slower the calculation. Increase Edge Treshold is using this feature',
		'pdiam' : 'For template correlator this is used to mask out the particle from the image.  Otherwise, this will be the diameter used by the leginon image viewer for displaying picked particles -	it will NOT affect the size of the boxed particles later on, this is only for display purposes.  ',
		'crudpdiam' : 'When finding aggregates or looking for carbon edge. particle diameter is used as template for convolution. Not required for crud mask type. ',
		'crudmindiam' : 'Minimal mask region size. The partical diameter will be used if not specified',
		'crudminthresh' : 'Lower limit in gradient amplitude for Canny edge detection.<BR>This should be between 0.0 to 1.0 and should be smaller than that of the high limit',
		'crudmaxthresh' : 'Threshold for Canny edge detector to consider as an edge in the gradient amplitude map.<BR>  The edge is then extended continuously from such places until the gradient falls below the Low threshold<BR>The value should be between 0.0 to 1.0 and should be close to 1.0',
		'blur' : 'Gaussian filter bluring used for producing the gradient amplitude map<BR> 1.0=no bluring',
		'crudstd' : 'Threshold to eliminate false positive regions that picks up the background<BR> The region will be removed from the final result if the intensity standard deviation in the region is below the specified number of standard deviation of the map<BR> Leave it blank or as 0.0 if not considered',
		'convolve' : 'Aggregate finding uses this threshold in determining the cutoff of the particle size convoluted edge map<BR> This value is not applicatable if use other mask types<BR> Leave it blank or as 0.0 if not considered',
		'masktype' : 'Crud: Selexon crudfinder.  Canny edge detector and Convex Hull is used<BR>  Edge: Hole Edge detection using region finder in libCV so that the region can be concave.<BR>  Aggr: Aggregate finding by convoluting Sobel edge with a disk of the particle size.',
		'tracerun' : 'Object tracing run to be analyzed',
		'stackname' : 'name of the output stack, usually start.*',
		'stackdescr' : 'brief description attributed to this stack',
		'stackparticles' : 'Particle selection run providing the coordinates that will be used for extracting the particles',
		'stackparticlelabels' : 'Select a label to make a stack with labeled particles',
		'stackparticles2' : 'Existing stack providing the coordinates that will be used for extracting the particles',
		'stackinv' : 'Density of your extracted particles will be inverted.  Three dimensional reconstruction packages usually require light density on a dark background.  2-D alignment algorithms usually do not.',
		'stacknorm' : 'normalize each of the particle images',
		'writefile' : 'If unchecked, a virtual stack is created without generating an actual stack file. Stack can be still be processed in Appion, and stack file can be generated later if necessary',
		'ctfcorrect' : 'CTF correct the particles. When off particles are untouched, when on particles with have their CTF corrected as determined by the method below.',
		'ctfcorrectmeth' : 'CTF correct the particles, there are currently four methods available, you can CTF correct the whole image and then box the particles or CTF correct the particles after boxing them. A Wiener filter improves the quality of the particles by both phase flipping and adjusting the amplitudes.',
		'ctfres' : 'Only micrographs with a CTF resolutions values in the range specified will be used in the creation of the stack. The minimum value is rarely used.',
		'ctfsort' : 'This value determines how the best CTF values are found from multiple runs of ctf estimation.',
		'phaseflip' : 'Check this box if you wish to use the defocus value determined by ACE to flip the phases of the particle images (flipping is performed on each individual particle).  The ACE value with the highest confidence will be used.  Note: Amplitudes are NOT affected.',
		'ctffindonly' : 'Only CTF values estimated using CTFFIND or CTFTILT will be used for correcting the CTF',
		'aceconf' : 'Only micrographs with a CTF confidence equal to or above the value specified will be used in the creation of the stack.  Values range from 0 (lowest confidence) to 1 (greatest confidence).  Empirically a confidence value of 0.8 or greater for ACE signifies a good estimation of the defocus.',
		'checkimage' : 'This option specifies which images to use for particle extraction.<br /><br /><b><i>Non-rejected: </b></i>images that are specified as "Hidden" in the Leginon Image Viewers or selected to "Reject" using the image assessor will NOT be used for stack creation.  This means that any uninspected images will be processed.<br /><br /><b><i>Best:</i></b> only images that are specified as "Exemplar" in the Leginon Image Viewers or were selected to "Keep" using the image assessor will be used for stack creation.<br /><br /><b><i>All: </i></b>all images will be used, regardless of their status.',
		'boxsize' : 'The size (width & height) of the square area that will be extracted from each raw micrograph, using each particle coordinate as its center.  Generally the box size should be at least 1.5 times greater than the diameter of your particle, an even number, and (if possible) has a small prime factor.<br /> NOTE: This value is in pixels, not &Aring;ngstr&ouml;ms!',
		'stackdfpair' : 'If you picked your particles on far-from focus images, select this to use the shift information to box out the particles from the close-to focus images',
		'stacklim' : 'Makestack will continue processing micrographs and checking the stack size.  Once the number of particles matches or exceeds this limit, it will stop processing images.  Since all particles from a micrograph are added to the stack before checking, the final stack rarely has exactly the number of particles specified by the limit.  Leave blank to process all the micrographs.',
		'maskrad' : 'Radius of external mask (in &Aring;ngstr&ouml;ms)',
		'force' : 'Insert new entries without checking if corresponding data already exists',
		// CTF find
		'medium' : 'Choose Carbon if most of your image includes carbon, choose Ice if most of your image does not include carbon.',

		// helical boxmask params
		'boxmaskcheck' : 'Create a rectangular mask at the center of helical particles',
		'boxmask' : 'Distance from the particle center to the outermost portion of the helix to mask (in &Aring;ngstr&ouml;ms)',
		'iboxmask' : 'Distance from the particle center to the innermost portion to mask (in &Aring;ngstr&ouml;ms)',
		'boxlen' : 'Total length along to the helix to keep (in &Aring;ngstr&ouml;ms)',
		'falloff' : 'Soft-edge falloff a the mask edge ((in &Aring;ngstr&ouml;ms)',

		'numpart' : 'Number of particles to use',
		'numref' : 'Number of references to generate in an ab initio manner. This will depend on the amount of preferred orientation within your data. A good range to aim for could be ~100-1000 particles per reference, but because ML algorithms are computationally intense, this may not always be feasible, depending on the size of your dataset. Defaults to square root of number of particles',
		'numrefcl2d' : 'Number of references to create in 2D alignment. CL2D performs a sequential binary separation of classes. For example, if you specify 100 classes, CL2D will produce 2, 4, 8, 16, 32, 64, and 100 classes.',
		'image2imagedistance' : 'How to measure the distance between two images. Correlation is perfectly adapted to Gaussian noise while correntropy is better suited to non-gaussian distributions',
		'image2clusterdistance' : 'Minimum distance assigns an image to the cluster with minimum distance as measured by image to image distance. Intracluster distance assigns an image to the cluster where the image is less rare.',
		'dontAlign' : 'Dont produced an aligned stack',
		'tau2fudge' : 'The regularisation parameter determines the relative weight between the experimental data and the prior. Bayes law dictates it should be 1, but sometimes better results are obtained using slightly higher values. 2D classifications seem to go better with values of 1-2.',
		'use_mirrors' : 'Align both regular particles and their mirror image',
		'mlsavemem' : 'Save memory by reducing the number of xy shift for the particles for each round.',
		'partcutoff' : 'The automated particle selection functions assign each paticle a correlation value - here you set a range of correlation values to use.  Correlation values that are very high or low may be contamination of noise on the micrograph.',
		'factorlist' : 'These images represent a set of eigenvectors, certain traits of the particles should be presented by each eigenvector.  Choosing an image below will use its eigenvectors as a basis for averaging the particles.',
		'numfactor' : 'Number of eigenvectors to calculate, certain traits of the particles should be presented by each eigenvector.  Choosing an image below will use its eigenvectors as a basis for averaging the particles.',
		'dendrogram' : 'Graphical representation of the clusters produced by the clustering algorithm.',
		'numclass' : 'Particle stack will be aligned according to the selected eigen images and averaged into this number of classes.',
		'refine2dnumclass' : 'Number of classes to generate (though some may be discarded). Typically less than the number of particles divided by 10 or the square root of the number of particles',
		'refine2dnumiter' : 'Number of iterations. 10 is almost always sufficient. For less noisy data 3-4 may be enough.',
		'apix' : 'Pixel size of the acquired image in &Aring;ngstr&ouml;ms.  Conversion: (1 nm = 10 &Aring;ngstr&ouml;ms)',
		'tiltseries': 'Select the tilt series number in the current session that corresponds to the tomogram to be processed.',
		'tiltseries_upload': 'Select the tilt series number in the current session that corresponds to the tomogram to be uploaded.',
		'tiltseriestwo': 'Select the 2nd tilt series if the tomogram is made from a combination of the two.',
		'session': 'Session name as created at leginon startup on the date of image capture.',
		'extrabin': 'additional binning used to reconstruct the tomogram relative to that of the tilt series images.',
		'tomorunname' : 'Specifies the name associated with the full tomogram processing results unique to the specified tilt series and parameters.',
		'tomosamplethickness' : 'Estimated thickness of the sample in nanometer to be reconstructed into tomogram.',
		'tomothickness' : 'Thickness of the tomogram to be reconstructed, count by pixelsof the tilt image before tomogram binning',
		'tomoexclude' : 'tilt images to be excluded from full tomogram making, separated by commas.  Images are identified by sorted tilt number as in the alignment graph aboveand counting starts from 1.  For example: Entering 1,2 will exclude the two images of the most negative tilts',
		'subtomorunname' : 'Specifies the name associated with the sub tomogram boxing. Default is "subtomo_pick"+pickrun Id or "subtomo_stack"+stack Id. New attempt to use the same run name from the same full tomogram will append to the old results.',
		'volume': 'a bounded subvolume (often a specific structure) of the full tomogram.  Leave it blank if uploading full tomogram for boxing later',
		'tomoregiontype': 'subtomogram center can be obtained from a particle selection run or a stack/substack of the particles. However, only subtomograms boxed from aligned or clustered substack can be used for averaging.',
		'tomostack': 'a stack of particles specifying the subvolume extraction center and the orientation if aligned.',
		'avgtomorunname' : 'Specifies the name associated with the subtomogram averaging.',
		'tomobox': 'a box dimension to define the subvolume in pixels of the tilt series images. x is column, y is row. For the purpose of subtomogram averaging, z should be large enough to bound all possible particle.',
		'subtomobin': 'binning to the cut subvolumes before saving',
		'zoffset': 'Offset in z-direction from the center of and in pixel of the full tomogram, normally 0',
		'tomoinvert': 'Invert the density in making the subtomogram.  The particles need to have positive density (white on black background) for subtomogram averaging later',
		'tomoorientation': 'Depending on the orientation of the image acquisition, definition of the tilt direction in the reconstruction package etc., the resulting tomogram may have different handness.  XYZ or XZY refers to the order of the axes in the mrc file to be uploaded where X and Y are the column and row of an untilted image in its series.  Right-handed means that a rotation from +X to +Y axis results in a counterclockwise rotation look from +Z direction towards the origin.  After upload, full tomograms is converted to XZY:right handed while subtomograms are converted to XYZ:right handed. If you collect data with Leginon on FEI tecnai and use all default transformation in eTOMO, you have full tomograms in XZY:left handed and subtomograms in XYZ:left handed.  This is because Leginon record images with the origin at top-left corner while IMOD/eTomo processes images assuming the origin at bottom-left corner.',
		'tomoalignrunname' : 'Specifies the name associated with the tilt series alignment processing results unique to the specified tilt series and parameters.',
		'tomoaligner' : 'Alignment can either be a single alignment run or a specific iteration of protomo refinement.  In general the last iteration should be selected',
		'tomoalignmethod' : 'Alignment methods available',
		'tomoleginonalign' : 'Using the tilt tracking result during Leginon data collection to align the tilt series. Shift-only',
		'protomoref' : 'reference image number in sorted tilt order. Protomo extend alignment incrementally from such a image. Default is the zero degree tilt image or the reference of the last refinement iteration. In protomo parameter file, this is called "imgref"',
		'protomocycle' : 'Multiple iterations of refinement is recommended for protomo projection alignment with decreasing sampling and increasing area of the image included',
		'protomosample' : 'Sample every x pixels in the alignment. Non-integer is acceptable but should not be smaller than 1.  Larger values result in faster and more error-tolerable run but lack the accuracy of the lower values.  The default is a reasonable next value based on that of the preceeding iteration. Known as "alismp" in the protomo parameter file',
		'protomoregion' : 'A region of each tilt image centered at the preceeding or reset alignment shift is cut out for projection alignment.  The larger the region, the slower and less error-tolerable the alignment but will be more accurate given good starting values.  The defaults are based on the preceeding iteration as the next reasonable value. The value is not allowed if the resulting region in pixels plus twice the maximum shift of the resetting iteration is larger than the image size. Protomo parameter "alibox" = this_value * 0.01 * alismp',
		'protomoreset': 'The new alignment iteration is a refinement of the alignment results from the preceeding iteration. If a large correction need to be made at the either end of the tilt series, protomo alignment may give false results.  Such false results can not be corrected by further iteration without resetting back to reasonable values and In the above rotation angle graph of the preceeding iteration, such failure appears as random or sudden jumps in alignment rotation angles.',
		'protomoresetrange': 'Use the number range to limit the images that take on those of the preceeding iteration whose rotation angle is shown in the graph. The default is the full range. The green box in the graph displays the current accepted alignment range.',
		'protomogoodcycle' : 'Reset the alignment shifts outside the image number range to those of the specified preceeding iteration. The rotation is reset to that of the closest accepted image in the the graphed iteration',
		'protomorepeat' : 'Repeat the last aligner iteration if the alignment got worse.  Try reducing the area of alignment, with higher binning, and/or reset more of the high tilt parameters to earlier, working aligner iteration.',
		'mask' : 'Radius of external mask (in pixels)',
		'premask' : 'Input stack particles are masked prior to alignment',
		'maxshift' : 'Maximum distance a particle can be translated',
		'includeClass' : 'Classes from classification that will be included',
		'excludeClass' : 'Classes from classification that will be excluded',
		'excludeClassum' : 'Class Average from classification that will be excluded (note: only class averages, and not particles, are affected)',
		'includeClassum' : 'Class Average from classification that will be included (note: only class averages, and not particles, are affected)',
		'templatetype' : 'The type of template stack that will be uploaded: You can either upload a stack of class averages or a stack of forward projections',
		'oldtemplatename' : 'The full path and name (ending in .img / .hed) of the template stack that you want to upload to the database',
		'commonlineemanprog' : 'EMAN common line program for initial model generation',
		'imask' : 'Inside mask used to exclude inside regions',
		'lp' : 'Lowpass filter radius in Fourier pixels',
		'partnum' : 'Number of particles to use for each view.  This number should be at least 10-20, and at most ~10% of the total particle data set.  50-100 is good for typical data sets of 2000 or more particles. Leave BLANK for auto-fill',
		'csym' : 'imposes C-fold symmetry on the model. Note: You CANNOT specify C1 here. Please use the asymmetric model creation on the previous page for C1 symmetry. ',
		'rounds' : 'Rounds of Euler angle determination to use (2-5)',
		'pdbid' : 'ID for an experimentally determined biological molecule from the RCSB Protein Data Bank (www.rcsb.org)',
		'emdbid' : 'ID for an experimentally determined electron density map from the EM Data Bank',
		'biolunit' : 'Use the functional / oligomeric form of the structure for model creation',
		'viper2eman' : 'Convert VIPER to EMAN orientation for icosahedral viruses',
		'eulers' : 'Eulers assigned to the particles for this iteration will be used when creating class averages.',
		'sigma' : 'Standard deviation multiplier to determine the quality of particle to be used.  Setting this to 0, only particles that have a quality factor equal to or greater than the mean quality factor will be used in making the class averages.  A larger sigma will result in fewer particles, but of higher \"quality\".  If no value is specified, all particles will be used.',
		'keepavg' : 'Any particles that have a median euler jump greater than this value will not be used in the class averages',
		'eotest' : 'even and odd class averages will be created in addition to the new class averages, to be used for an even/odd test',
		'angleinc' : 'angular increment for alignment, the smaller the increment the longer it takes to run, default 5, rough run use 10 degrees',
		'fastmode' : 'fast mode is a setting in Xmipp that reduces the time for an iteration after the first round, if off all iterations take a long time, if on then if the the iteration time will drop 90% after the first round, e.g.  60 min after round 1 to 4 min for each iteration after',
		'noisedistribution' : 'Determines which noise distribution model to use during alignment. Options are Gaussian and Student\'s  T distrubtions',
		'maxiter' : 'maximum number of iterations to perform without converging before giving up',
		'xmippmaxiter' : 'Xmipp uses a convergence criteria to stop, but it also has a maximum number of iterations it will perform without converging before it gives up',
		'xmippstacknorm' : 'Normalize particle images using Xmipp. Removes ramp density by subtracting a least-squares plane through the background pixels, and replaces pixels above and below the specified sigma threshold with random values within the threshold range.',
		'stack' : 'Input particles to be classified',
		'planereg' : 'Fit a 2D plane to the image and subtract, similar to a high pass filter',
		'peaktype' : 'The determines how the center of the particle is found. Default for leginon hole finder is center of mass, but you may get better results with maximum. WARNING: Christopher needs to update pyami on cluster for maximum to work, so use center of mass',
		'doubles' : 'Each particle must be picked twice. Picked by more than one template or DoG slice',
		'griddim' : 'Self-organizing maps create a large 2D array of images, each image is a class average. E.g., 4x3 grid gives 12 class averages',
		'uploadproject' : 'Project to which the uploading session belongs to.  If the session exists, the project must match correctly',
		'uploadsession' : 'Images can be uploaded to an existing session or a new one.  Only images with unique names can be uploaded into the same session. In some cases the session name is determined by the upload script',
		'uploadtype' : 'Images uploaded in groups will know their members during processing.  For example, particle picked on one of the defocal series can be transfered to others in the same group', 
		'host' : 'Instrument host as defined in Leginon where particular combinations of scope and camera are available',
		'scope' : 'Type of mircoscope used in data collection',
		'camera' : 'Type of camera used in data collection. Gatan refers to any models of Gatan camera interfaced through Gatan Digital Micrograph software.  Use Film Scanner type for arbitrary dimension and pixel size image upload',
		'images_in_group' : 'Number of images per tilt series or defocal group.  Enter 1 or leave it blank if not a tilt series or defocal group. This will divide all images to be upload in groups of the defined number.  It is therefore not advisable to mix images belonging to a tilt series with ones that are not in the same upload. if the number is larger than 1, Field 8 (stage alpha tilt) must exist in the information file',
		'batchfile' : 'Enter the full path to a text file that contains information of each mrc image to be uploaded. The file has no title line.  Each line has the following fields of the image separated by tabs (examples are shown in []): <p>(1) complete image path ended with extension mrc; [/yourhome/yourimage.mrc]<p>(2) pixel size in meters; [1.5e-10]<p>(3) binning in x; [1]<p>(4) binning in y; [1]<p>(5) nominal scope magnification; [50000]<p>(6) intended defocus in meters, [-2e-6]<p>(7) high tension in volts; [200000]<p>(8) (optional) stage alpha tilt in degrees if loading tilt group.[55.0] See help on number of image pertilt series.<p>Note that (3) and (4) are only relavent for CCD camera, use 1 for scanned film with arbitrary scan step.',
		'batchcheck' : 'By default the existence and the number of text fields are checked before proceeding.  However, the checking process requires read privilege into your file system not as your computer login but as a user in a group specified in your web server configuration.  If read privilege is not set, you can by-pass the process by unchecking this.',
		'azimuth' : 'Tilt azimuth relative to the y-axis in degrees.  (ex. 0).',
		'tiltlist' : 'List the nominal tilt angles in the tilt series in degrees, separated by commas.  (ex. 0,10,20,30).',
		'doselist' : 'Optional: List the dose per tilt-image in e-/Å^2, separated by commas.  (ex. 1.2,1.2,1.1,1.1).',
		'defociilist' : 'List the nominal defocii in the defocal series in microns, separated by commas.  (ex. -1,-2).',
		'rctmask' : 'SPIDER mask radius around the particle.  The maximum is (boxsize/2 - 2) pixels.',
		'rctcenter' : 'In RCT, the particle Euler angles are fixed, but the particles are not centered. Through an interative process the volume is projected in the direction of the particle and cross-correlated, then the particle is shifted to its correct location.',
		'rctpartlp' : 'low-pass filter the tilted particles prior to reconstructing (0=off, do not low-pass filter particles)',
		'rctparthp' : 'high-pass filter the tilted particles prior to reconstructing (0=off, do not high-pass filter particles)',
		'rctvollp' : 'low-pass filter of the volume after reconstructing',
		'snapfilter' : 'Fixed low pass filter used in rendering volume snapshot, leave it blank to use the FSC 0.5 result for each iteration',
		'snapzoom' : 'Zoom in the volume data to see the volume better for a large boxsize',
		'roi' : 'Define inner and outher radii used to compute rotational spectra (power spectrun of Fourier transform in polar coordinates)',
		'spectrainnerradius' : 'Select the radius at which the symmetry of interest began to appear',
		'spectraouterradius' : 'Select the radius at which the symmetry of interest disappear',
		'smoothnessfactor'   : 'Defines how simmilar two output spectra should be. This is called regularization and prevent the algorithm from divergence. In order to optain an optimal smoothnes factor an optimization is done between the initial and final regularization parameters',
		'initregulfact'      : 'Initial smoothness factor (Default = 1000)' ,   
		'finalregulfact'     : 'Final smoothness factor (Default = 200)'  ,  
		'incrementregulfact' : 'Increment smoothness factor (Default = 5)' ,   
		'symmetryrange'      : 'Range of symmetries that should be analyzed',   
		'spectralowharmonic'       : 'Smaller symmetry that should be analyzed (default =1)',   
		'spectrahighharmonic'      : 'Higher  symmetry that should be analyzed (default = 15)',   
		'niterrec' : 'Number of iterations for reconstruction (Default = 15)',   
		'maskfile' : 'Filename of a mask (0=outside particle; 1=inside particle)',   
		'innerradius' : 'Inner radius for alignment (in pixels)',   
		'outerradius' : 'Outer radius for alignment (in pixels)',   
		'angularsteps' : 'Angular distance (in degrees) between neighboring projection  points. You must specify this option for each iteration. This can be done by a sequence of numbers (for instance, "8 8 2 2" specifies 4 iterations, the first two set the value to 8 and the last two to 2. An alternative compact notation  is ("2x8 2x0", i.e., 2 iterations with value 8, and 2 with value 2). Note: if there are less values than iterations the last value is reused. Note: if there are more values than iterations the extra value are ignored',   
		'maxangularchange' : 'Maximum change in rot & tilt  (in +/- degrees). You must specify this option for each iteration. This can be done by a sequence of numbers (for instance, "1000 1000 10 10 " specifies 4 iterations, the first two set the value to 1000 (no restriction) and the last two to 10degrees. An alternative compact notation is ("2x1000 2x10", i.e., 2 iterations with value 1000, and 2 with value 10). Note: if there are less values than iterations the last value is reused. Note: if there are more values than iterations the extra value are ignored',
		'maxchangeoffset' : 'Maximum allowed change in shift in the 3D+2D searches (in +/- pixels). Shifts larger than this value will be reset to (0,0) You must specify this option for each iteration.  This can be done by a sequence of numbers (for instance, "1000 1000 10 10 "  specifies 4 iterations, the first two set the value to 1000 (no restriction) and the last two to 10degrees. An alternative compact notation  is ("2x1000 2x10", i.e., 2 iterations with value 1000, and 2 with value 10). Note: if there are less values than iterations the last value is reused. Note: if there are more values than iterations the extra value are ignored',
		'search5dshift' : 'Give search range from the image center for 5D searches (in +/- pixels). Values larger than 0 will results in 5D searches (which may be CPU-intensive) Give 0 for conventional 3D+2D searches.  Note that after the 5D search, for the optimal angles always  a 2D exhaustive search is performed anyway (making it ~5D+2D) Provide a sequence of numbers (for instance, "5 5 3 0" specifies 4 iterations, the first two set the value to 5, then one with 3, resp 0 pixels. An alternative compact notation is ("3x5 2x3 0", i.e., 3 iterations with value 5, and 2 with value 3 and the rest with 0). Note: if there are less values than iterations the last value is reused Note: if there are more values than iterations the extra value are ignored',
		'search5dstep' : 'Provide a sequence of numbers (for instance, "2 2 1 1" specifies 4 iterations, the first two set the value to 2, then two with 1 pixel. An alternative compact notation is ("2x2 2x1", i.e., 2 iterations with value 2, and 2 with value 1). Note: if there are less values than iterations the last value is reused Note: if there are more values than iterations the extra value are ignored',
		'symmetrygroup' : 'E.g., c1, c2, ..., d1, d2, ... For more groups see http://xmipp.cnb.csic.es/twiki/bin/view/Xmipp/Symmetry for a description of the symmetry groups format. If no symmetry is present, give c1',
		'discardpercentage' : 'Provide a sequence of numbers (for instance, "20 20 10 10" specifies 4 iterations, the first two set the value to 20%, then two with 10% An alternative compact notation would be ("2x20 2x10"). Note: if there are less values than iterations the last value is reused Note: if there are more values than iterations the extra value are ignored Set to zero to prevent discarding any images',
		'reconstructionmethod' : 'Provide a sequence of methods (fourier, wbp, art). See http://xmipp.cnb.csic.es/twiki/bin/view/Xmipp/Wbp and http://xmipp.cnb.csic.es/twiki/bin/view/Xmipp/Mpi_wbp and http://xmipp.cnb.csic.es/twiki/bin/view/Xmipp/Art http://xmipp.cnb.csic.es/twiki/bin/view/Xmipp/Fourier http://xmipp.cnb.csic.es/twiki/bin/view/Xmipp/Mpi_fourier for details',
		'artlambda' : 'IMPORTANT: you must specify a value of lambda for each iteration even if art has not been selected. IMPORTANT: NOte that we are using the WLS version of ART that  uses geater lambdas than the plain art. See http://xmipp.cnb.csic.es/twiki/bin/view/Xmipp/Art for details You must specify this option for each iteration.  This can be done by a sequence of numbers (for instance, ".1 .1 .3 .3"  specifies 4 iterations, the first two set the value to 0.1  no restriction) and the last  two to .3. An alternative compact notation  is ("2x.1 2x.3"). Note: if there are less values than iterations the last value is reused Note: if there are more values than iterations the extra value are ignored',
		'fouriermaxfrequencyofinterest' : 'This number os only used in the first iteration.  From then on, it will be set to resolution computed in the resolution section',
		'docomputeresolution' : '0=Do not compute resolution; 1=Compute resolution (FSC)',
		'dolowpassfilter' : '0=Do not low pass filter; 1=Low pass filter',
		'dontusefscforfilter' : 'If set to false, the volume will be filtered at a frecuency equal to the  resolution computed with a FSC=0.5 threshold, possibly  plus a constant provided by the user in the next input box.  If set to true, then the filtration will be made at the constant  value provided by the user in the next box (in digital frequency, i.e. pixel-1: minimum 0, maximum 0.5) ',
		'constanttoaddtofiltration' : 'The meaning of this field depends on the previous flag. If set to true, then the volume will be filtered at a frecuency equal to the  resolution computed with resolution_fsc (FSC=0.5) plus the value  provided in this field  If set to false, the volume will be filtered at the resolution provided in this field  This value is in digital frequency, or pixel^-1: minimum 0, maximum 0.5 You can specify this option for each iteration.  This can be done by a sequence of numbers (for instance, ".15 .15 .1 .1"  specifies 4 iterations, the first two set the constant to .15 and the last two to 0.1. An alternative compact notation  is ("2x.15 2x0.1", i.e., 4 iterations with value 0.15, and three with value .1). Note: if there are less values than iterations the last value is reused Note: if there are more values than iterations the extra value are ignored',
		'particlefiles' : 'i.e. /home/username/files/*.box<br><br>NOTE: box files must have the SAME name as the corresponding mrc files in the database.<br>the box file for <br><b>0059ma.mrc</b><br> must be named<br><b>0059ma.box</b>',
		'particlescaling' : 'If particles were selected from binned images, enter the binning factor here, otherwise leave blank.  For example, if images were binned by a factor of 4 for particle selection, enter 4 here',
		'imgpath' : 'directory containing the images to be imported (i.e. /home/username/experiment/date).<br><br>Note: Do not include bad characters in your tilt image filenames, such as [ or } or . or , etc.',
		'fileformat' : 'format of images to be imported',
		'imgbin' : 'Image binning',
		'magnification' : 'Nominal instrument magnification of images (i.e. 50000)',
		'defocus' : 'Nominal defocus of images in microns (i.e. -1.5)',
		'kev' : 'High tension of the microscope in kilovolts (i.e. 120)',
		'alonghelices' : 'Place points along a helix, you will define stepsize and overlap when you make the stack',
		'helicalstep' : 'Distance between picks on helical filaments that will be automatically inserted with Helical Insert. Leave blank if you are not picking filaments.',
		'stackfile' : 'The full path of stack, including filename. Stacks must be in IMAGIC format (i.e. filename ending in .img/.hed)',
		'serialem_stack' : 'Full file path to a .st/.mrc tilt-series stack.<br><br>Note: The filename will be cleaned up by replacing illegal characters like [ and ) and { and . etc. with underscores (type: string).',
		'serialem_mdoc' : 'Full file path to a SerialEM-formatted mdoc file (type: string).',
		'serialem_dir' : 'Full path to a directory containing one or more sets of .st/.mrc tilt-series stacks and SerialEM-formatted mdoc files that have not already been uploaded to this session.<br><br>The .mdoc file needs to have the name of the stack, but ending in .mdoc; e.g. stack.st.mdoc or stack.mdoc.<br><br>Note: The filenames will be cleaned up by replacing illegal characters like [ and ) and { and . etc. with underscores (type: string).',
		'tomo4_stack' : 'Full file path to a .st/.mrc tilt-series stack.<br><br>Note: The filename will be cleaned up by replacing illegal characters like [ and ) and { and . etc. with underscores (type: string).',
		'tomo4_txt' : 'Full file path to a TOMO4-formatted txt file (type: string).',
		'tomo4_rawtlt' : 'Full file path to a TOMO4-formatted rawtlt file (type: string).',
		'tomo4_dir' : 'Full path to a directory containing one or more sets of .st/.mrc tilt-series stacks and TOMO4-formatted txt and rawtlt files that have not already been uploaded to this session.<br><br>The .txt and .rawtlt files need to have the name of the stack either with or without _orig, but ending in .txt/.rawtlt; e.g. stack.st.txt/.rawtlt or stack.txt/.rawtlt.<br><br>Note: The filenames will be cleaned up by replacing illegal characters like [ and ) and { and . etc. with underscores (type: string).',
		'voltage' : 'TEM voltage in keV (type: int).',
		'per_image_dose' : 'Dose for each tilt image (type: float).',

/******* Helical Image Processing ********/
		'mandir' : 'The directory containing the mandatory input files for Phoelix.  These include llbo.sa, range.sa, strong.sa, cutfit1.dek, cutfit2.dek, cutfit3.dek, chop1.dek, chop2.dek, and template.  If you do not have these files, select "Run PreHIP" option and they will be generated in this directory. See HIP wikipages for more information.',		
		'replen' : 'The 360 degree repeat distance along the filament, in &Aring;ngstr&ouml;ms. Calcuated by the distance to the first layer line.',
		'diam' : 'The approximate outer diameter of the filament, in &Aring;ngstr&ouml;ms',
		'diaminner' : 'The approximate inner diameter of the filament, in &Aring;ngstr&ouml;ms',
		'xlngth' : 'Desired length of the filament segments, usually a certain number of helical repeats, in pixels.  Should be the same as your stack box size.',
		'subunits' : 'Number of subunits in one helical repeat. Determined by calculating Helical Repeat/Rise or finding the Layer Line with a J0 intercept',
		'ovrlp' : 'Percent overlap when cutting the filament into segments. Setting this to 0% will box out filaments with no overlap between them',
		'yht' : 'Desired height for the filament box before alignments, usually the power of 2 value that is at least twice the diameter size, in pixels',
		'yht2' : 'Height of the filament box after alignments, usually the power of 2 value greater than the filament diameter, in pixels',
		'padval' : 'Value to pad the filament box to during alignments, usually the power of 2 value greater than the filament length/box size',
		'filval' : 'Lowpass filter value for filament segments used during alignments to find filament edges. 200 seems to work well, but should be tested before processing the full stack',
		'rescut' : 'Maximum phase residual for post averaging.  Any files with phase residual above this cutoff will not be included in the final average, map, overplot, etc.',
		'prehip' : 'If this is your first time running HIP on this data, select this option and run preHIP.py command line to set up mandatory input files',
		'conchg' : 'If your filament stack has black on white density, the final reconstruction will need a contrast change',
		'risecheck' : 'Use the rise distance and twist angle between protein subunits to determine selection rule and generate llbo.sa file',
		'llbocheck' : 'Use the layer line and Bessel Order for the (1,0) and (0,1) layer lines to determine selection rule and generate llbo.sa file.',
		'nfold' : 'Order of the symmetry axis. Default is 1-fold for no symmetry.',
		'maxll' : 'Maximum layer line to include in the llbo.sa file',
		'maxbo' : 'Maximum Bessel Order to include in the computation for llbo.sa',
		'helicalcheck' : 'If you used helical insert in Manual Picker, check this box to apply the estimated rotation angle and roughly align your helical segments vertically',
		'finealigncheck' : 'If you used helical insert in Manual Picker, check this box to apply the estimated rotation angle and calculate a fine rotation angle in fourier space, which will align your helical segments vertically in a single interpolation. Warning: This process is slow!',
		'resol' : 'All data up to this resolution will be amplitude scaled',
		'ampx' : 'Low resolution data will be scaled to this factor. Ex. If you want 15&Aring features scaled to 30%, Resolution cutoff = 15 and Amplitude scaling = 0.3',

/******* Topology Alignment ********/
		'startnumcls' : 'Number of classes to create in the first iteration. Each subsequent iteration will create fewer classes until the last iteration creates the ending number of classes',
		'endnumcls' : 'Number of classes to create in the last iteration',
		'topoliter' : 'Number of alignment iterations to perform',
		'itermult' : 'Multiplier for determining number of times data will be presented to the network. Number of particles in your stack will by multiplied by this value to determine # of iterations (default=10.0)',
		'learn' : 'Direct learning rate - fraction of the distance that a network node will move toward a presented data point. Higher values will make the learning more noisy but possibly explore more of "image space". Low values may prevent the network from accurately capturing your data. 0.01 suggested for cryo, higher for neg stain',
		'ilearn' : 'Indirect learning rate - fraction of the distance that a network node connected to the highest scoring node will move toward that data point. This effect gives the network interesting "cohesive" properties and helps with classification. Should be lower than direct rate (default = 0.0005)',
		'age' : 'Number of iterations an edge connecting two units can be unused before it is discarded. Higher values lead to a more connected network, but over-connecting can lead to inhibition of correct classification (i.e. 25)',
		'mramethod' : 'Processing package that will be used to perform the multi-reference alignment step for each iteration (IMAGIC seems to give better results for most datasets)',

/******* IMAGIC terms ********/

		'lpfilt' : 'This should be about 1/10 to 1/50 of the particle diameter, <I>e.g.</I> for a particle with diameter 150 &Aring;, a low pass of 5-10 &Aring; works pretty well.<BR/><BR/> NOTE: Imagic uses filtering values between 0 and 1.  This parameter will be converted in the python script to between 0-1 for use in Imagic.',
		'hpfilt' : 'This removes any darkness gradients in the image.  Typically you could disable this by setting it equal to zero, otherwise 400-600 works pretty well for IMAGIC.<BR/><BR/> NOTE: Imagic uses filtering values between 0 and 1.  This parameter will be converted in the python script to between 0-1 for use in Imagic.',	
		'transalign_iter' : 'Translational alignment in imagic has 3 basic steps.  1) A total sum of your images is created, 2) The total sum is rotationally averaged, 3) boxed particles are translationally (X-Y) aligned to the rotationally averaged sum.  In the imagic log file you will be able to see how the translational alignment converges with each iteration.  Generally this happens after ~5 iterations.',
		'box_size' : 'number of columns & number of rows for each particle in the stack (these should be equal)',
		'new_classums' : 'These classums will be created from your input stack so as to maximize the signal-to-noize ratio and IMAGIC\'s ability to assign correct euler angles to your images.  The goal is to represent the different views in your stack with new averages that have an improved SNR.  Choosing 25% of the particles in your stack has worked well in test runs.  For example, if your stack contains 400 particles, input 100 here.',
		'num_classaverages' : 'This value refers to the number of class averages that will be used in creating your initial 3d model (3d0).  It is obtained from the reclassification (SORTED BY MEMBERSHIP), and should be set equal to or slightly less than the the number of reclassified classums.  <BR/><BR/> For example, if you have 100 reclassified classums, and are satisfied with all but the 2 last ones, input 98 here.',
		'choose_projections' : 'This first step is the most crucial part of angular reconstitution.  For asymmetric objects, a minimum of 3 projections is required to determine the relationship between the tilt axes of the projections, and hence their euler angles.  These projections should NOT be related by a tilt around a single rotation axis.  For this reason, it is crucial to examine your class averages and decide which 3 belong to the 3 projection planes (i.e.  X-Y, X-Z, Y-Z).  You can, and probably should, play around with different variations, making sure to check the IMAGIC log file and choose  angles with the largest inter-euler difference and lowest error in angular reconstitution.  <BR/><BR/> Note: Imagic begins all projections with [1] instead of [0]',
		'copy' : 'Duplicate the parameters for this iteration',
		'itn' : 'Iteration Number',

		/*** THESE ARE OLD ***/
		'shift_orig' : 'Occasionally the motif of certain images can shifted out of the image field during alignment.  In this case we would lose the whole image information so the best thing then is just to do nothing.<BR/><BR/> Give a maximum radial shift beyond which you do not shift the image.  Either you can specify this in pixels directly, or as a fraction of the inner radius of the image.<BR/><BR/> Please note that the maximal shift, which you specify here, is the maximal shift for equivalent rotation/shift, which is the overall shift using the original (usually the pre-treated) images to create the output images.',
		'shift_this' : 'For this refinement you may want to specify a maximum shift, which is allowed to shift the images during this alignment.<BR/><BR/> Please note that this maximal shift is another value than the maximal shift during equivalent rotation/shift, which is the overall shift starting from the original (usually the pre-treated) images.<BR/><BR/>Give a maximum radial shift beyond which you do not shift the image.  Either you can specify this in pixels directly, or as a fraction of the inner radius of the image.',
		'samp_par' : 'To calculate the rotational cross-correlation the input images are transformed into cylindrical co-ordinates.  The horizontal size of these images, and hence the precision of the rotational alignment, depends on sampling parameter, which you have to specify here.  <BR/><BR/>Example: When the sampling parameter is chosen to have the value 4, this means that the number of sampling points along the tangential direction equals four times the radius of the input images.  Reasonable values lie between 4 and 12, with low precision being 4, high precision being 12.',
		'euler_ang_inc' : 'This angular increment is taken as an indication of how precisely you want to determine the euler angles of the input images.  The computing time required for 1 degree is FOUR times more than for 2 degrees, etc.  Can try, for example, 10 in first iterations, and 1-2 in the last iterations.',
		'num_classums' : 'The classums are sorted according to the error in angular reconstitution.  This value is the number of classums that you will use for iterative refinement.  Typically only a handful of classums have a very high error in angular reconstitution, so a good value may be 90-95% of your original classums.  Alternatively, all of them can be used as well.  <BR/><BR/><b> NOTE: ORIGINAL CLASS AVERAGES IN NOREF RUN ARE USED FOR REFINEMENT </b>',
		'keep_classes' : 'The classes that are produced are sorted according to the overall quality of the class. This value refers to the percentage of class averages that you want to keep',
		'keep_ordered' : 'The "ordered" class averages which have been assigned euler angles are sorted according to the error in angular reconstitution (an internal consistency measurement). This value refers to the percentage of best class averages that you want to keep',
		'ham_win' : '<font size=1.5>A hamming window can be incorporated into the 3d filter to suppress high frequency compontents that cause artefacts such as ringing, streaking, etc.  The effect of a hamming filter is to smooth off the edge of the filter rather than to have a sharp cut-off.  <BR/><BR/>For Hamming Window = 1.  No smooth edge, but rather a sharp cut-off at the nyquist frequency (effectively a circular mask).  <BR/><BR/>For Hamming Window = 0.8, you get a smooth transition from the value "1" at 0.6 times the Nyquist frequency to a value "0" at the Nyquist frequency.  <BR/><BR/>For Hamming Window = 0.5 you get a very smooth transition from the value "1" at the frequency origin, to a value "0" at the Nyquist frequency.  The amplitudes at half the Nyquist frequency will be damped to 0.5 of their original values.  <BR/><BR/>For Hamming Window = 0.2, you get a very smooth transition from the value "1" at the frequency origin, to a value "0" at 0.4 times the Nyquist frequency</size>',
		'obj_size' : 'The relative size of the object inside the 3D volume influences the shape of the exact filter.  A value of "1" means that the reconstructed object entirely fills the reconstruction volume.  A value of ".01" within a volume of 256*256*256 means the 3D object only fills the central 1% of the 3D volume.  If the object is small (relative to the volume size) this means that the width of the central section in Fourier space is relatively large, and that thus intersecting central sections (rather central "slabs") influence each other over a larger frequency range.  <BR/><BR/> Low values (e.g.  0.1) have given poor results in test simulations.  High values (e.g.  0.8) have given better results.  While they may include some noise, this should be eliminated during the automasking procedure.',
		'repalignments' : 'Imagic builds a 3d form your chosen classums.  The batch script is then set up to perform translational and rotational alignments of the reprojections from the built 3d to the classums used to create the 3d.  By iterating this procedure, the 3d-error is minimized.  <BR/><BR/>In test runs alignments have converged after 10-20 iterations.',
		'amask_dim' : 'A good starting point for the lower bound of the bandpass parameter is the smallest dimension of our object.  <BR/><BR/>You can use the formula 2 / (number of pixels for smallest dimension of object).  For example, if it spans 17 pixels, input 0.12 here (2 / 17 = 0.12)',
		'amask_lp' : 'This is a noise-reducing low-pass filter.  Because initial models are done at low resolution, this can be set pretty low (e.g.  0.4)',
		'amask_sharp' : 'The low-pass parameter needs to be >= the low bound of the bandpass.  The higher this filter is set, the "finer / sharper" the mask will be.  Acceptable values from 0-1',
		'amask_thresh' : 'What the program wants from you is what percentage of the voxels (between 0 and 100) you expect the wanted mask to cover.  The program will then automatically generate a threshold value that leads to a 3D mask approximately covering the wanted percentage of the available voxels in the 3D volume.  <BR/><BR/> In test runs, 15 has worked well.',
		'mra_ang_inc' : 'The angular increment for forward projectsions of your masked and filtered 3d used for multi-reference alignment.  You do not need many references here, so setting this paramter to 25 should suffice',
		'forw_ang_inc' : 'The angular increment for forward projections of your masked and filtered 3d used for euler angle refinement (an anchor set).  This value can vary, decreasing as you increase the iterations.  <BR/><BR/>For a C1 structure, choosing 10 should probably be set as the limit, as this creates ~1000 projections which, in combination with an euler angle increment of 2, will take an entire day to perform euler angle assignments for a single iteration',

		/******* Angular Reconstitution Initial Model Creation *******/
		'nvol' : 'number of \'raw\' volumes to compute before 3D alignment and classification. If testing, 100 works. 500-1000 would be better, but will take 1-2 days to run on 8 cpus.',
		'scale' : 'this will dramatically increase the speed of the procedure and is highly recommended.',
		'prealign' : 'this option will iteratively align all images to each other. It may provide improvements, but may also bias the results. If starting a new project, the suggestion would be to try with and without this option.',
		'weight_randomization' : 'If this option is checked, then the sequence of image input into angular reconstitution will be weighted by dissimilarity. The most dissimilar images will be used first. The purpose of this function is to provide a large Euler angle reference base for subsequent image addition. For each image, the selection is still randomized, albeit weighted toward the combined dissimilarity to all images that have already been used. Thus, identical sequences should not be encountered.',
		'linmask' : 'Radius of the linear mask (in Angstroms) to be imposed on the sinogram and within which the statistics will be calculated for the normalization of the sinograms. For best results, this value should be exactly 1/2 * the diameter of your particle. For example, for a particle of diameter 200 Angstroms, this value should be 100. For NO masking answer 0.',
		'threes' : 'only use sets of three images for the initial volume calculation. Rather than using ALL of the class averages for the raw volume calculations, if this option is specified, all raw volumes will consist of a group of 3 images. This dramatically speeds up initial volume calculation. The volumes will still be aligned and refined as usual.',
		'asqfilt' : 'ASQ filtering means Amplitude-Square-Root and is described in papers, like: Marin van Heel, Michael Schatz, and Elena Orlova, \'Correlation Functions Revisited\', Ultramicroscopy 46 (1992) 304-316. This filtering is important if one does not want the sinogram (and a sine-correlation-function derived from it) to be largely dominated by low-frequency information. The ASQ filter functions largely as a high-pass filter but is based on a rather different philosophy (see paper).',
		'ang_inc2' : 'This angular increment is taken as an indication of how precisely you want to determine the Euler angles of the input images. The computing times required for 1 degree is FOUR times more than for 2 degrees etc.',
		'threedfilt' : 'filter each reconstructed volume to this resolution',
		'images_per_volume' : 'This number should be ~50% of the number of input class averages (e.g. if your input stack is 128, this might be 64). More specifically, when using EMAN1 for cross-common lines, this parameter refers to the number of images to use for constructing each 3D map. The full set of input averages (128 in the example above) correspond to the total \'pool\' from which a subset will be randomly selected for analysis by cross-common lines. N different subsets will be randomly calculated and selected, where N refers to the total number of raw maps that were specified with the \'Number of Volumes to Compute\' parameter.',
		'nref' : 'number of 3D alignment references to create during maximum-likelihood alignment calculations.',
		'usePCA' : 'use principal components analysis to reduce the dimensionality of 3D volume comparison & determine inter-volume similarity as (1/Euclidean distance) between transformed coordinates. In tests, this has not affected the results, but dramaticallyl speeds up the calculation.',
		'numeigens' : 'number of Eigenvolumes to compute during principal components analysis for data reduction',
		'recalc' : 'optional parameter: specify ONLY if you wish to recalculate the 3D volumes after PCA data reduction. This option does NOT affect any results, and is only present for visualization purposes of the effects of PCA',
		'PreferenceType' : 'preference value for affinity propation which influences the resulting number of 3D class averages. choose from \'median\', \'minimum\', or \'minlessrange\'. \'median\' will result in the greatest amount of classes, followed by \'minimum\', while \'minlessrange\' results in the fewest',
		'cl_mask_radius' : 'Radius of the mask for the refinement of the initial volume calculated by angular reconstitution (Angstroms). For best results, this value should be slightly larger than the diameter of your particle (e.g. for a 200 Angstrom particle, this value can be ~240/2 ~= 120 Angstroms). The default value is "linear_mask" parameter * 1.2',
		'cl_inner_radius' : 'inner radius for the alignment search of volume refinement (Angstroms)',
		'cl_outer_radius' : 'outer radius for the alignment search during volume refinement (Angstroms). The default value is "mask_radius" parameter * 0.8',
		'ccpr_weight' : 'weight assigned to the "cross-correlation between projections and re-projections" metric. In test cases, this metric has performed best',
		'ej_weight' : 'weight assigned to the "Euler jumper" metric (the average discrepancy in final Euler angles per image within a 3D class). If your average per-image Euler jumpers are high (e.g. 30+), then this metric may have little meaning and should be set to 0',
		'fsc_weight' : 'weight assigned to the "Fourier shell correlation" (resolution at FSC 0.5) metric. In test cases, this metric has had little correlation with the "correctness" of the final result, particularly at low resolution',
		

		/******* Angular Reconstitution Batch Refinement *********/
		'filtering' : '<b> particle filtering (OPTIONAL) </b><br><br> PARAMETER 1: low-pass filter stack to this value (in &Aring;ngstr&ouml;ms) prior to alignment and classification <br><br> PARAMETER 2: high-pass filter stack to this value (in &Aring;ngstr&ouml;ms) prior to alignment and classification',
		'MRA' : '<b> Multi Reference Alignment (MRA) of raw particles </b><br><br> PARAMETER 1: angular increment of forward projections for MRA (~25 is enough) <br><br> PARAMETER 2: maximum radial shift compared to original images - Occasionally the motif of certain images can shifted out of the image field during alignment.  In this case we would lose the whole image information. Parameter specified in pixels directly or as a fraction of inner radius. <br><br> PARAMETER 3: maximum radial shift during THIS PARTICULAR iteration <br><br> PARAMETER 4: minimum radius (in pixels) for rotational alignment <br><br> PARAMETER 5: maximum radius (in pixels) for rotational alignment',
		'MSA' : '<b> Multivariate Statistical Analysis (MSA) </b><br><br> PARAMETER 1: percentage of images (raw particles) to ignore when calculating eigenimages (this does not affect the number of classes produced) <br><br> PARAMETER 2: number of class averages to produce from the raw images (angular reconsitution needs large amounts of class averages to create a good model) <br><br> PARAMETER 3: number of factors (Eigenimages) to use for the classification (should be increased with increasing iterations, to take into account more high-resolution information) <br><br> PARAMETER 4: percentage of worst class members to ignore after classification (again, does not affect the specified number of class averages produced) <br><br> PARAMETER 5: Fraction of final class averages to keep - The classes that are produced are sorted according to the overall quality of the class, so this value REDUCES the amount of class averages going into angular reconstitution.',
		'Angular_Reconstitution' : '<b> The main method of assigning euler angles to class averages in IMAGIC. </b><br><br> PARAMETER 1: angular increment of forward projections - This is your "anchor set" for refining euler angles. The value can vary, decreasing as you increase the iterations. <br><br> PARAMETER 2: Angular Increment of Euler Search - indication of how precisely you want to determine the euler angles of the input images.  The computing time required for 1 degree is FOUR times more than for 2 degrees, etc.  Can try, for example, 10 in first iterations, and 1-2 in the last iterations. <br><br> PARAMETER 3: Fraction of best "ordered" images to keep - The "ordered" class averages which have been assigned euler angles are sorted according to the error in angular reconstitution (an internal consistency measurement).',
		'Threed_Reconstruction' : 'PARAMETER 1: Object size - The relative size of the object inside the 3D volume influences the shape of the exact filter. <BR/><BR/> Low values (e.g.  0.1) have given poor results in test simulations.  High values (e.g.  0.8) have given better results.  While they may include some noise, this should be eliminated during the automasking procedure. <br><br> PARAMETER 2: low-pass filter 3-D volume prior to masking (in &Aring;ngstr&ouml;ms)',
		'Masking' : '<b> Modulation-based masking of the 3d-density </b><br><br> PARAMETER 1: Lower bound of bandpass parameter for mask - A good starting poing is the smallest dimension of our object. You can use the formula 2 / (number of pixels for smallest dimension of object).  For example, if it spans 17 pixels, input 0.12 here (2 / 17 = 0.12). <br><br> PARAMETER 2: This is a noise-reducing low-pass filter - Because initial models are done at low resolution, this can be set pretty low (e.g.  0.4) <br><br> PARAMETER 3: Mask sharpness parameter - The low-pass parameter needs to be >= the low bound of the bandpass.  The higher this filter is set, the "finer / sharper" the mask will be.  Acceptable values from 0-1. <br><br> PARAMETER 4: Density thresholding - What the program wants from you is what percentage of the voxels (between 0 and 100) you expect the wanted mask to cover.  The program will then automatically generate a threshold value that leads to a 3D mask approximately covering the wanted percentage of the available voxels in the 3D volume. In test runs, 15 has worked well',
		'mass' : 'This value is for the chimera-generated model slices and does not affect the reconstruction. Please give the approximate mass of the specimen so that, when the mrc maps are generated, the volume at a threshold of 1 will approximately represent the given mass',
		'symmetry' : 'imposes symmetry on the model.  Used for multi-reference alignment (MRA), angular reconstitution, threed reconstruction, etc.  e.g.  C1, C2, D7, icosahedral, etc.',

		/*** MSA ***/
		'numiters' : 'Number of Iterations for multivariate statistical alignment. Typically the eigenimages converge very quickly, within a few iterations, but a large number is set as default to make sure that spikes do not occur later on during convergence.',
		'mask_radius' :'The mask radius is used during masking / filtering of the stack AND during the creation of eigenimages.  The output images will be normalized inside a circular mask with this radius.  The radius should be chosen such that no part of the molecules are cut off by the resulting mask.  This value may be specified as a fraction of the inner radius of the image or in pixels.  Radius = 1 means that the whole image is used for normalization.',
		'mask_dropoff' : 'If you specify a drop-off the mask will be a soft mask.  The drop-off parameter determines the width of the soft edge (halfwidth of soft-edge Gaussian drop-off) by which the circular mask is smoothed.  A value of 0 specifies a hard mask.',
		'overcorrection' : 'The overcorrection factor is a very important parameter in the MSA program. It determines the convergence speed of the Eigenvector Eigenvalue algorithm. However, if a too large overcorrection is chosen, the algorithm may start oscillating. Oscillations of the algorithm may be observed in the plot of the sum of the eigenvalues versus iteration number which is part of the output of this program. Divergence may thus only be detected a posteriori. The accepted values for OVER_CORRECTION lie between 0 and 0.9',
		'ignore_images' : 'percentage of images (raw particles) to ignore when calculating eigenimages (this does not affect the number of classes produced)',
		'ignore_members' : 'percentage of worst class members to ignore after classification',
		'norefbin' : 'Binning of the image. This takes a power of 2 (1,2,4,8,16) and shrinks the image to help make the processing faster. Binning would be useful if, for example, the reference-free averages are to be used for initial model creation. Otherwise IMAGIC MSA runs are quite fast. For example, on a stack of 10,000 particles with a boxsize of 192, the algorithm takes ~15-30 minutes to run, so bining is not necessary.',
		'MSAdistance' : 'distance metric used to analyze the difference between two images. Modulation analysis is defaulted to IMAGIC. Chi-square analysis is used in SPIDER Correspondence Analysis.',
		'num_eigenimages' : 'Number of factors (Eigenimages) to use for classification. The IMAGIC feature analysis algorithm defaults to calculating 69 Eigenimages, however, for the initial rounds of classification, the later ones usually represent pure noise. You may therefore wish to specify using less eigenimages (e.g. 5-10) for creating class averages, which would speed up the hierarchical clustering algorithm and reduce noise bias.',

		/*** MRA ***/
		'templatestack' : 'Template stack, the images of which will be used as references for the alignment',
		'lpfilt_refs' : 'Low pass filter applied to the references. Note that this is during processing, and does not alter the actual reference file in any way',
		'thresh_refs' : 'Thresholds the reference images to a certain pixel value. The reason for this is that commonly negative values represent negative stain. For example, thresholding to 0 removes all dark pixel values that would represent stain. NOTE: If you do not want any threshold give -999. ',
		'maskrad_refs' : 'contour the references with a circular mask. Value can be given in pixels OR as a fraction of the inner radius of the image (default)',
		'numiter_mra' : 'Number of Iterations for multi-reference alignment. IMAGIC limits this value to 5, since the good images will typically be ready after 2 or 3 iterations, whereas the bad images go on forever',
		'minrad' : 'Specify which radial parts of the images are to be included in the rotational alignment. The suggested value of 0 means that the starting point is the center of the image',
		'maxrad' : 'Specify which radial parts of the images are to be included in the rotational alignment. The suggested value of 0.7 means that all radii up to 70% of the image will be included in the search',
		'center' : 'perform a translational centering operation against the total particle sum prior to multi-reference alignment (NOTE: in the IMAGIC 3-D refinement, this is ONLY done for the first iteration. Subsequent iterations perform multi-reference rotational and translational alignment)',
		'num_orientations' : 'This parameter drives BRUTE_FORCE alignment option. CPU usage will be proportional to the number of different rotation directions you desire. Reasonable values are 5-360',

		/*** Synthetic Dataset Creation ***/
		'projcount' : 'number of projections to be made from the input model. If an even distribution is chosen, this value will be approximate, and the number of projections will be rounded up to the closest number giving an even, equivalent distribution of all angular views',
		'projtype' :  'These can be evenly distributed about the entire sphere (standard), or have a preferred orientation about the 3 axes (good for common lines tests)', 
		'projstdev' : 'standard deviation of gaussian distribution of euler angles about each axis. The model will be projected randomly in the the XY, XZ, and YZ coordinates with euler angles determined by a random gaussian distribution with the given standard deviation. A value of ~5 will give 3 preferred orientations.',
		'projinc' : 'angular increment of projections, as used in EMAN project3d program. For reference, ang=90 gives 3 projections, 45->8, 30->20, 20->44, 10->180, 7->388, 5->711, 4->1179, 3->1969, 2->4442, 1->17817. For example, an angular increment of 5, with 10000 projections chosen will produce a stack of 10665 particles (i.e. 15 repetitions of all angular views).',
		'shiftrad' : 'radius of of random shift for each particle. Should not be too much, otherwise the particles will not fit inside box', 
		'rotang' : 'angle of random rotation for each particle; provide 0 if you do NOT want your 2D particles to be rotated after projecting', 
		'flip' : 'randomly flip the projections along with shifts and rotations',
		'pad' : 'pad 2D images before CTF application. This will reduce ringing artifacts caused by applying a CTF to boxed images rather than the entire micrograph.',
		'padval_synthetic' : 'padding factor to apply to the 2D images. 2 is recommended. More than that will dramatically increase the computation ', 
		'snr1' : 'first level of noise, simulating beam damage & structural noise. Estimated as 1.4-1.8 by Baxter et. al., 2009',
		'snrtot' : 'signal-to-noise ratio of final particles, simulating shot noise, detector noise, film granularity, & digitization. Final images have an estimated SNR of 0.05 in Baxter et. al., 2009', 
		'radius' : 'radius of particle inside the box (in pixels, defaulted to 1/2*boxsize). This is necessary in order to calculate correc SNR values see W.T. Baxter et al. (2009). JSB 166 126-132. Correlations were calculated using a circular mask of 220 pixels from a 300-pixel box, effectively increasing the CCC and SNRs from what is calculated here. If your particle occupies 70% of the box then the calculated noise additions will be increased by a factor of 1/(0.35*0.35*pi) = ~2.46',
		'df1' : 'defocus value in x direction, positive value is underfocus (represented as the mean, if randomization is checked)',
		'df2' : 'defocus value in x direction, positive value is underfocus (represented as the mean, if randomization is checked)',
		'astigmatism' : 'Astigmatism of CTF. Only input if you want to apply an astigmatic ctf',
		'randomdef' : 'randomize defocus values when applying CTF (df1 and df2 would represent the mean)',
		'randdefstd' : 'standard deviation (in microns) for the gaussian distribution of defoci randomizations about the mean',
		'ace2correct' : 'correct images after applying CTF. Several options are given',
		'correctiontype' : 'Three options are available: <br><br><b> 1) Applied CTF </b> This is the simplest method, which corrects the images by wiener filtering the particles using the same defocus values as those that were applied. <br><br><b> 2) Use ACE2 Estimate </b> This method uses ACE2 to estimate the applied defoci. These Estimated values are then used to correct each micrograph and particle, simulating reality. In test runs, ACE2 either gets the exact value or completely fails. The latter case is most likely due to the fact that too much noise has been added before estimating. If this is the case, you can try decreasing SNR1 to 1, while keeping SNR Total as is at 0.05 (which is what it should be for ice images). <br><br><b> 3) Perturb Applied CTF </b> The correction values will be perturbed according to a gaussian mean (the applied CTF) and standard deviation (specified below) of the applied defoci. If you want to introduce errors in the correction phase, use this option.',
		'ace2correct_std' : 'used only in conjunction with the perturbation option above, if you want to introduce random errors in the CTF correction process',
		'ccsearchmult' : 'The cross-correclation search multiple is a scale factor used to improve the results of cross-correlation by increasing the size of the mask used for the cross-correlation step. This is only used with the GPU version of the template correlator. For example a typical cross-correlation search size of 1.2 will multiply the template mask diameter by 1.2 and use this new size mask for cross-correlation. Values between 1.0 and 1.3 are recommended.',
		
		
		/*** Additional Protomo popups ***/
		'protomo_logging' : 'Enable Protomo\'s diagnostic terminal output (type: true/false).',
		'protomo_imod_coarse_align' : 'Perform Imod coarse alignment in addition to Protomo coarse alignment. This will happen alongside Protomo coarse alignment, not after. (type: True/False).',
		'protomo_further_alignment' : 'Runs Protomo Coarse Alignment twice in a row (type: True/False).',
		'protomo_tiltseries': 'Select the tilt-series number in the current session that corresponds to the tomogram to be processed. Protomo supports CCP4, EM, FFF, IMAGIC, MRC, SPIDER, SUPRIM, and TIFF filetypes. Currently images recorded as individual .mrc files are fully supported.',
		'protomo_defocus_estimate' : 'Estimate the defocus of the untilted plane of the tilt-series using TomoCTF. This will overwrite previous TomoCTF runs. Briefly, TomoCTF will tile from all tilt images to build a composite 2D power spectrum of the whole tilt-series, which will therefore be of greater SNR compared to estimating the defocus of any individual low dose tilt image. Consequently, this approach requires that the goniometer used to collect the tilt-series is sufficiently stable and well calibrated so that the tilt angles are representative of the actual motion of each exposure area relative to the distance along the beam direction.<br><br>Here, TomoCTF will be run multiple times while varying the tile size - 256, 384, 512 - and CTFMin - 0,0.33,0.67,1 (see TomoCTF documentation), then the user will determine which estimation is most accurate/<br><br>Note: Defocus estimation depends on an accurate tilt-azimuth value. If you are confident in the database value or know the tilt-azimuth from previous tilt-series from the same microscope, use that value, otherwise it is recommended that a full tilt-series Refinement is performed first to properly refine the tilt-azimuth (type: selection).',
		'protomo_tiltseries_manual': 'Input the tilt-series number corresponding to the .tlt file you have made, e.g. if the .tlt file is named series0013.tlt then put 13 here (type: int).',
		'protomo_dimx': 'The x-dimension of the tilt images in your \'raw\' directory, in pixels (type: int).',
		'protomo_dimy': 'The y-dimension of the tilt images in your \'raw\' directory, in pixels (type: int).',
		'protomo_starting_tlt_file' : 'Use the alignment results after Protomo coarse alignment (Iteration 1 or 2), Imod coarse alignment, Manual alignment, Initial alignment, or your own .tlt file to begin Refinement.<br><br>Check the tilt-series videos on the Coarse Alignment Summary webpage to determine which to begin with. You may also provide your own Protomo .tlt file by copying it to the run directory with the name series####.tlt (type: selection).',
		'protomo_pixelsize' : 'Pixelsize, in angstroms/pixel, of the tilt images in your \'raw\' directory (type: float).',
		'protomo_parallel' : 'Parallelize depiction image and video generation.<br><br>If you encounter memory errors, try switching this to False. If you encounter libgomp errors, try switching this to False (type: True/False).',
		'protomo_frame_aligned' : 'Use frame-aligned images instead of naively summed images, if present. If True, the last frame aligned tilt image will be used (type: True/False).',
		'protomo_center_all_images' : 'Center all images with respect to the image dimensions.<br><br>Sometimes Leginon does not record the proper image shifts. If there is a large shift in some of the tilt images, try changing this to True (type: True/False).',
		'protomo_re_center_images' : 'Re-center images with respect to the alignment.<br><br> with respect to the alignment. This will increase the maximum allowed search area, which is useful in most cases (type: True/False).',
		'protomo_binning' : 'Enable/disable binning of raw images (type: true/false).',
		'protomo_change_refimg' : 'Protomo works best when the reference image for alignment is the image either half-way between the highest and lowest tilt angle, or the 0 degree image. If the tilt-series was collected with Leginon with a non-zero starting angle, then the default reference image is not the 0 degree image. You usually want to change it to be the 0 degree image. The same may also be true for images uploaded to Leginon. (type: True/False).',
		'protomo_preprocessing' : 'Enable/disable preprocessing of raw image files. Setting this to false turns off all of the options under Preprocessing Parameters (type: true/false).',
		'protomo_gradient' : 'Enable/disable linear gradient subtraction for preprocessing masks (type: true/false).',
		'protomo_iter_gradient' : 'Iterate gradient subtraction once (type: true/false).',
		'protomo_filter' : 'Preprocessing filter. Options are "median" or "gauss". If "gauss" is chosen, the radius of the Gaussian will be 1/2 of the Filter Window Size. Median filter is recommended (type: string).',
		'protomo_corr_mode' : 'Correlation mode. Options are standard (xcf), mutual (mcf), phase only (pcf), phase doubled (dbl). Mutual correlation (mcf) is usually recommended.<br><br>xcf: Conventional cross-correlation.<br><br>mcf: Mutual correlation function. mcf is less biased towards strong low-frequency components.<br><br>pcf: Phase only correlation function. pcf ignores the amplitude of the Fourier coefficients and only aligns based on phase. pcf might be useful in Refinements, however it requires accurate geometric parameters as a starting point.<br><br>dbl: Phase doubled correlation. dbl doubles the peak shift allowing for more accurate alignments especially on tilt-series taken with poor imaging conditions.<br><br>Note: ccc values outputed to the command window by Protomo during alignment are normalized to xcf ccc values; mcf, pcf, and dbl ccc values are not normalized to 1 (type: string selection).',
		'protomo_r1_corr_mode' : 'Correlation mode for Round 1. Options are standard (xcf), mutual (mcf), phase only (pcf), phase doubled (dbl).<br><br>xcf: Conventional cross-correlation.<br><br>mcf: Mutual correlation function. mcf is less biased towards strong low-frequency components.<br><br>pcf: Phase only correlation function. pcf ignores the amplitude of the Fourier coefficients and only aligns based on phase. pcf might be useful in Refinements, however it requires accurate geometric parameters as a starting point.<br><br>dbl: Phase doubled correlation. dbl doubles the peak shift allowing for more accurate alignments especially on tilt-series taken with poor imaging conditions.<br><br>Note: ccc values outputed to the command window by Protomo during alignment are normalized to xcf ccc values; mcf, pcf, and dbl ccc values are not normalized to 1 (type: string selection).',
		'protomo_r2_corr_mode' : 'Correlation mode for Round 2. Options are standard (xcf), mutual (mcf), phase only (pcf), phase doubled (dbl).<br><br>xcf: Conventional cross-correlation.<br><br>mcf: Mutual correlation function. mcf is less biased towards strong low-frequency components.<br><br>pcf: Phase only correlation function. pcf ignores the amplitude of the Fourier coefficients and only aligns based on phase. pcf might be useful in Refinements, however it requires accurate geometric parameters as a starting point.<br><br>dbl: Phase doubled correlation. dbl doubles the peak shift allowing for more accurate alignments especially on tilt-series taken with poor imaging conditions.<br><br>Note: ccc values outputed to the command window by Protomo during alignment are normalized to xcf ccc values; mcf, pcf, and dbl ccc values are not normalized to 1 (type: string selection).',
		'protomo_r3_corr_mode' : 'Correlation mode for Round 3. Options are standard (xcf), mutual (mcf), phase only (pcf), phase doubled (dbl).<br><br>xcf: Conventional cross-correlation.<br><br>mcf: Mutual correlation function. mcf is less biased towards strong low-frequency components.<br><br>pcf: Phase only correlation function. pcf ignores the amplitude of the Fourier coefficients and only aligns based on phase. pcf might be useful in Refinements, however it requires accurate geometric parameters as a starting point.<br><br>dbl: Phase doubled correlation. dbl doubles the peak shift allowing for more accurate alignments especially on tilt-series taken with poor imaging conditions.<br><br>Note: ccc values outputed to the command window by Protomo during alignment are normalized to xcf ccc values; mcf, pcf, and dbl ccc values are not normalized to 1 (type: string selection).',
		'protomo_r4_corr_mode' : 'Correlation mode for Round 4. Options are standard (xcf), mutual (mcf), phase only (pcf), phase doubled (dbl).<br><br>xcf: Conventional cross-correlation.<br><br>mcf: Mutual correlation function. mcf is less biased towards strong low-frequency components.<br><br>pcf: Phase only correlation function. pcf ignores the amplitude of the Fourier coefficients and only aligns based on phase. pcf might be useful in Refinements, however it requires accurate geometric parameters as a starting point.<br><br>dbl: Phase doubled correlation. dbl doubles the peak shift allowing for more accurate alignments especially on tilt-series taken with poor imaging conditions.<br><br>Note: ccc values outputed to the command window by Protomo during alignment are normalized to xcf ccc values; mcf, pcf, and dbl ccc values are not normalized to 1 (type: string selection).',
		'protomo_r5_corr_mode' : 'Correlation mode for Round 5. Options are standard (xcf), mutual (mcf), phase only (pcf), phase doubled (dbl).<br><br>xcf: Conventional cross-correlation.<br><br>mcf: Mutual correlation function. mcf is less biased towards strong low-frequency components.<br><br>pcf: Phase only correlation function. pcf ignores the amplitude of the Fourier coefficients and only aligns based on phase. pcf might be useful in Refinements, however it requires accurate geometric parameters as a starting point.<br><br>dbl: Phase doubled correlation. dbl doubles the peak shift allowing for more accurate alignments especially on tilt-series taken with poor imaging conditions.<br><br>Note: ccc values outputed to the command window by Protomo during alignment are normalized to xcf ccc values; mcf, pcf, and dbl ccc values are not normalized to 1 (type: string selection).',
		'protomo_r6_corr_mode' : 'Correlation mode for Round 6. Options are standard (xcf), mutual (mcf), phase only (pcf), phase doubled (dbl).<br><br>xcf: Conventional cross-correlation.<br><br>mcf: Mutual correlation function. mcf is less biased towards strong low-frequency components.<br><br>pcf: Phase only correlation function. pcf ignores the amplitude of the Fourier coefficients and only aligns based on phase. pcf might be useful in Refinements, however it requires accurate geometric parameters as a starting point.<br><br>dbl: Phase doubled correlation. dbl doubles the peak shift allowing for more accurate alignments especially on tilt-series taken with poor imaging conditions.<br><br>Note: ccc values outputed to the command window by Protomo during alignment are normalized to xcf ccc values; mcf, pcf, and dbl ccc values are not normalized to 1 (type: string selection).',
		'protomo_r7_corr_mode' : 'Correlation mode for Round 7. Options are standard (xcf), mutual (mcf), phase only (pcf), phase doubled (dbl).<br><br>xcf: Conventional cross-correlation.<br><br>mcf: Mutual correlation function. mcf is less biased towards strong low-frequency components.<br><br>pcf: Phase only correlation function. pcf ignores the amplitude of the Fourier coefficients and only aligns based on phase. pcf might be useful in Refinements, however it requires accurate geometric parameters as a starting point.<br><br>dbl: Phase doubled correlation. dbl doubles the peak shift allowing for more accurate alignments especially on tilt-series taken with poor imaging conditions.<br><br>Note: ccc values outputed to the command window by Protomo during alignment are normalized to xcf ccc values; mcf, pcf, and dbl ccc values are not normalized to 1 (type: string selection).',
		'protomo_r8_corr_mode' : 'Correlation mode for Round 8. Options are standard (xcf), mutual (mcf), phase only (pcf), phase doubled (dbl).<br><br>xcf: Conventional cross-correlation.<br><br>mcf: Mutual correlation function. mcf is less biased towards strong low-frequency components.<br><br>pcf: Phase only correlation function. pcf ignores the amplitude of the Fourier coefficients and only aligns based on phase. pcf might be useful in Refinements, however it requires accurate geometric parameters as a starting point.<br><br>dbl: Phase doubled correlation. dbl doubles the peak shift allowing for more accurate alignments especially on tilt-series taken with poor imaging conditions.<br><br>Note: ccc values outputed to the command window by Protomo during alignment are normalized to xcf ccc values; mcf, pcf, and dbl ccc values are not normalized to 1 (type: string selection).',
		'protomo_slab' : 'Adjust back-projection body size for a slab-like specimen. This will take into account the increasing apparent thickness when the specimen is tilted. In the back-projection, the thickness parameter is usually assumed to be constant, but this is valid only for spherical objects. If the objects in the tilt images are spherical, consider changing this option to \'false\' (type: true/false).',
		'protomo_create_tiltvids' : 'Create tilt-series videos after alignments for depiction (type: true/false).',
		'protomo_create_tilt_video' : 'Create tilt-series videos for tilt-series before and after Coarse Alignment for depiction on the next page (type: true/false).',
		'protomo_create_tilt_video2' : 'Create tilt-series video after Refinements for depiction on the next page (type: true/false).',
		'protomo_create_reconstruction' : 'Create a reconstruction after Coarse Alignment for depiction as a video on the next page.<br><br>The Reconstruction Size in z will be twice the thickness (in pixels). The Window Size will be shown for the section of the reconstruction that was used for Coarse Alignment, if requested.<br><br>If this option and the Create Tilt-Series Videos option are set to false, the options below will do nothing. (type: true/false).',
		'protomo_create_reconstruction2' : 'Create reconstructions after alignments for depiction as a video on the next page.<br><br>The Reconstruction Size in z will be twice the thickness (in pixels). The Window Size will be shown for the section of the reconstruction that was used for Refinement, if requested.<br><br>If this option and the Create Tilt-Series Video option are set to false, the options below will do nothing. (type: true/false).',
		'protomo_show_window_size' : 'Select \'true\' to have the Window Size, which is the search area, displayed on the reconstruction video on the summary page. The z-height of the Window Size box is approximately the requested thickness of volume each preliminary back-projection is derived from. This option is particularly useful for diagnosing alignment issues (type: true/false).',
		'protomo_keep_recons' : 'Keep premilinary reconstructions used for generating a reconstruction video. Reconstructions can be found in the tiltseries\' \"out\" directory with file names ending in \"_bck\" (type: true/false).',
		'protomo_video_type' : 'Depiction videos for correlation peaks, tilt-series, and reconstructions will be made. Select HTML5 to encode videos as mp4, webm, and ogv (for compatibility). It is recommended that you only use gifs if there is any trouble with HTML5 video playback in your browser.<br/><br/>If HTML5 videos don\'t loop, try refreshing the webpage (type: string).',
		'protomo_tilt_clip' : 'Clip the pixel values of each image in the tilt-series video to 5 sigma. This usually allows for more consistent contrast across the tilt-series video (type: true/false).',
		'protomo_do_estimation' : 'Estimate geometric parameters instead of using stored values from previous cycle (type: true/false).',
		'protomo_norotations' : 'Set in-plane rotations to zero instead of using stored values (type: true/false).',
		'protomo_orientation' : 'Include orientation angles in refinement. It is recommended to leave this set to true.<br><br>Some alignments fail in later iterations because the orientation angles (displayed in the Refinement Summary webpage) begin to diverge even after it converging. If this happens, try switching \'Include Orientation Angles in Refinement\' to false after it has converged (Hint: use the Switch option to do so) (type: true/false).',		
		'protomo_azimuth' : 'Include tilt azimuth in refinement. It is recommended to leave this set to true.<br><br>Some alignments fail in later iterations because the tilt azimuth (displayed in the Refinement Summary webpage) begins to diverge even after it converges. If this happens, try switching \'Include Tilt Azimuth in Refinement\' to false after it has converged (Hint: use the Switch option to do so) (type: true/false).',		
		'protomo_azimuth_stability_check' : 'Check the tilt azimuth after each iteration to see if it has deviated from the initial tilt azimuth by more than the \'Maximum Deviation Allowed\' value.<br><br>The tilt azimuth for some tilt-series will diverge for various reasons. If the refined tilt azimuth for a given goniometer+holder combination diverges from the known value by more than a few degrees, then you may wish to turn this option on. By doing so, if the tilt azimuth diverges, it will be reset for the next iteration to the initial tilt azimuth value (type: True/False).',
		'protomo_elevation' : 'Include tilt axis elevation in refinement. It is recommended to leave this set to false for the first few iterations and possibly set this to true for later iterations (type: true/false).',		
		'protomo_rotation' : 'Include in-plane rotations in refinement. It is recommended to leave this set to true, though consider switching this to false if using pcf Correlation Mode (type: true/false).',
		'protomo_scale' : 'Include scale factors (magnification) in refinement. It is recommended to leave this set to false for the first few iterations and possibly set this to true for later iterations (type: true/false).',
		'protomo_link' : 'Raw Images will either be symlinked to the output \'raw\' directory or copied. Use linking if your system allows to significantly reduce overhead, disk accessing, and disk space.',
		'protomo_coarse_presets_size' : 'This is the estimated size of the object(s) you wish to align on. This preset changes the lowpass filters and the thickness parameter.<br><br>Note that Protomo aligns in Fourier space, which allows for sub-pixel accuracy. This means that the resolution of the alignment may be better than the lowpass cutoff. Generic is pixelsize*75.',
		'protomo_coarse_presets_search' : 'This is the search area of each image that will be used for Coarse Alignment. Alignment will be performed on object(s) inside the Search Area. This preset changes the Mask Width and the Highpass Filters. Beware of aligning to grid hole edges.<br><br>Pay attention to the Window Size box shown in the \'Tilt-Series Reconstruction After Coarse Alignment\' video on the next webpage. If an insufficient amount of specimen-related contrast does not appear in the Window Size box, consider increasing the size of the Search Area.<br><br>Note: Generic is 50%.',
		'protomo_refine_settings' : 'The Express Settings only include the Preset Parameters, requiring minimal knowledge of the alignment process. The Basic Settings display critical and preset parameters. Advanced Settings include all parameters.<br><br>It is recommeded to adjust the Window Size and Mask Parameters using the Parameter Presets because those parameters are calculated based on the Window Size and the Lowpass Filter.<br><br>Note: First choose Settings Verbosity, then choose Parameter Presets, then edit parameter values if desired.',
		'protomo_refine_presets_size' : 'This is the estimated size of the object(s) you wish to align on. This preset changes the lowpass filters and the thickness parameter. Three sets of presets are given: Constant, decreasing, or steeply decreasing lowpass over Refinement iterations.<br><br>\'Steep lowpass\' is designed to begin by aligning to larger objects, then align to smaller objects while scaling by the change in sampling, which is much steeper than \'Decreasing lowpass\'. \'Decreasing lowpass\' is designed to begin by aligning to larger objects, then at lower samplings align to smaller objects. \'Constant lowpass\' is designed to consistantly align to the same objects over all Rounds. Those smaller objects might be features of the larger objects, different objects entirely, or noise.<br><br>It is recommended that you first try \'Steep lowpass\'.<br><br>Note that Protomo aligns in Fourier space, which allows for sub-pixel accuracy. This means that the resolution of the alignment may be better than the lowpass cutoff. Generic is pixelsize*75.',
		'protomo_refine_presets_search' : 'This is the search area of each image that will be used for Refinement. Alignment will be performed on object(s) inside the Search Area. This preset changes the Mask Width and the Highpass Filters. Beware of aligning to grid hole edges.<br><br>The Window Box Size shown in reconstruction videos shows the approximate search volume being used for refinement.<br><br>Note: Generic is 90% of the maximum search area in common between all tilt images.',
		'protomo_refine_presets_type' : 'This preset defines the number of iterations performed in each Round.<br><br>All refinements except for Quick switch on the scaling parameters during the last half of the last Round. Exhaustive refinement adds an additional Round where the search is performed with the phase only correlation function (pcf) in an attempt to refine based on the phase of the Fourier coefficients.',
		'protomo_recon_iter' : 'Refinement iteration used to make final reconstruction.<br><br>Note: This will leave all iterations and all files in the Output directory untouched (type: int).',
		'protomo_firststep' : 'This is the first processing step to be done in batch processing.<br><br>If you choose one of the first four options as the First Step, the Last Step must be the same or one of the next options in that same set of options.<br><br>If you choose either Screening Mode, CTF Correction, Dose Compensation, or Fully Automated, the First and Last Steps must be the same.',
		'protomo_laststep' : 'This is the last processing step to be done in batch processing.<br><br>If you choose one of the first four options as the First Step, the Last Step must be the same or one of the next options in that same set of options.<br><br>If you choose either Screening Mode, CTF Correction, Dose Compensation, or Fully Automated, the First and Last Steps must be the same.',
		'protomo_picking_gpu_or_cpu' : 'Use either GPU template-tomogram convolution (requires OmniMatch) or CPU-based convolution (uses SciPy) (type: selection).',
		'preset_info' : 'Here you will find three sets of modular presets for the most critical parameters in a Protomo Refinement.',
		'genparam_info' : 'These are general image, sampling, and logging parameters.',
		'genparam_info2' : 'These are general image, sampling, and logging parameters.<br><br>Rounds are introduced in Protomo Refinement to allow the user to alter parameters for specified numbers of iterations. Parameters that can be changed from iteration to iteration are either specified with a Round number (R1-R5), or with a switch (for changing a parameter from true to false or vice verse). Parameters without Switch or Round options remain constant across all iterations. Each Round must either be entirely filled in with values or entirely blank, however if you wish to skip a round you only need to change the number of iterations for that Round to 0 (zero) - all other options for that Round will be ignored.',
		'preprocparam_info' : 'If \'Raw Image Preprocessing\' is set to \'true\', Protomo will apply the following modifications to the Raw Images before Sampling and before alignment. Preprocessing is a two step process: First the Gradient Subtraction, Filtering, and Filter Window Size are applied. The remaining parameters are applied in the second step.',
		'windowparam_info' : 'Protomo will use the following windowing parameters during alignment.',
		'gridsearchparam_info' : 'Protomo does Coarse Alignment using gridsearch. Images are rotated according to the Gridsearch Parameters and an exhaustive translationional search is performed for each angular increment. The image is then set to the transformation that produces the highest correlation peak. Gridsearch is performed inside the masked region.',
		'maskparam_info' : 'Filters and Mask Apodization are applied inside the region covered by the mask.',
		'crosscorrparam_info' : 'Cross-correlation values are searched for inside the Peak Search Radius using the selected Correlation Mode.',
		'mapparam_info' : 'This option is related to the back-projection made both during alignment and for depiction.',
		'depictionparam_info' : 'These parameters relate to the depiction of the tomogram and diagnostic videos on the next page.',
		'areamatchinparam_info' : 'The tilt-series will be aligned with Area Matching, which these parameters relate to. Area Matching is performed inside the masked region.',
		'geomrefineparam_info' : 'After alignment, Protomo attempts to determine the geometric parameters of the alignment based on the following parameters.',
		'corrimageinfo_coarse' : 'These are correlation peaks between each tilt image and the corresponding preliminary back-projection image.<br><br>If you can see a white correlation peak during most frames, then you should proceed onto Refinement. There should be one black Frame in the middle that corresponds to the reference image used for Coarse Alignment. If there are more than one black Frames, then these correspond to images that were aligned before the alignment failed and was restarted successfully; in this case, the black correlation peak images correspond to images that are aligned. This case occurs if the Window Size is too large. Check the commandline output and consider re-running Coarse Alignment with the values recommended there.<br><br>Excluded images are not included.',
		'corrimageinfo_refine' : 'Correlation peaks for each iteration are displayed here for quick refinement evaluation. Well-aligned reconstructions produce a point-like correlation peak video where the peak does not wander more than a few pixels from the center of the video. Excluded images are not included.<br><br>To view depicton and diagnostics for an individual iteration, click on the corresponding correlation peak image or title.',
		'corrimageinfo_refine2' : 'The correlation peak should remain in the center of the image surrounded by relatively dark noise. A peak that does not wobble or deviate from the center at all is characteristic of a good refinement.',
		'corrimageinfo_recon' : 'These are the correction factor plots for the chosen iteration.<br><br>It is not uncommon for a an otherwise well-aligned tilt-series to have poorly aligned images at high tilt angles. You may wish to remove offending high tilt angle images from the reonstruction by using the Angle Limit parameters above. Consider doing so if there are images that meet one or more of the following criteria:<br>&nbsp&nbsp• Correction Factor (x) > 1.015<br>&nbsp&nbsp• Correction Factor (y) < 0.985<br>&nbsp&nbsp• Correction Factor for Scaling < 0.985 or > 1.015<br>&nbsp&nbsp• Correction Factor for Rotation < -1.5° or > 1.5°',
		'initialtiltimageinfo_coarse' : 'This is the tilt-series before any alignment, but including shifts and rotations as recorded in the database. These images have not (yet) been CTF corrected and/or dose compensated. Excluded images are not included.',
		'defocusestimation_info' : 'Defocus of the untilted plane of the tilt-series has been estimated using TomoCTF while varying parameters. Here you will find multiple TomoCTF runs with those varying parameters. A properly estimated defocus will<br>&nbsp&nbsp1) Have the first zero matched properly - make sure that the estimated defocus is not aliased (ie. that the first estimated zero coincides with the first zero in the data), and<br>&nbsp&nbsp2) Have well-matched subsequent zeros, in order, out to the last resolvable zero in the data.<br><br>Either take note of the most accurately estimated defocus value and enter it in on the next webpage or re-run the defocus estimation until the defocus has been accurately measured.',
		'tiltimageinfo_coarse' : 'These are the Raw Images translated and rotated according to the Coarse Alignment with CTF correction and/or dose compensation if requested. Grey borders correspond to translations. Black borders correspond to rotations. Excluded images are not included in this depiction. To view the initial tilt-series before alignment, click on the \'View Initial Tilt-Series\' button above this image.',
		'protomo_reconstruction_actions' : 'Choose what set of actions you wish to perform on your original, raw images before reconstruction/stack creation. These actions will be performed in the order presented.<br><br>Note: Choices with CTF Correction or Dose Compensation will overwrite the current images in the tilt-series directory before processing.<br><br>Note: CTF correction is currently disabled, pending further testing (type: selection).',
		'protomo_reconstruction_method' : 'The software and method used for reconstructing the tilt-series. Currently there are three options:<br>&nbsp&nbsp• Protomo weighted back-projection: Protomo will reconstruct the tilt-series by WBP such that the tilt axis is on the x-axis and is tilted by the refined azimuth. The grid orientation will also be taken into account so that the resulting tomogram is representative of the position of the grid with respect to the electron beam.<br>&nbsp&nbsp• Tomo3D weighted back-projection: Tilt images will be rotated so that the tilt axis is on the y-axis before WBP.<br>&nbsp&nbsp• Tomo3D SIRT: Tilt images will be rotated so that the tilt axis is on the y-axis.<br>Note: You must have Tomo3D (CPU version) and IMOD installed for Tomo3D reconstructions.<br>Note: Protomo and Tomo3D WBP weight frequencies differently; they are not equivalent. (type: string selection).',
		'reconimageinfo_coarse' : 'This is a Z-slice through of the binned reconstruction for depiction. You should be able to see large, high contrast objects present in your tomogram. Most objects in your zero-degree tilt image should be visible somewhere in the tomogram.<br><br>If you set the Show Window Size in Reconstruction Videos to true, in the middle half of the Z-slices you will see a box the size of the requested Window Size. The volume enclosed by this box is approximately the volume used to perform Coarse Alignment. It is usually best to choose a Window Size that encloses a large amount of the objects in your tomogram in the x- and y-directions, and to choose a Thickness that encloses all of those objects that you wish to align on.',
		'bin_type' : 'The method used to down-sample images.<br><br>Fourier binning will crop tilt images in Fourier space after per-image translation, rotation, and stretching is applied.<br><br>Interpolation will use scipy.ndimage.zoom to interpolate images with an order 5 polynomial. This may reduce contrast in the images, and thus the reconstruciton due to the inevitable smoothing of local extrema.<br><br>Sum will simply add neighboring pixel values together as a method for down-sampling images. This might increase contrast, but will limit resolvable features compared to Fourier binning.',
		'recon_lowpass' : 'Enable/disable lowpass filtering of images before reconstruction by back-projection.<br><br>If you are planning on performing single particle tomography on the resulting tomogram, set this to False. If instead you are planning to use the tomogram for segmenting or visualization purposes, set this to True and set the lowpass filters to the resolution you are hoping to be able to segment from or visualize. (type: True/False).',
		'manual_info' : 'To use Appion-Protomo on a tilt-series that is not in the Appion/Leginon database, you must do the following:<br>&nbsp&nbsp• Create an Output directory,<br>&nbsp&nbsp• Create a subdirectory, Run name, in the Output directory,<br>&nbsp&nbsp• Create a subdirectory in Run name called \'raw\',<br>&nbsp&nbsp• Place your tilt-series as individual .mrc tilt images into the \'raw\' directory,<br>&nbsp&nbsp• Copy $myamidir/appion/appionlib/data/template.tlt to you Run name directory as seriesXXXX.tlt (XXXX=Tilt-Series Number),<br>&nbsp&nbsp• Edit this .tlt file to include all information for this tilt-series,<br>&nbsp&nbsp• Fill in the parameters on this webpage,<br>&nbsp&nbsp• Click \'Submit Manual Parameters\' and continue on to Coarse Alignment.<br><br>If you are having difficulty, there is a video in the \'User Guide\' to walk you through the process.',
		'batch_info' : 'These parameters are required for any batch processing. Batch mode allows you to process any number of tilt-series in a session through a sequential number of steps chosen above..<br><br>The following steps require access to the Appion/Leginon database: File Preparation, Screening Mode, CTF Correction, Dose Compensation, and Fully Automated. The protomo2batch.py script has been tested on individual workstations and interactive HPC Slurm and MOAB clusters (msub -I and salloc, respectively).',
		'prep_info' : 'This step prepares tilt-series for processing. A directory for each tilt-series is made, raw images are copied, and Appion/Leginon database is queried to generate a geometry .tlt file. An initial tilt-series video is made if requested.',
		'coarse_info' : 'This step processes tilt-series through a coarse alignment based on the parameters in the param file provided by the user. Correlation peak videos, initial tilt-series videos, coarse aligned tilt-series videos, and reconstruction videos will be generated for depiction. Tilt-series need to have been prepared before this step. The Appion/Leginon database is not queried during this step.',
		'refine_info' : 'This step processes tilt-series through refinements based on the parameters in the param file provided by the user. Correlation peak videos, correlation plots, and CCMS plots will be generated for depiction. Tilt-series videos and reconstruction videos will be made if requested (see Depiction Parameters below). Tilt-series need to have been coarsely aligned, either through Appion or manually, before this step. The Appion/Leginon database is not queried during this step.',
		'stack_info' : 'A stack of aligned images in rotated so that the tilt axis is parallel to the y-axis will be created. If a sampling > 1 is requested, a second stack will be created by binning the first stack. In addition, a script for binning will be created.<br><br>CTF correction will be performed if requested. If you select dose compensation, dose compensation will not be performed. Instead, a dose compensation script, stack_dose_compensate.py, will be created so that you can dose compensate the stack at a later time in case you wish to alter the images in any way (eg. TomoCTF correction).',
		'recon_info' : 'This step processes tilt-series through reconstructions based on the parameters in the param file provided by the user. No depictions will be made. Tilt-series need to have been aligned (either through Appion or manually) before this step. Normalization will be attempted first with EMAN2, then with EMAN1. The Appion/Leginon database is not queried to create the Reconstruction, but will be queried if Dose Compensaton is requested.',
		'recon_info2' : 'Weighted back-projection reconstruction. Maximum resolution of the resulting reconstruction will at best be 2*pixelsize*sampling. Normalization will be attempted first with EMAN2, then with EMAN1.<br><br>For single particle tomography (SPT), do not apply a lowpass filter. For segmentation, depiction, or other non-SPT purposes, consider applying a lowpass filter to reduce noise and reconstruction artifacts.',
		'screening_info' : 'Screening Mode is intended to be run as tilt-series are being collected. In screening mode the script will process all available tilt-series in a session sequentially beginning with the first, then wait for more tilt-series to appear and process those until the user manually stops the script at the command line. Screening mode will process tilt-series through the Preparation and Coarse Alignment steps, generating correlation peak videos, initial tilt-series videos, coarse aligned tilt-series videos, and reconstruction videos. This may allow the user to determine whether a specimen will be alignable using Protomo and to determine optimal parameters (dose, defocus, tilt range, etc.) in Leginon before collecting an entire session.',
		'defocus_info' : 'Here you will find parameters for determining the defocus of your tilt-series. Currently TomoCTF is supported.<br><br>It is recommended that you only use the estimated defocus from before refinement as long as the tilt azimuth is within a few degrees of being correct and the image shifts/rotations are known to be minimal.',
		'defocus_info2' : 'Here you will find parameters for determining the defocus of your tilt-series. Currently TomoCTF is supported.<br><br>Be aware that the defocus search range is fixed, so it is highly recommended that defocus be estimated in batch for ranges of tilt-series that have the same/similar nominal defoci.',
		'defocus_tlt' : 'Which iteration to use for determining the tilt-azimuth for defocus estimation.<br><br>TomoCTF defocus estimation requires the tilt-azimuth to be defined as accurately as possible. Luckily, Protomo refines the tilt-azimuth during tilt-series Refinement. Choose which iteration should be used to extract the tilt-azimuth.<br><br>Options: Best (by CCMS value), Best with binning of 1 or 2 (by CCMS value), Original (ie. as recorded in the database before alignment), or choose Iteration and enter an iteration number to the right (type: selection).',
		'amp_correct' : 'Correct for amplitude in addition to phase flipping? If turned on, a Wiener filter will be applied during CTF correction by strips, which is controlled by the two Wiener filter parameters to the right, w1 and w2 (see TomoCTF documentation) (type: selection).',
		'ctf_info' : 'CTF Correction requires that tilt-series images have already had their defocus estimated through the Appion interface such that the defocus and defocus confidence values have been inserted into the Leginon Database. The CTF correction algorithm first removes the low confidence defocus values, then removes defocus values that exceed one standard deviation from the tilt-series mean, and finally replaces those values with linearly interpolated values between the remaining high confidence defocus values in the tilt-series.<br><br>CTF correction is performed strip-by-strip using ctfphaseflip from the IMOD package (use v4.8.X only). Please use the citation below in publications.<br><br>Note: CTF correction will be performed before Dose Compensation, if requested. Generally if you are going to Dose Compensate the tilt images, you should CTF correct them first because the critical resolution limit is the first zero of the CTF curve.<br><br>Note: CTF correction does not work with tilt-series manually prepared from within Appion-Protomo.',
		'ctf_correct' : 'CTF correct tilt images using either TomoCTF (requires that a defocus value has already been entered into Appion-Protomo) or CTF correct with IMOD\'s ctfphaseflip using defocus values in the Appion/Leginon database.<br><br>Note: CTF correction may reduce the contrast of the objects in the image, so it is not recommended that CTF correction be performed before Appion-Protomo alignment (type: selection).',
		'auto_ctf_correct' : 'Apply CTF correction using defocus values in the Appion/Leginon database? CTF correction in Fully Automated mode will occur after File Preparation and before Coarse Alignment.',
		'defocus_estimate_info' : 'The estimated defocus of the untilted plane of the tilt-series as measured by TomoCTF using multiple different tile sizes and CTFMin values.<br><br>The goal is to identify the most accurately estimated defocus value by visually evaluating the ctf fit. The top-half of each ctf plot is a radial average of a background-subtracted power spectrum of height-compensated tiles extracted from each tilt-image. The bottom-half is the estimated ctf by TomoCTF given the top-half.<br><br>The user should make sure that the first zero (ie. the first dark strip on the left) matches on the top and bottom. A well-fit ctf will agree on the zeros of the ctf, beginning from left to right until the agreement disappears.<br><br>Either identify the best-fit ctf and record the defocus value for TomoCTF correction later or re-run defocus estimation with a more accurate search range.<br><br>Note: Defocus measurement depends on the accuracy of the tilt-azimuth.',
		'ctfplot_info' : 'The left plot shows the measured and interpolated defoci for the tilt-series.<br><br>The right plot shows the estimated CTF^2 in the tilt-series images. Note that ctfphaseflip only flips the phases and doesn\'t correct for the amplitude. Here we use the CTF and Envelope equations from section 3 of Frank, 2006 with q0=0.5 and a defocus spread of 750Å. This plot should accurately show the first CTF zero in the low angle tilt images, and may give an idea of how much signal attenuation there is at high frequencies.',
		'dose_info' : 'Dose compensation is performed by applying a lowpass filter based on the accumulated exposure of electrons on the sample. Dose compensation is modelled using equation (3) in Grant & Grigorieff, 2015 (citation below).<br><br>Note: CTF correction will be performed before Dose Compensation, if requested. Generally if you are going to Dose Compensate the tilt images, you should CTF correct them first because the critical resolution limit is the first zero of the CTF curve.<br><br>Note: If the tilt-series were uploaded to Appion/Leginon, then the dose will be taken to be 1 electron/angstrom^2.<br><br>Note: Dose compensation does not work with tilt-series manually prepared from within Appion-Protomo.',
		'dose_presets' : 'Either choose a preset value:<br>&nbsp&nbsp• Light: a=0.245, b=-1.8, c=12<br>&nbsp&nbsp• Moderate: a=0.245, b=-1.665, c=2.81<br>&nbsp&nbsp• Heavy: a=0.245, b=-1.4, c=2<br>or choose Advanced Settings + Custom Dose Compensation Type to input your own a, b, and c values.<br><br>To help determine values for a, b, and c, go here: tinyurl.com/grant2015dosecomp<br><br>You may dose compensate the images before refinement, after alignment, or both. For single particle-like objects in thin ice (<~100nm), it is recommended that the images be dose compensated with Moderate before alignment and reconstruction. For thick samples (>~200nm) replete with proteins and/or membranes such as cell lamella, Moderate dose compensation before alignment may introduce too much contrast (check the reconstruction videos). If this occurs, either re-run the alignment with Light dose compensation or without dose compensation to restore the contrast during alignment. After alignment it is recommended that images be dose compensated with Moderate before reconstruction. (type: string selection).',
		'doseplot_info' : 'The left plot shows the accumulated dose of each image as a function of the tilt angles as recorded in the Leginon database.<br><br>The right plot shows the applied dose compensation as a function of the accumulated dose (equation (3) in Grant & Grigorieff, 2015).<br><br>Use the left plot to determine how much information is present for a given angular range.',
		'driftplot_info' : 'This plot shows the maximum frame-to-frame drift for each tilt image, as determined by frame alignment performed with Appion.<br><br>The maximum drift is a critical resolution limit and so must be considered when deciding which tilt images to include during sub-volume alignment, for instance. In reality, the maximum drift is the minimum resolution limit because any non-uniform drift of the ojects of interest in x, y, or z between tilt images reduces the accuracy of tilt-series alignment. One possible way to recover the resolution imposed by non-uniform drift between tilt images is to perform tilt-series refinement on all particle tilt images (outside of Appion-Protomo), allowing for all Euler angles of each particle tilt image to refine.',
		'auto_info' : 'Fully Automated mode processes tilt-series in batch through File Preparation, CTF Correction (optional), Coarse Alignment, Refinement, Dose Compensation (optional), and Reconstruction. Rounds 1 through 3 proceed without a check for convergence. Rounds 4 and 5 include a check for convergence. If convergence is not reached by the end of Round 5, a further 3 Rounds will be run with scaling turned on and tilt axis elevation turned on half way through.<br><br>A restricted set of parameters are given. Default values aim for an exhaustive tilt image geometry search.',
		'exporting_info' : 'Export tilt-series from the Leginon database (unaligned), formatted for easy import to Appion-Protomo (Docker or native version). Each tilt-series will be made into an mrc stack with a corresponding SerialEM-formatted mdoc file containing all of the tilt-series\' meta-information.',
		'quality_assessment' : 'The left plot shows the sum of the average correction factors and their standard deviations for shifts (orange), rotations (cyan), and/or scale (orange) (CCMS = Combined Correction Mean plus Standard deviation), together with their scaled sum (black) for each iteration. Generally lower is better.<br><br>The top right plot shows the refinement of the tilt azimuth for each iteration.<br><br>The middle right plot shows the refinement of the orientation angles for each iteration.<br><br>The bottom right plot shows the refinement of the tilt elevation for each iteration.<br>*Click on a plot to view them full-size.',
		'quality_assessment2' : 'Each Protomo refinement iteration begins with creating a preliminary back-projection of the 0° tilt image, from which a projection of the first positive tilt is made. The corresponding tilt image is then aligned to this projection. With these two aligned images, a second preliminary back-projection is created, from which a projection of the first negative tilt is made. The corresponding tilt image is then aligned to this projection. This continues on (+, -, +, -, …) until all tilt images are aligned (rotation, translation, and/or scaling) to their respective preliminary back-projection. A final back-projection is then created, to which each freshly shifted, rotated, and/or scaled image is compared with and correction factors between the previous and current iteration are outputted.<br><br>To estimate the quality of a tilt-series, the correction factors for each variable are averaged and the standard deviation of each is calculated. Plotted here are the sums of the average correction factors and the standard deviations:<br><br>CCMS(X) = Avg(corr(X))+Stdev(corr(X))<br><br>where X are the shifts and scaling correction factors (orange) and the rotation correction factors (cyan) for each image. A candidate iteration for a well aligned tilt-series will have CCMS(shifts) and CCMS(scalings) each below 0.02 and CCMS(rotations) below 0.5° at a binning of 1 or 2. The scaled sum of CCMS(shifts), CCMS(scale), and CCMS(rotations) is plotted as a simple metric for quickly assessing the quality of all iterations. One should also check that the tilt azimuth, orientation angle, and/or tilt elevation have converged.',
		'quality_assessment_batch' : 'Each plot shows the sum of the average correction factors and their standard deviations for shifts (orange), rotations (cyan), and/or scale (orange) (CCMS = Combined Correction Mean plus Standard deviation), together with their scaled sum (black) for each iteration. Generally lower is better. Click on a plot to go to the Refinement Summary webpage for the corresponding tilt-series.',
		
	},
	'basicrefine' : {
		'outerMaskRadius' : 'The radius of the mask to apply to the particle from the center to the outer edge.',
		'innerMaskRadius' : 'The radius of the mask to apply to the particle from the center to the inner edge.',
		'outerAlignRadius' : 'The outer particle radius taken into account during 2D alignment. (Should be about half the size of the longest particle dimension.)',
		'innerAlignRadius' : 'The inner particle radius taken into account during 2D alignment. (This value can be greater than zero for hollow particles.)',
		'symmetry' : 'Imposes symmetry on the model, omit this option for no/unknown symmetry<BR/>Examples: c1, c2, d7, etc.',
		'endIter' : 'Total number of refinement iterations to perform.',
		'angSampRate' : 'Angular step for projections in degrees.',
		'percentDiscard' : 'Percentage of worst images to discard.',
		'filterEstimated' : 'Filter reconstructed volume to the estimated resolution.',
		'filterResolution' : 'The estimated resolution of the reconstruction.',
		'filterComputed' : 'Filter the reconstructed volume to the resolution computed by FSC.',
		'filterConstant' : 'Constant value to add to computed filter value. Units refer to the digital frequency. For example, if your model has an FSC of 10 Angstroms with a pixel size of 1.63, the digital frequency value is (1.63 / 10) = 0.163. Adding 0.01 to this means that the resulting model will be filtered to 1.63/(0.163+0.01) = 9.42 Angstroms. Keep this value relatively low.',		
	},	
	'eman' : {
/**
* these should be separate
**/
		'nodes' : 'Nodes refers to the number of computer to process on simultaneously.  The more nodes you get the faster things will get process, but more nodes requires that you wait longer before being allowed to begin processing.',
		'imask' : 'Radius of internal mask (in pixels)',
		'walltime' : 'Wall time, also called real-world time or wall-clock time, refers to elapsed time as determined by a chronometer such as a wristwatch or wall clock.  (The reference to a wall clock is how the term originally got its name.)',
		'cputime' : 'Wall time, also called real-world time or wall-clock time, refers to elapsed time as determined by a chronometer such as a wristwatch or wall clock.  (The reference to a wall clock is how the term originally got its name.)',
		'memory' : 'Amount of memory needed per node (not per processor)',
		'procpernode' : 'Processors per node.  If each computer (node) has 4 processors (procs), then proc/node=4.  For some cases, you may want to use less processors on each node, leaving more memory and system resources for each process.',
		'ang' : 'Angular step for projections (in degrees)',
		'itn' : 'Iteration Number',
		'copy' : 'Duplicate the parameters for this iteration',
		'mask' : 'Radius of external mask (in pixels)',
		'imask' : 'Radius of internal mask (in pixels)',
		'amask' : '<b>amask=[r],[threshold],[iter]</b><br />Must be used in conjunction with xfiles - This option applies an automatically generated \'form fitting\' soft mask to the model after each iteration.  The mask generation is generally quite good.  It uses 3 values :<br />First - the smallest radius from the center of the map that contacts some density of the \'good\' part of the map.<br />Second - A threshold density at which all of the undesirable density is disconnected from the desired mass.<br />Third - A number of 1-voxel \'shells\' to include after the correct density has been located (this allows you to use threshold densities higher than the desired isosurface threshold density).  The iterative shells will include a \'soft\' Gaussian edge after 2 pixels.  ie - if you add 8 shells, the density will decay in this region using a 1/2 width of 3 pixels starting at the 3rd pixel.  If the number of shells is specified as a negative value, then the mask will have a sharp edge, and any hollow areas inside the mask will be filled in.',
		'sym' : 'Imposes symmetry on the model, omit this option for no/unknown symmetry<BR/>Examples: c1, c2, d7, etc.',
		'hard' : 'Hard limit for <I>make3d</I> program.  This specifies how well the class averages must match the model to be included, 25 is typical',
		'maxshift' : 'Maximum translation during image alignment (in pixels)',
		'classkeep' : '<b>classkeep=[std dev multiplier]</b><br />This determines how many raw particles are discarded for each class-average.  This is defined in terms of the standard-deviation of the self-similarity of the particle set.  A value close to 0 (should not be exactly 0) will discard about 50% of the data.  1 is a typical value, and will typically discard 10-20% of the data.',
		'classiter' : 'Generation of class averages is an iterative process.  Rather than just aligning the raw particles to a reference, they are iteratively aligned toeach other to produce a class-average representative of the data, not of the model, eliminating initial model bias.  Typically set to 8 in the early rounds and 3 in later rounds - 0 may be used at the end, but model bias may result.',
		'filt3d' : '<b>fil3d=[rad]</b><br />Applies a gaussian low-pass filter to the 3D model between iterations.  This can be used to correct problems that may result in high resolution terms being upweighted.  [rad] is in pixels, not &Aring;ngstr&ouml;ms',
		'shrink' : '<b>shrink=[n]</b><br /><i>Experimental</i>, Another option that can produce dramatic speed improvements.  In some cases, this option can actually produce an improvement in classification accuracy.  This option scales the particles and references down by a factor of [n] before classification.  Since data is often heavily oversampled, and classification is dominated by low resolution terms, this can be both safe, and actually improve classification by \'filtering\' out high resolution noise.  Generally shrink=2 is safe and effective especially for early refinement.  In cases of extreme oversampling, larger values may be ok.  This option should NOT be used for the final rounds of refinement at high resolution.',
		'euler2' : '<b>euler2=[oversample factor]</b><br /><i>Experimental</i>, This option should improve convergence and reconstruction quality, but has produced mixed results in the past.  It adds an additional step to the refinement process in which class-averages orientations are redetermined by projection-matching.  The parameter allows you to decrease the angular step (ang=) used to generateprojections.  ie - 2 would produce projections with angular step of ang/2.  It may be worth trying, but use it with caution on new projects.',
		'perturb' : '<i>Experimental</i>, potentially useful and at worst should be harmless.  Has not been well characterized yet.  Rather than generating Euler angles at evenly spaced positions, it adds some randomness to the positions.  This should produce a more uniform distribution of data in 3D Fourier space and reduce Fourier artifacts',
		'xfiles' : '<b>xfiles=[mass in kD]</b><br />A convenience option.  For each 3D model it will produce a corresponding x-file (threed.1a.mrc -> x.1.mrc).  Based on the mass, the x-file will be scaled so an isosurface threshold of 1 will contain the specified mass.',
		'tree' : 'This can be a risky option, but it can produce dramatic speedups in the refinement process.  Rather than comparing each particle to every reference, this will decimate the reference population to 1/4 (if 2 is specified) or 1/9 (if 3 is specified) of its original size, classify, then locally determine which of the matches is best.  Is is safest in conjunction with very small angular steps, ie - large numbers of projections.  The safest way to use this is either:<br /><i>a)</i> for high-resolution, small-ang refinement or <br/><i>b)</i> for the initial iterations of refinement (then turn it off for the last couple of iterations).',
		'median' : 'When creating class averages, use the median value for each pixel instead of the average.  Not recommended for larger datasets, as it can result in artifacts.  If your dataset is noisy, and has small particles this is recommended',
		'phasecls' : 'This option will use signal to noise ratio weighted phase residual as a classification criteria (instead of the default optimized real space variance).  Over the last year or so, people working on cylindrical structures (like GroEL), have noticed that \'side views\' of this particle seem to frequently get classified as being tilted 4 or 5 degrees from the side view.  While apparently this didn\'t effect the models significantly at the obtained resolution, it is quite irritating.  This problem turns out to be due to resolution mismatch between the 3D model and the individual particles.  Using phase residual solves this problem, although it\'s unclear if there is any resolution improvement.  This option has a slight speed penalty',
		'fscls' : 'An improvement, albeit an experimental one, over phasecls.  phasecls ignores Fourier amplitude when making image comparisons.  fscls will use a SNR weighted Fourier shell correlation as a similarity criteria.  Preliminary tests have shown that this produces slightly better results than phasecls, but it should still be used with caution.',
		'refine' : 'This will do subpixel alignment of the particle translations for classification and averaging.  May have a significant impact at higher resolutions (with a speed penalty).',
		'goodbad' : 'Saves good and bad class averages from 3D reconstruction.  Overwrites each new iteration.',
		'eotest' : 'Run the <I>eotest</I> program that performs a 2 way even-odd test to determine the resolution of a reconstruction.',
		'coran' : 'Use correspondence analysis particle clustering algorithm',
		'coranCC' : 'During correspondence analysis, all resulting class averages that have a correlation coefficient equal to or higher than this value will be used in the final class average. If none meet this criteria, then the single average that has the highest CC is used. Value must be 0-1',
		'coranmask' : 'Defines a radius (in pixels) from center of image to be used for correspondence analysis. Only image data within this radius will be used for reference-free classification. This mask is NOT used in calculation of CCs to the model projection.', 
		'coranlp' : 'low-pass filter the particles for reference-free classification (in &Aring;ngstr&ouml;ms). Unfiltered particles are used to create the class average.',
		'coranhp' : 'high-pass filter the particles for reference-free classification (in &Aring;ngstr&ouml;ms). Unfiltered particles are used to create the class average.',

		'affprop' : 'Use affinity propagation particle clustering algorithm',
		'affpropCC' : 'During affinity propagation clustering, all resulting class averages that have a correlation coefficient equal to or higher than this value will be used in the final class average. If none meet this criteria, then the single average that has the highest CC is used. Value must be 0-1',
		'affpropMP' : 'Defines the minimum number of particles needed for affinity propagation to run. If the minimum is not met the algorithm is skipped',

	},

	'spider' : {
		'mask' : 'Radius from center of particle to outer edge (in pixels). Everything further will be masked after each iteration',
		'imask' : 'Inner masking radius (in pixels).',
		'lp' : 'Particles can be low-pass filtered for projection-matching, specify the amount here (in &Aring;ngstr&ouml;ms).  The raw, unfiltered data is used for the back-projection.',
		'hp' : 'Particles can be high-pass filtered for projection-matching, specify the amount here (in &Aring;ngstr&ouml;ms).  The raw, unfiltered data is used for the back-projection.',
		'firstring' : 'Used in determination of rotational alignment. Any pixels this far away from the center will not be used in the analysis. If you have an empty virus caspid, for example, enter a value that is a few pixels smaller than the particle radius.',
		'lastring' : 'Used in determination of rotational alignment. Only pixels this far from the center will be used in the analysis.',
		'xysearch' : 'Translational search during projection matching will be limited to this many pixels from the center of the image',
		'xyshift' : 'During projection-matching, particles will only be allowed to shift this far from the center of the image. This value is a percentage of the total box size (0-1).  For example, if using a box size of 256, an xyshift value of 0.2 will allow the particle to move a maximum distance of 52 pixels from its original location.',
		'keep' : 'Used to determine which particles are kept for use in the back-projection.  This value sets the particle cutoff in terms of sigma levels above or below the mean cross-correlation.  A value of 0 only keeps the particles that have an equal or better cc value than the mean. The higher the value entered here, the fewer (but better correlated) particles that are used.  A value of -1 will include particles that are 1 standard deviation worse than the mean cc value in the back projection.',
		'voliter' : 'Maximum number of iterative back-projection cycles to perform, in order to properly determine the relative weights of the low to high frequencies.',
		'lambda' : 'Controls the speed of convergence during iterative back-projection.  Too small a value will result in a structure that has high frequencies underrepresented, and will appear very smooth. Too large a value will terminate the iterations too soon, and the resulting structure will be incorrect.',
		'smooth' : 'Determines the relative weight of the low-pass filtration. 0 means no smoothing.  To achieve stronger low-pass filtration, one can decrease lambda and increase the smoothing constant.',
		'ang_inc' : 'A list of angular increments for projection matching, separated by commas.',
	},
	
	'frealign' : {
		'emaninit' : 'Converts Euler angles and shifts from earlier processing (using EMAN, XMIPP etc.). This should be done whenever possible as Frealigns global search may introduce alignment errors and it requires substantial computing power.',
		'ctffindonly' : 'Only CTF values estimated using CTFFIND3 will be used for correcting the CTF',
		'ctftilt' : 'Only CTF values estimated using CTFTILT will be used for correcting the CTF',
		'paramonly' : 'Exports a Frealign particle parameter file to further use outside of Appion.',
		'fmag' : 'Enables refinement of magnification on a per micrograph basis. Should only be used in rare cases when the signal in the images is sufficiently strong, such as with large virus particles.',
		'fdef' : 'Enables refinement of defocus. Should only be used in rare cases when the signal in the images is sufficiently strong, such as with large virus particles.',
		'fpart' : 'Enables defocus refinement on a per particle basis. This option is only active when Defocus refinement is active.',
		'fbeaut' : 'Applies particle symmetry in real space. Symmetry is always applied in reciprocal space but depending on the symmetry, there are small interpolation errors that might be visible when examining the density map in real space. This should not affect the refinement and quality of the map but is not ideal when making figures for publications. Therefore, this option should be off during refinement but could be switched on for the final reconstruction (if deviations from symmetry are noticeable in the map).',
		'ffilt' : 'Applies a low-pass filter to the reconstruction based on signal-to-noise estimates from the data. This should be used to generate an optimally filtered map. See Sindelar & Grigorieff (JSB 2012) for more details. IMPORTANT: If further averaging is done after Frealign reconstruction (e.g. non-icosahedral averaging on icosahedral viruses), this option should be disabled.',
		'fbfact' : 'Corrects the reconstruction for any B-factor that attenuates high-resolution signal. It also imposes a resolution cut-off based on the FSC curve (FSC = 0.143). This option should be used with caution as the B-factor estimation sometimes fails. If it fails a B-factor should be applied separately (using bfactor.exe, for example, see Grigorieff lab software download page).',
		'pbc' : 'Enables per particle weighting during reconstruction. This may improve the quality of the reconstruction if particles differ noticeably in their phase residual determined by Frealign. Alternatively, a certain percentage of particles can be excluded (see box "percentage of worst images to discard").',
		'lp' : 'Low-pass filter applied by Frealign to the particle images before refinement. As a rule, this limit should not significantly exceed 10 Å in most cases because it will worsen the alignment. It also helps limit over-fitting of noise. For example, if the FSC curve suggests a resolution that exceeds 10 Å even though no data beyond this resolution was used in the refinement, one can assume that the FSC curve is unbiased and that the reconstruction contains true signal at higher resolution.',
		'hp' : 'High-pass filter applied by Frealign to the particle images before refinement. As a rule, this filter should be set approximately to match the diameter of the particle.',
		'wgh' : 'Amplitude contrast used by Frealign to correct for the CTF. A value of 0.07 is commonly assumed for protein in ice while a value of 0.1 could be used for a protein-nucleic acid complex and 0.15 for negative stain. IMPORTANT: Choosing a negative value here will switch off CTF correction in Frealign. In this case, a CTF-corrected (e.g. phase flipped) particle image stack should be supplied on input with particle density light on dark background.',
		'psi' : 'Enables refinement of the Psi Euler angles (in-plane angle).',
		'theta' : 'Enables refinement of the Theta Euler angles (out-of-plane angle).',
		'phi' : 'Enables refinement of the Phi Euler angles.',
		'x' : 'Enables refinement of the X shifts.',
		'y' : 'Enables refinement of the Y shifts.',
	},
	'cluster' : {
		'processinghost' : 'The name of the processing computer to send this job to. ',
		'nodes' : 'Nodes refers to the number of computer to process on simultaneously.  The more nodes you get the faster things will get process, but more nodes requires that you wait longer before being allowed to begin processing.',
		'walltime' : 'Wall time, also called real-world time or wall-clock time, refers to elapsed time as determined by a chronometer such as a wristwatch or wall clock.  (The reference to a wall clock is how the term originally got its name.)',
		'cput' : 'Wall time, also called real-world time or wall-clock time, refers to elapsed time as determined by a chronometer such as a wristwatch or wall clock.  (The reference to a wall clock is how the term originally got its name.)',
		'ppn' : 'Processors per node.  If each computer (node) has 4 processors (procs), then proc/node=4.',
		'rpn' : 'Reconstructions per node.  For some cases, you may want to use less processors on each node, leaving more memory and system resources for each process. If each computer (node) has 4 processors (procs), but you want to use 2, then ppn=4 and rpn=2.  ',
		'mem' : 'Amount of memory needed per node (not per processor)',
		'remoteoutdir' : 'The full path to a directory for processing output located on the selected processing host.',
	},	
	'runparams' : {
		'runname' : 'Specifies the name associated with the processing results unique to the specified session and parameters.  An attempt to use the same run name for a session using different processing parameters will result in an error. The Default is automatically incremented',
		'description' : 'brief description attributed with the processing results',
		'outdir' : 'The base output directory to which files will be stored.  If you are testing, switch \"appion\" to \"temp\".  A subdirectory of the run name will be appended for actual output',
	},	
	'simple' : {
		'clip' : 'Clip the unbinned boxsize',
		'bin' : 'Binning of the image.  This takes any integer value, but powers of 2 are recommended. Binning quickly shrinks the image to help make the processing faster.',
                'alignlabel' : 'label to be appended to the presetname, e.g. --label=a gives ed-a as the aligned preset for preset ed.',
                'alignoffset' : 'number of frame offset in alignment in dosefgpu_driftcorr.',
                'alignccbox' : 'length of the square box in pixels in which cross correlation peak is searched in dosefgpu_driftcorr.  This must accomodate all shift and should be large if there are more frames ormore shift for best results.  However, larger box will make the program slower, too. Default 96 can take average of 2 pixel drift in each frames for 24 frames ( total of 48 pixel shift)',
                'alignbfactor' : 'alignment B-factor in pix^2 in dosefgpu_driftcorr.',
		'num-part' : 'number of particles to use',
		'no_center' : 'center the stack using EMAN’s cenalignint program prior to alignent and classification in SIMPLE. Note: SIMPLE does not search for translational parameters in “cluster”, but it does in “origami”. ; commandval = --no_center (only if unchecked, keep clear if checked).',
		'ring2' : 'last ring for alignment (in pixels)',
		'ncls' : 'Number of 2D classes to generate',
		'minp' : 'minimum number of particles per class',
		'nvars' : 'number of eigenvectors to use for clustering',
		'mask' : 'radius of external mask (in pixels)',
		'lp' : 'low-pass limit for origami reconstruction (in Angstroms)',
		'hp' : 'high-pass limit for origami reconstruction (in Angstroms). If you work with really large compelxes (lots of inelastic scattering), you may want to change this value',
		'froms' : 'tarting number of conformational states to classify (note: if you have 1 conformational state, you may still wish to use 2 in order to suck up bad particles)',
		'tos' : 'ending number of conformational states to classify (note: if you have 1 conformational state, you may still wish to use 2 in order to suck up bad particles)',
		'maxits' : 'maximum number of rounds for refinement',
		'mw' : 'molecular weight (in KDa)',
		'frac' : 'fraction of particles to include',
		'amsklp' : 'auto-masking parameter; low-pass filter value of the mask', 
		'edge' : 'size of softening of the molecular envelope (in pixels)',
		'trs': 'origin shift (in pixels)',
	},	
	'stackprep' : {
		'lastParticle' : 'Specifies the the last particle number in the stack to use for this processing run.',
		'lowpass' : 'please add a description in help.js',
		'highpass' : 'please add a description in help.js',
		'bin' : 'please add a description in help.js',
	},
	'xmipp' : {
		'mask' : 'Filename of a mask (0=outside particle; 1=inside particle)',
		'maxAngularChange' : 'Maximum change in rot & tilt  (in +/- degrees). You must specify this option for each iteration. This can be done by a sequence of numbers (for instance, "1000 1000 10 10 " specifies 4 iterations, the first two set the value to 1000 (no restriction) and the last two to 10degrees. An alternative compact notation is ("2x1000 2x10", i.e., 2 iterations with value 1000, and 2 with value 10). Note: if there are less values than iterations the last value is reused. Note: if there are more values than iterations the extra value are ignored',
		'maxChangeOffset' : 'Maximum allowed change in shift in the 3D+2D searches (in +/- pixels). Shifts larger than this value will be reset to (0,0) You must specify this option for each iteration.  This can be done by a sequence of numbers (for instance, "1000 1000 10 10 "  specifies 4 iterations, the first two set the value to 1000 (no restriction) and the last two to 10degrees. An alternative compact notation  is ("2x1000 2x10", i.e., 2 iterations with value 1000, and 2 with value 10). Note: if there are less values than iterations the last value is reused. Note: if there are more values than iterations the extra value are ignored',
		'search5DShift' : 'Give search range from the image center for 5D searches (in +/- pixels). Values larger than 0 will results in 5D searches (which may be CPU-intensive) Give 0 for conventional 3D+2D searches.  Note that after the 5D search, for the optimal angles always  a 2D exhaustive search is performed anyway (making it ~5D+2D) Provide a sequence of numbers (for instance, "5 5 3 0" specifies 4 iterations, the first two set the value to 5, then one with 3, resp 0 pixels. An alternative compact notation is ("3x5 2x3 0", i.e., 3 iterations with value 5, and 2 with value 3 and the rest with 0). Note: if there are less values than iterations the last value is reused Note: if there are more values than iterations the extra value are ignored',
		'search5DStep' : 'Provide a sequence of numbers (for instance, "2 2 1 1" specifies 4 iterations, the first two set the value to 2, then two with 1 pixel. An alternative compact notation is ("2x2 2x1", i.e., 2 iterations with value 2, and 2 with value 1). Note: if there are less values than iterations the last value is reused Note: if there are more values than iterations the extra value are ignored',
		'reconMethod' : 'Provide a sequence of methods (fourier, wbp, art). See http://xmipp.cnb.csic.es/twiki/bin/view/Xmipp/Wbp and http://xmipp.cnb.csic.es/twiki/bin/view/Xmipp/Mpi_wbp and http://xmipp.cnb.csic.es/twiki/bin/view/Xmipp/Art http://xmipp.cnb.csic.es/twiki/bin/view/Xmipp/Fourier http://xmipp.cnb.csic.es/twiki/bin/view/Xmipp/Mpi_fourier for details',
		'ARTLambda' : 'IMPORTANT: you must specify a value of lambda for each iteration even if art has not been selected. IMPORTANT: NOte that we are using the WLS version of ART that  uses geater lambdas than the plain art. See http://xmipp.cnb.csic.es/twiki/bin/view/Xmipp/Art for details You must specify this option for each iteration.  This can be done by a sequence of numbers (for instance, ".1 .1 .3 .3"  specifies 4 iterations, the first two set the value to 0.1  no restriction) and the last  two to .3. An alternative compact notation  is ("2x.1 2x.3"). Note: if there are less values than iterations the last value is reused Note: if there are more values than iterations the extra value are ignored',
		'doComputeResolution' : '0=Do not compute resolution; 1=Compute resolution (FSC)',
		'fourierMaxFrequencyOfInterest' : 'This number is only used in the first iteration.  From then on, it will be set to resolution computed in the resolution section',
	},
	'xmippml3d' : {
		'ImagesArePhaseFlipped' : 'The phases of the raw images have been flipped according to the CTF estimation. You can run MLF with or without having phase flipped the images',
		'ProjMatchSampling' : 'Angular incremement of projections ONLY for the grey-scale correction. As the resolution of the intial reference should be low, this sampling can be relatively crude, e.g. 15.',
		'LowPassFilter' : 'low-pass filter of the initial reference. It is highly recommended to low-pass filter your initial reference volume as much as you can',
		'NumberOfReferences' : 'number of classes to compute',
		'DoCorrectGreyScale' : 'Correct greyscale values for all images before performing ML3D. This is done using a single iteration of projection-matching with the ProjMatchSampling value specified. The probabilities computed during ML3D are based on squared differences, so that the absolute grey scale is important',
	},
	'relion' : {
		'ctf' : 'If set to Yes, CTFs will be corrected inside the MAP refinement. The resulting algorithm intrinsically implements the optimal linear, or Wiener filter. Note that CTF parameters for all images need to be given in the input STAR file. The command "relion_refine --print_metadata_labels" will print a list of all possible metadata labels for that STAR file. See the RELION Wiki for more details. Also make sure that the correct pixel size (in Angstrom) is given above!)',
		'ctf_intact_first_peak' : 'If set to Yes, then CTF-amplitude correction will only be performed from the first peak of each CTF onward. This can be useful if the CTF model is inadequate at the lowest resolution. Still, in general using higher amplitude contrast on the CTFs (e.g. 10-20%) often yields better results. Therefore, this option is not generally recommended: try increasing amplitude contrast (in your input STAR file) first!',
		'ctf_corrected_ref' : 'Set this option to Yes if the reference map represents density that is unaffected by CTF phases and amplitudes, e.g. it was created using CTF correction (Wiener filtering) inside RELION or from a PDB. If set to No, then in the first iteration, the Fourier transforms of the reference projections are not multiplied by the CTFs.',
		'ini_high' : 'It is recommended to strongly low-pass filter your initial reference map. If it has not yet been low-pass filtered, it may be done internally using this option. If set to 0, no low-pass filter will be applied to the initial reference(s).',
		'healpix_order' : 'There are only a few discrete angular samplings possible because we use the HealPix library to generate the sampling of the first two Euler angles on the sphere. The samplings are approximate numbers and vary slightly over the sphere. If auto-sampling is used, this will be the value for the first iteration(s) only, and the sampling rate will be increased automatically after that.',
		'auto_local_healpix_order' : 'In the automated procedure to increase the angular samplings, local angular searches of -6/+6 times the sampling rate will be used from this angular sampling rate onwards.',
		'offset_range' : 'Probabilities will be calculated only for translations in a circle with this radius (in pixels). The center of this circle changes at every iteration and is placed at the optimal translation for each image in the previous iteration. If auto-sampling is used, this will be the value for the first iteration(s) only, and the sampling rate will be increased automatically after that.',
		'offset_step' : 'Translations will be sampled with this step-size (in pixels).Translational sampling is also done using the adaptive approach. Therefore, if adaptive=1, the translations will first be evaluated on a 2x coarser grid. If auto-sampling is used, this will be the value for the first iteration(s) only, and the sampling rate will be increased automatically after that.',
	},
	'ddstack': {
		'ddstack': 'Choose an dd frame stack',
		'transfer2ddstack':'Apply the transfer not on the original image where the stack came from but to its associated (aligned) image of the specified ddstackrun',
	},
	'makeDDStack' : {
		'align' : 'Select to align the images.',
		'defergpu' : 'Select defer gpu if this job will be launched on a computer without GPU capability. The alignment can be done after building the stack by running catchUpDDAlign.py',
		'bin' : 'Binning of the image.  This takes any integer value, but powers of 2 are recommended. Binning quickly shrinks the image to help make the processing faster.',

                'alignlabel' : 'label to be appended to the presetname, e.g. --label=a gives ed-a as the aligned preset for preset ed.',
                'alignoffset' : 'number of frame offset in alignment in dosefgpu_driftcorr.',
                'alignccbox' : 'length of the square box in pixels in which cross correlation peak is searched in dosefgpu_driftcorr.  This must accomodate all shift and should be large if there are more frames ormore shift for best results.  However, larger box will make the program slower, too. Default 96 can take average of 2 pixel drift in each frames for 24 frames ( total of 48 pixel shift)',
                'alignbfactor' : 'alignment B-factor in pix^2 in dosefgpu_driftcorr.',
		'no_keepstack' : 'Remove any ddstack generated after it is used for alignment and generating aligned sum image to upload. If the stack is needed later. run the same script under the same run but remove --no-keepstack flag, change --commit to --no-commit and change --conitnue to --no-continue.',
		'ddstartframe' : 'The frame number to begin with for the frame sum. 0 is the first frame acquired.',
		'ddnframe' : 'The total number of frames that will be used for the sum. Leave blank to default to all frames.',
	},		
	'em_hole_finder' : {
		'downsample' : 'The amount the image is down sampled before being process for masking. This is done to increase the speed of the algorithm.',
		'compsizethresh' : 'The size of the smallest component that is considered by the algorithm.',
		'adapthresh' : 'The size of the window that is used to threshold each pixel. Each pixel is compared to the distribution of pixels in its window.',
		'blur' : 'The size of the window for the blur function.',
		'dilation' : 'The amount the masked area is dilated to make the algorithm more conservative.',
		'erosion' : 'The amount the thresholded areas are eroded to break small bridges between separate components.',
	},		
	'protomo' : {
		'sessionname' : 'For example, sessionname=14apr15c (type: string)',
		'projectid' : 'This should be the same number as the \'expid\' number in your address bar (type: int).',
		'tiltseries' : 'This is the tiltseries number, recorded chronologically during a session (type: int).',
		'commit' : 'Set to true if you want to commit this run to the database.',
		'shift_limit' : 'Percentage of (x,y) shift, above which the images in the initial .tlt file will be discarded. <i>You probably don\'t want to change this!</i><br/><br/>The Python script will first query the Leginon database to locate the tilt-series images and to create a *.tlt file. During imaging, Leginon attempts to measure the relative (x,y) shifts for each image in the tilt-series. Occasionally the shifts are wildly incorrect, causing Protomo to fail during the coarse alignment. This parameter allows you to discard the overly shifted images if one or more x or y shifts exceed the given percentage of the x or y dimensions of the image (type: float).',
		'angle_limit' : 'Tilt angles below this value, in degrees, will not be removed by the Shift Limit parameter. This parameter restricts the removal of images from the tilt-series to only high angle tilts. e.g. A value of 40 will allow any image with abs(tilt angle) greater than 40 degrees to be removed if it is overly shifted. (type: float).',
		'region_x' : 'Pixels in x to use for region matching. The Search Area Parameter Preset changes this value. This number will be binned by the requested sampling before alignment. It is recommended that you make the Window Size/Sampling a number that only has prime factors of 2, 3, or 5. Window Size (x) must be less than or equal to the dimensions in (x) of the Raw Images (type: int).',
		'region_y' : 'Pixels in y to use for region matching. The Search Area Parameter Preset changes this value. This number will be binned by the requested sampling before alignment. It is recommended that you make the Window Size/Sampling a number that only has prime factors of 2, 3, or 5. Window Size (y) must be less than or equal to the dimensions in (y) of the Raw Images (type: int).',
		'r1_region_x' : 'Pixels in x to use for region matching for Round 1. The Search Area Parameter Preset changes this value. This number will be binned by the requested sampling before alignment. It is recommended that you make the Window Size/Sampling a multiple of 2, 3, or 5. Window Size (x) must be less than or equal to the dimensions in (x) of the Raw Images (type: int).',
		'r2_region_x' : 'Pixels in x to use for region matching for Round 2. The Search Area Parameter Preset changes this value. This number will be binned by the requested sampling before alignment. It is recommended that you make the Window Size/Sampling a multiple of 2, 3, or 5. Window Size (x) must be less than or equal to the dimensions in (x) of the Raw Images (type: int).',
		'r3_region_x' : 'Pixels in x to use for region matching for Round 3. The Search Area Parameter Preset changes this value. This number will be binned by the requested sampling before alignment. It is recommended that you make the Window Size/Sampling a multiple of 2, 3, or 5. Window Size (x) must be less than or equal to the dimensions in (x) of the Raw Images (type: int).',
		'r4_region_x' : 'Pixels in x to use for region matching for Round 4. The Search Area Parameter Preset changes this value. This number will be binned by the requested sampling before alignment. It is recommended that you make the Window Size/Sampling a multiple of 2, 3, or 5. Window Size (x) must be less than or equal to the dimensions in (x) of the Raw Images (type: int).',
		'r5_region_x' : 'Pixels in x to use for region matching for Round 5. The Search Area Parameter Preset changes this value. This number will be binned by the requested sampling before alignment. It is recommended that you make the Window Size/Sampling a multiple of 2, 3, or 5. Window Size (x) must be less than or equal to the dimensions in (x) of the Raw Images (type: int).',
		'r1_region_y' : 'Pixels in y to use for region matching for Round 1. The Search Area Parameter Preset changes this value. This number will be binned by the requested sampling before alignment. It is recommended that you make the Window Size/Sampling a multiple of 2, 3, or 5. Window Size (y) must be less than or equal to the dimensions in (y) of the Raw Images (type: int).',
		'r2_region_y' : 'Pixels in y to use for region matching for Round 2. The Search Area Parameter Preset changes this value. This number will be binned by the requested sampling before alignment. It is recommended that you make the Window Size/Sampling a multiple of 2, 3, or 5. Window Size (y) must be less than or equal to the dimensions in (y) of the Raw Images (type: int).',
		'r3_region_y' : 'Pixels in y to use for region matching for Round 3. The Search Area Parameter Preset changes this value. This number will be binned by the requested sampling before alignment. It is recommended that you make the Window Size/Sampling a multiple of 2, 3, or 5. Window Size (y) must be less than or equal to the dimensions in (y) of the Raw Images (type: int).',
		'r4_region_y' : 'Pixels in y to use for region matching for Round 4. The Search Area Parameter Preset changes this value. This number will be binned by the requested sampling before alignment. It is recommended that you make the Window Size/Sampling a multiple of 2, 3, or 5. Window Size (y) must be less than or equal to the dimensions in (y) of the Raw Images (type: int).',
		'r5_region_y' : 'Pixels in y to use for region matching for Round 5. The Search Area Parameter Preset changes this value. This number will be binned by the requested sampling before alignment. It is recommended that you make the Window Size/Sampling a multiple of 2, 3, or 5. Window Size (y) must be less than or equal to the dimensions in (y) of the Raw Images (type: int).',
		'sampling' : 'Sampling rate of Raw Images. To avoid extra interpolations, choose a value that is divisible by 2 (type: int >= 1 and <= 15).',
		'r1_sampling' : 'Sampling rate of Raw Images for Round 1. For fastest alignment, choose a value that is evenly divisible by 2. It is recommended to keep this value 10 or below. Multiple Refinement iterations performed with a Sampling of 2 or 1 are highly recommended (type: real >= 1 and <= 15).',
		'r2_sampling' : 'Sampling rate of Raw Images for Round 2. For fastest alignment, choose a value that is evenly divisible by 2. It is recommended to keep this value 10 or below. Multiple Refinement iterations performed with a Sampling of 2 or 1 are highly recommended (type: real >= 1 and <= 15).',
		'r3_sampling' : 'Sampling rate of Raw Images for Round 3. For fastest alignment, choose a value that is evenly divisible by 2. It is recommended to keep this value 10 or below. Multiple Refinement iterations performed with a Sampling of 2 or 1 are highly recommended (type: real >= 1 and <= 15).',
		'r4_sampling' : 'Sampling rate of Raw Images for Round 4. For fastest alignment, choose a value that is evenly divisible by 2. It is recommended to keep this value 10 or below. Multiple Refinement iterations performed with a Sampling of 2 or 1 are highly recommended (type: real >= 1 and <= 15).',
		'r5_sampling' : 'Sampling rate of Raw Images for Round 5. For fastest alignment, choose a value that is evenly divisible by 2. It is recommended to keep this value 10 or below. Multiple Refinement iterations performed with a Sampling of 2 or 1 are highly recommended (type: real >= 1 and <= 15).',
		'r6_sampling' : 'Sampling rate of Raw Images for Round 6. For fastest alignment, choose a value that is evenly divisible by 2. It is recommended to keep this value 10 or below. Multiple Refinement iterations performed with a Sampling of 2 or 1 are highly recommended (type: int >= 1 and <= 15).',
		'r7_sampling' : 'Sampling rate of Raw Images for Round 7. For fastest alignment, choose a value that is evenly divisible by 2. It is recommended to keep this value 10 or below. Multiple Refinement iterations performed with a Sampling of 2 or 1 are highly recommended (type: int >= 1 and <= 15).',
		'r8_sampling' : 'Sampling rate of Raw Images for Round 8. For fastest alignment, choose a value that is evenly divisible by 2. It is recommended to keep this value 10 or below. Multiple Refinement iterations performed with a Sampling of 2 or 1 are highly recommended (type: int >= 1 and <= 15).',
		'map_sampling' : 'Sampling rate of Raw Images for use in summary reconstructions. Protomo will first create a weighted back-projection 3D reconstruction using the Sampling value in the General Parameters section, then a video will be made and resized to this value if it is greater than the first Sampling value. For unbinned reconstructions, make sure you have enough CPU time limit (type: real >= 1 and > Sampling).',
		'recon_map_sampling' : 'Sampling rate of Raw Images for use in reconstructions. To avoid extra interpolations, choose a value that is divisible by 2. For unbinned reconstructions, make sure you have enough CPU time limit and RAM (type: int >= 1 and <= 15).',
		'thickness' : 'Estimated thickness of unbinned specimen along the beam direction, in angstroms. \'Specimen\' refers to the object(s) near zero-tilt with the most contrast in the Raw Images.<br><br>If you are unsure, run a Coarse Alignment with the default value, watch the Reconstruction video, and determine whether the Window Size border covers all Z-slices where there is contrast from your object of interest in the tomogram. If necessary, increase/reduce the thickness accordingly and run Coarse Alignment again.<br/><br/>Tilt images in 3D fourier space only have one line in common. To align images, information about another degree of freedom is required. Features with thickness \'t\' have fourier points with features at 1/t. Providing an estimate for this thickness allows features in fourier space less than 1/t to be aligned on. Protomo works best when this parameter is accurate to within 50% of the actual thickness.<br><br>Tip: Input multiple, comma-separated thickness values to run N refinement runs, where N is the number of thicknesses requested. Don\'t overload your machine! (type: float).',
		'maxtilt' : 'Highest tilt angle, in degrees (type: int).',
		'mask_width_x' : 'Rectangular mask size (x), in pixels. Default value is (Window Size (x)/Sampling) - 2.5*Apodization (x) (type: float).',
		'mask_width_y' : 'Rectangular mask size (y), in pixels. Default value is (Window Size (y)/Sampling) - 2.5*Apodization (y) (type: float).',		
		'lowpass_diameter_x' : 'Lowpass filter (x), in angstroms. This will filter out frequencies higher than the chosen value.<br/><br/>This is a critical parameter. If you don\'t filter out frequencies higher than the highest resolvable structure of your specimen, Protomo might align to noise (type: float).',
		'lowpass_diameter_y' : 'Lowpass filter (y), in angstroms. This will filter out frequencies higher than the chosen value.<br/><br/>This is a critical parameter. If you don\'t filter out frequencies higher than the highest resolvable structure of your specimen, Protomo might align to noise (type: float).',
		'highpass_diameter_x' : 'Highpass filter (x), in angstroms. This will filter out frequencies lower than the chosen value (type: float).',	
		'highpass_diameter_y' : 'Highpass filter (y), in angstroms. This will filter out frequencies lower than the chosen value (type: float).',	
		'mask_apod_x' : 'Apodization (x) for rectangular and ellipsoidal masks, in pixels. This value usually should not be changed.<br/><br/>Apodization is a set of bandpass filters applied to soften edges fourier space so that edges images are not aligned to edges and so that there are no edge ripples from fourier space inversion that would otherwise add ordered noise to the real space images (type: float).',
		'mask_apod_y' : 'Apodization (y) for rectangular and ellipsoidal masks, in pixels. This value usually should not be changed.<br/><br/>Apodization is a set of bandpass filters applied to soften edges fourier space so that edges images are not aligned to edges and so that there are no edge ripples from fourier space inversion that would otherwise add ordered noise to the real space images (type: float).',
		'lowpass_apod_x' : 'Lowpass apodization filter (x) for rectangular and ellipsoidal masks, in angstroms. Default value is 2.5 times Lowpass Filter (x) (type: float).',	
		'lowpass_apod_y' : 'Lowpass apodization filter (y) for rectangular and ellipsoidal masks, in angstroms. Default value is 2.5 times Lowpass Filter (y) (type: float).',			
		'highpass_apod_x' : 'Highpass apodization filter (x) for rectangular and ellipsoidal masks, in angstroms. Default value is Highpass Filter (x) divided by 2 (type: float).',		
		'highpass_apod_y' : 'Highpass apodization filter (y) for rectangular and ellipsoidal masks, in angstroms. Default value is Highpass Filter (y) divided by 2 (type: float).',
		'r1_mask_width_x' : 'Rectangular mask size (x) for Round 1, in pixels. Default value is (Window Size (x)/Sampling) - 2.5*Apodization (x) (type: float).',
		'r2_mask_width_x' : 'Rectangular mask size (x) for Round 2, in pixels. Default value is (Window Size (x)/Sampling) - 2.5*Apodization (x) (type: float).',
		'r3_mask_width_x' : 'Rectangular mask size (x) for Round 3, in pixels. Default value is (Window Size (x)/Sampling) - 2.5*Apodization (x) (type: float).',
		'r4_mask_width_x' : 'Rectangular mask size (x) for Round 4, in pixels. Default value is (Window Size (x)/Sampling) - 2.5*Apodization (x) (type: float).',
		'r5_mask_width_x' : 'Rectangular mask size (x) for Round 5, in pixels. Default value is (Window Size (x)/Sampling) - 2.5*Apodization (x) (type: float).',
		'r1_mask_width_y' : 'Rectangular mask size (y) for Round 1, in pixels. Default value is (Window Size (x)/Sampling) - 2.5*Apodization (x) (type: float).',
		'r2_mask_width_y' : 'Rectangular mask size (y) for Round 2, in pixels. Default value is (Window Size (x)/Sampling) - 2.5*Apodization (x) (type: float).',
		'r3_mask_width_y' : 'Rectangular mask size (y) for Round 3, in pixels. Default value is (Window Size (x)/Sampling) - 2.5*Apodization (x) (type: float).',
		'r4_mask_width_y' : 'Rectangular mask size (y) for Round 4, in pixels. Default value is (Window Size (x)/Sampling) - 2.5*Apodization (x) (type: float).',
		'r5_mask_width_y' : 'Rectangular mask size (y) for Round 5, in pixels. Default value is (Window Size (x)/Sampling) - 2.5*Apodization (x) (type: float).',
		'r1_lowpass_diameter_x' : 'Lowpass filter (x) for Round 1, in angstroms. This will filter out frequencies higher than the chosen value. If your correlation peaks are visible throughout the entire tilt-series, you may wish to lower the lowpass filter to include more high resolution information for refinement.<br/><br/>This is a critical parameter. If you don\'t filter out frequencies higher than the highest resolvable structure of your specimen, Protomo might align to noise. However, even with sub-pixel accuracy, if you don\'t make this value low enough this might impose a limit on the resolution of subvolume averaging (type: float).',			
		'r2_lowpass_diameter_x' : 'Lowpass filter (x) for Round 2, in angstroms. This will filter out frequencies higher than the chosen value. If your correlation peaks are visible throughout the entire tilt-series, you may wish to lower the lowpass filter to include more high resolution information for refinement.<br/><br/>This is a critical parameter. If you don\'t filter out frequencies higher than the highest resolvable structure of your specimen, Protomo might align to noise. However, even with sub-pixel accuracy, if you don\'t make this value low enough this might impose a limit on the resolution of subvolume averaging (type: float).',			
		'r3_lowpass_diameter_x' : 'Lowpass filter (x) for Round 3, in angstroms. This will filter out frequencies higher than the chosen value. If your correlation peaks are visible throughout the entire tilt-series, you may wish to lower the lowpass filter to include more high resolution information for refinement.<br/><br/>This is a critical parameter. If you don\'t filter out frequencies higher than the highest resolvable structure of your specimen, Protomo might align to noise. However, even with sub-pixel accuracy, if you don\'t make this value low enough this might impose a limit on the resolution of subvolume averaging (type: float).',			
		'r4_lowpass_diameter_x' : 'Lowpass filter (x) for Round 4, in angstroms. This will filter out frequencies higher than the chosen value. If your correlation peaks are visible throughout the entire tilt-series, you may wish to lower the lowpass filter to include more high resolution information for refinement.<br/><br/>This is a critical parameter. If you don\'t filter out frequencies higher than the highest resolvable structure of your specimen, Protomo might align to noise. However, even with sub-pixel accuracy, if you don\'t make this value low enough this might impose a limit on the resolution of subvolume averaging (type: float).',			
		'r5_lowpass_diameter_x' : 'Lowpass filter (x) for Round 5, in angstroms. This will filter out frequencies higher than the chosen value. If your correlation peaks are visible throughout the entire tilt-series, you may wish to lower the lowpass filter to include more high resolution information for refinement.<br/><br/>This is a critical parameter. If you don\'t filter out frequencies higher than the highest resolvable structure of your specimen, Protomo might align to noise. However, even with sub-pixel accuracy, if you don\'t make this value low enough this might impose a limit on the resolution of subvolume averaging (type: float).',
		'r1_lowpass_diameter_y' : 'Lowpass filter (y) for Round 1, in angstroms. This will filter out frequencies higher than the chosen value. If your correlation peaks are visible throughout the entire tilt-series, you may wish to lower the lowpass filter to include more high resolution information for refinement.<br/><br/>This is a critical parameter. If you don\'t filter out frequencies higher than the highest resolvable structure of your specimen, Protomo might align to noise. However, even with sub-pixel accuracy, if you don\'t make this value low enough this might impose a limit on the resolution of subvolume averaging (type: float).',		
		'r2_lowpass_diameter_y' : 'Lowpass filter (y) for Round 2, in angstroms. This will filter out frequencies higher than the chosen value. If your correlation peaks are visible throughout the entire tilt-series, you may wish to lower the lowpass filter to include more high resolution information for refinement.<br/><br/>This is a critical parameter. If you don\'t filter out frequencies higher than the highest resolvable structure of your specimen, Protomo might align to noise. However, even with sub-pixel accuracy, if you don\'t make this value low enough this might impose a limit on the resolution of subvolume averaging (type: float).',		
		'r3_lowpass_diameter_y' : 'Lowpass filter (y) for Round 3, in angstroms. This will filter out frequencies higher than the chosen value. If your correlation peaks are visible throughout the entire tilt-series, you may wish to lower the lowpass filter to include more high resolution information for refinement.<br/><br/>This is a critical parameter. If you don\'t filter out frequencies higher than the highest resolvable structure of your specimen, Protomo might align to noise. However, even with sub-pixel accuracy, if you don\'t make this value low enough this might impose a limit on the resolution of subvolume averaging (type: float).',		
		'r4_lowpass_diameter_y' : 'Lowpass filter (y) for Round 4, in angstroms. This will filter out frequencies higher than the chosen value. If your correlation peaks are visible throughout the entire tilt-series, you may wish to lower the lowpass filter to include more high resolution information for refinement.<br/><br/>This is a critical parameter. If you don\'t filter out frequencies higher than the highest resolvable structure of your specimen, Protomo might align to noise. However, even with sub-pixel accuracy, if you don\'t make this value low enough this might impose a limit on the resolution of subvolume averaging (type: float).',		
		'r5_lowpass_diameter_y' : 'Lowpass filter (y) for Round 5, in angstroms. This will filter out frequencies higher than the chosen value. If your correlation peaks are visible throughout the entire tilt-series, you may wish to lower the lowpass filter to include more high resolution information for refinement.<br/><br/>This is a critical parameter. If you don\'t filter out frequencies higher than the highest resolvable structure of your specimen, Protomo might align to noise. However, even with sub-pixel accuracy, if you don\'t make this value low enough this might impose a limit on the resolution of subvolume averaging (type: float).',	
		'r1_highpass_diameter_x' : 'Highpass filter (x) for Round 1, in angstroms. This will filter out frequencies lower than the chosen value (type: float).',
		'r2_highpass_diameter_x' : 'Highpass filter (x) for Round 2, in angstroms. This will filter out frequencies lower than the chosen value (type: float).',
		'r3_highpass_diameter_x' : 'Highpass filter (x) for Round 3, in angstroms. This will filter out frequencies lower than the chosen value (type: float).',
		'r4_highpass_diameter_x' : 'Highpass filter (x) for Round 4, in angstroms. This will filter out frequencies lower than the chosen value (type: float).',
		'r5_highpass_diameter_x' : 'Highpass filter (x) for Round 5, in angstroms. This will filter out frequencies lower than the chosen value (type: float).',		
		'r1_highpass_diameter_y' : 'Highpass filter (y) for Round 1, in angstroms. This will filter out frequencies lower than the chosen value (type: float).',		
		'r2_highpass_diameter_y' : 'Highpass filter (y) for Round 2, in angstroms. This will filter out frequencies lower than the chosen value (type: float).',		
		'r3_highpass_diameter_y' : 'Highpass filter (y) for Round 3, in angstroms. This will filter out frequencies lower than the chosen value (type: float).',		
		'r4_highpass_diameter_y' : 'Highpass filter (y) for Round 4, in angstroms. This will filter out frequencies lower than the chosen value (type: float).',		
		'r5_highpass_diameter_y' : 'Highpass filter (y) for Round 5, in angstroms. This will filter out frequencies lower than the chosen value (type: float).',	
		'r1_mask_apod_x' : 'Apodization (x) for rectangular and ellipsoidal masks for Round 1, in pixels. This value usually should not be changed (type: float).',		
		'r2_mask_apod_x' : 'Apodization (x) for rectangular and ellipsoidal masks for Round 2, in pixels. This value usually should not be changed (type: float).',	
		'r3_mask_apod_x' : 'Apodization (x) for rectangular and ellipsoidal masks for Round 3, in pixels. This value usually should not be changed (type: float).',	
		'r4_mask_apod_x' : 'Apodization (x) for rectangular and ellipsoidal masks for Round 4, in pixels. This value usually should not be changed (type: float).',	
		'r5_mask_apod_x' : 'Apodization (x) for rectangular and ellipsoidal masks for Round 5, in pixels. This value usually should not be changed (type: float).',	
		'r1_mask_apod_y' : 'Apodization (y) for rectangular and ellipsoidal masks for Round 1, in pixels. This value usually should not be changed (type: float).',	
		'r2_mask_apod_y' : 'Apodization (y) for rectangular and ellipsoidal masks for Round 2, in pixels. This value usually should not be changed (type: float).',	
		'r3_mask_apod_y' : 'Apodization (y) for rectangular and ellipsoidal masks for Round 3, in pixels. This value usually should not be changed (type: float).',	
		'r4_mask_apod_y' : 'Apodization (y) for rectangular and ellipsoidal masks for Round 4, in pixels. This value usually should not be changed (type: float).',	
		'r5_mask_apod_y' : 'Apodization (y) for rectangular and ellipsoidal masks for Round 5, in pixels. This value usually should not be changed (type: float).',		
		'r1_lowpass_apod_x' : 'Lowpass apodization filter (x) for rectangular and ellipsoidal masks for Round 1, in angstroms (type: float).',	
		'r2_lowpass_apod_x' : 'Lowpass apodization filter (x) for rectangular and ellipsoidal masks for Round 2, in angstroms (type: float).',	
		'r3_lowpass_apod_x' : 'Lowpass apodization filter (x) for rectangular and ellipsoidal masks for Round 3, in angstroms (type: float).',	
		'r4_lowpass_apod_x' : 'Lowpass apodization filter (x) for rectangular and ellipsoidal masks for Round 4, in angstroms (type: float).',
		'r5_lowpass_apod_x' : 'Lowpass apodization filter (x) for rectangular and ellipsoidal masks for Round 5, in angstroms (type: float).',	
		'r1_lowpass_apod_y' : 'Lowpass apodization filter (y) for rectangular and ellipsoidal masks for Round 1, in angstroms (type: float).',	
		'r2_lowpass_apod_y' : 'Lowpass apodization filter (y) for rectangular and ellipsoidal masks for Round 2, in angstroms (type: float).',	
		'r3_lowpass_apod_y' : 'Lowpass apodization filter (y) for rectangular and ellipsoidal masks for Round 3, in angstroms (type: float).',	
		'r4_lowpass_apod_y' : 'Lowpass apodization filter (y) for rectangular and ellipsoidal masks for Round 4, in angstroms (type: float).',	
		'r5_lowpass_apod_y' : 'Lowpass apodization filter (y) for rectangular and ellipsoidal masks for Round 5, in angstroms (type: float).',	
		'r1_highpass_apod_x' : 'Highpass apodization filter (x) for rectangular and ellipsoidal masks for Round 1, in angstroms (type: float).',	
		'r2_highpass_apod_x' : 'Highpass apodization filter (x) for rectangular and ellipsoidal masks for Round 2, in angstroms (type: float).',	
		'r3_highpass_apod_x' : 'Highpass apodization filter (x) for rectangular and ellipsoidal masks for Round 3, in angstroms (type: float).',	
		'r4_highpass_apod_x' : 'Highpass apodization filter (x) for rectangular and ellipsoidal masks for Round 4, in angstroms (type: float).',	
		'r5_highpass_apod_x' : 'Highpass apodization filter (x) for rectangular and ellipsoidal masks for Round 5, in angstroms (type: float).',	
		'r1_highpass_apod_y' : 'Highpass apodization filter (y) for rectangular and ellipsoidal masks for Round 1, in angstroms (type: float).',	
		'r2_highpass_apod_y' : 'Highpass apodization filter (y) for rectangular and ellipsoidal masks for Round 2, in angstroms (type: float).',	
		'r3_highpass_apod_y' : 'Highpass apodization filter (y) for rectangular and ellipsoidal masks for Round 3, in angstroms (type: float).',	
		'r4_highpass_apod_y' : 'Highpass apodization filter (y) for rectangular and ellipsoidal masks for Round 4, in angstroms (type: float).',	
		'r5_highpass_apod_y' : 'Highpass apodization filter (y) for rectangular and ellipsoidal masks for Round 5, in angstroms (type: float).',	
		'corr_mode' : 'Correlation mode: standard (xcf), mutual (mcf), phase only (pcf), phase doubled (dbl) (type: string).',		
		'raw_path' : 'Alternative full path to raw image files. Use if Appion doesn\'t find raw images automatically. If this option is used, then you will also need to place your own \'series%04d<tiltseriesnumber>.tlt\' file in the \'Run name\' directory if Leginon cannot query the Raw Image metadata. It is recommended, however, that you instead upload your tilt-series to the Leginon/Appion database and then process your tilt-series normally (type: string).',		
		'r1_iters' : 'Number of alignment and geometry refinement iterations for Round 1 (type: int).',
		'r2_iters' : 'Number of alignment and geometry refinement iterations for Round 2 (type: int).',
		'r3_iters' : 'Number of alignment and geometry refinement iterations for Round 3 (type: int).',
		'r4_iters' : 'Number of alignment and geometry refinement iterations for Round 4 (type: int).',
		'r5_iters' : 'Number of alignment and geometry refinement iterations for Round 5 (type: int).',
		'r6_iters' : 'Number of alignment and geometry refinement iterations for Round 6. If convergence is not met by Round 5, up to three more Rounds will be run with tilt axis elevation and scaling refinement turned on (immediately for scaling and half way through for elevation) (type: int).',
		'r7_iters' : 'Number of alignment and geometry refinement iterations for Round 7. If convergence is not met by Round 5, up to three more Rounds will be run with tilt axis elevation and scaling refinement turned on (immediately for scaling and half way through for elevation) (type: int).',
		'r8_iters' : 'Number of alignment and geometry refinement iterations for Round 8. If convergence is not met by Round 5, up to three more Rounds will be run with tilt axis elevation and scaling refinement turned on (immediately for scaling and half way through for elevation) (type: int).',
		'auto_convergence' : 'Stop refinement during Rounds 4 or 5 if each CCMS value is less this value. Set to zero to perform all iterations (type: float).',
		'auto_convergence_iters' : 'Number of iterations to perform after convergence is reached (type: int).',
		'param_file' : 'Override other parameters and use an external paramfile. Provide full path (type: string).',		
		'binning' : 'Enable/disable binning of raw images. If set to \'false\', then the Sampling parameter will be ignored (type: true/false).',		
		'preprocessing' : 'Enable/disable preprocessing of raw image files. If set to \'false\', then the Preprocessing Parameters will be ignored (type: true/false).',		
		'tilt_azimuth' : 'Override the tilt azimuth as recorded in the database with this value, in degrees, before alignment.<br><br>If the tilt axis is vertical, then the tilt azimuth is ±90°. If the tilt axis is horizontal, then the tilt azimuth is 0° or 180°.<br><br>Use this if you know that the tilt azimuth recorded in the database is wrong (ie. off by more than 20 degrees) and you know the correct tilt azimuth (type: float).',
		'azimuth_max_deviation' : 'If \'Check Azimuth Stability\' is turned on and the tilt azimuth exceeds +-(this value), in degrees, for a given iteration, then the tilt azimuth will be reset to the initial tilt azimuth for the next iteration (type: float).',	
		'select_images' : 'Select specific images in the tilt-series. Eg. 3,4,6-30. Only use numbers, commas, and hyphens (type: int selection).',		
		'exclude_images' : 'Exclude images from the tilt-series. Eg. 1-7,50-60. Only use numbers, commas, and hyphens (no spaces). Images are not renumbered after removal. You cannot exclude the image closest to 0°; ie. the alignment reference image.<br><br>Note: The image number corresponds to the IMAGE number in the .tlt file (type: int selection).',
		'exclude_images_by_angle' : 'Exclude images from the tilt-series given their tilt angles in degrees. Seperate angles by commas. If an angle you provide is not accurate to within the given Accuracy, then that angle will be ignored. Use angles provided on the bottom-right corner of the tilt-series videos.<br><br>It is important to remove any divergent tilt images prior to refinement. You may also wish to remove particularly poor tilt images before reconstruction. If your tilt-series was collected bidirectionally, there may be more than one zero degree image - you may wish to remove the second one for weighting purposes during alignment and reconstruction. (type: comma-seperated floats).',
		'exclude_images_by_angle_accuracy' : 'Accuracy of the requested angles versus the angles recorded in the database, in degrees (type: float > 0).',
		'desired_ref_tilt_angle' : 'Enter the tilt angle, in degrees, you would like to use as the reference image for Protomo alignment. This will choose the image closest to this value (type: float).',
		'border' : 'Width of area at the image edge to exclude from image statistics, in pixels. This option is used to ensure that the borders of the raw images that include artifacts from the camera are excluded (type: int > 0).',		
		'clip_low' : 'Lower threshold specified as a multiple of the standard deviation of the pixel density values per Raw Image. This option clips very low pixel values potentially caused by dead pixels (type: float).',
		'clip_high' : 'Upper threshold specified as a multiple of the standard deviation of the pixel density values per Raw Image. This option clips very high pixel values potentially caused by x-rays or other high energy interactions with the camera (type: float).',
		'thr_low' : 'Lower threshold specified as density values. Alternative to \'Lower Clip\' parameter (type: float).<br><br>Note that if the \'Alternate Raw Image Path\' option is not used, pixel values will be have been converted to float32 and normalized before this step.',		
		'thr_high' : 'Upper threshold specified as density values. Alternative to \'Upper Clip\' parameter (type: float).<br><br>Note that if the \'Alternate Raw Image Path\' option is not used, pixel values will be have been converted to float32 and normalized before this step.',
		'gradient' : 'Enable/disable linear gradient subtraction for preprocessing masks (type: true/false).',
		'gradient_switch' : 'Iteration when Linear Gradient Subtraction is switched from true«»false (type: int).',
		'iter_gradient' : 'Iterate gradient subtraction once (type: true/false).',
		'iter_gradient_switch' : 'Iteration when Iterate Gradient Subtraction Once is switched from true«»false (type: int).',
		'filter' : 'Preprocessing filter. Options are "median" or "gauss". If "gauss" is chosen, the radius of the Gaussian will be 1/2 of the Filter Window Size (type: string).',		
		'kernel_x' : 'Filter window size (x) of the Preprocessing Filter, in pixels. This value usually should not be changed (type: int).',			
		'kernel_y' : 'Filter window size (y) of the Preprocessing Filter, in pixels. This value usually should not be changed (type: int).',	
		'r1_kernel_x' : 'Filter window size (x) of the Preprocessing Filter for Round 1, in pixels. This value usually should not be changed (type: int).',
		'r2_kernel_x' : 'Filter window size (x) of the Preprocessing Filter for Round 2, in pixels. This value usually should not be changed (type: int).',
		'r3_kernel_x' : 'Filter window size (x) of the Preprocessing Filter for Round 3, in pixels. This value usually should not be changed (type: int).',
		'r4_kernel_x' : 'Filter window size (x) of the Preprocessing Filter for Round 4, in pixels. This value usually should not be changed (type: int).',
		'r5_kernel_x' : 'Filter window size (x) of the Preprocessing Filter for Round 5, in pixels. This value usually should not be changed (type: int).',
		'r1_kernel_y' : 'Filter window size (y) of the Preprocessing Filter for Round 1, in pixels. This value usually should not be changed (type: int).',
		'r2_kernel_y' : 'Filter window size (y) of the Preprocessing Filter for Round 2, in pixels. This value usually should not be changed (type: int).',
		'r3_kernel_y' : 'Filter window size (y) of the Preprocessing Filter for Round 3, in pixels. This value usually should not be changed (type: int).',
		'r4_kernel_y' : 'Filter window size (y) of the Preprocessing Filter for Round 4, in pixels. This value usually should not be changed (type: int).',
		'r5_kernel_y' : 'Filter window size (y) of the Preprocessing Filter for Round 5, in pixels. This value usually should not be changed (type: int).',
		'window_area' : 'Fraction of extracted area that must lie within the source image. Real value between 0 and 1. This value usually should not be changed (type: float).',
		'grow' : 'Grow the selected regions in the binary mask by the specified number of pixels. The first preprocessing step defines the binary mask area. This value usually should not be changed (type: int).',
		'do_estimation' : 'Estimate geometric parameters instead of using stored values from previous cycle. It is recommended to leave this set to false during Refinement (type: true/false).',
		'norotations' : 'Set in-plane rotations to zero instead of using stored values. It is recommended to leave this set to false during Refinement (type: true/false).',
		'max_correction' : 'Terminate alignment if correction exceeds specified value (type: float).',		
		'correlation_size_x' : 'Size (x) of the cross-correlation peak video, in pixels. Size is independent of sampling. There is usually no reason to change this value (type: int).',		
		'correlation_size_y' : 'Size (y) of the cross-correlation peak video, in pixels. Size is independent of sampling. There is usually no reason to change this value	 (type: int).',		
		'peak_search_radius_x' : 'Peak search radius (x), in pixels. This defines the area that the search for the correlation peak will be performed within (type: int).',			
		'peak_search_radius_y' : 'Peak search radius (y), in pixels. This defines the area that the search for the correlation peak will be performed within (type: int).',		
		'r1_peak_search_radius_x' : 'Peak search radius (x) for Round 1, in pixels (type: int).',	
		'r2_peak_search_radius_x' : 'Peak search radius (x) for Round 2, in pixels (type: int).',	
		'r3_peak_search_radius_x' : 'Peak search radius (x) for Round 3, in pixels (type: int).',	
		'r4_peak_search_radius_x' : 'Peak search radius (x) for Round 4, in pixels (type: int).',	
		'r5_peak_search_radius_x' : 'Peak search radius (x) for Round 5, in pixels (type: int).',	
		'r1_peak_search_radius_y' : 'Peak search radius (y) for Round 1, in pixels (type: int).',	
		'r2_peak_search_radius_y' : 'Peak search radius (y) for Round 2, in pixels (type: int).',	
		'r3_peak_search_radius_y' : 'Peak search radius (y) for Round 3, in pixels (type: int).',	
		'r4_peak_search_radius_y' : 'Peak search radius (y) for Round 4, in pixels (type: int).',	
		'r5_peak_search_radius_y' : 'Peak search radius (y) for Round 5, in pixels (type: int).',	
		'translimit' : 'Per-image, per-iteration translational limit, in pixels. Default: 8% of image width.<br><br>If a tilt image alignment results in a translation greater than this value, then the alignment for that particular image will be discarded and the initial image alignment will be used instead (type: float).',
		'orientation' : 'Include orientation angles in refinement. It is recommended to leave this set to true. Some alignments fail in later iterations because the orientation angle, theta (displayed in the Refinement Summary webpage), begins to diverge even after it converges. If this happens, try switching \'Include Orientation Angles in Refinement\' to false after it has converged (Hint: use the Switch option to do so) (type: true/false).',			
		'orientation_switch' : 'Iteration when Orientation Angles is switched from true«»false (type: int).',		
		'azimuth' : 'Include tilt azimuth in refinement. It is recommended to leave this set to true. Some alignments fail in later iterations because the tilt azimuth (displayed in the Refinement Summary webpage) begins to diverge even after it converges. If this happens, try switching \'Include Tilt Azimuth in Refinement\' to false after it has converged (Hint: use the Switch option to do so) (type: true/false).',			
		'azimuth_switch' : 'Iteration when Tilt Azimuth is switched from true«»false (type: int).',		
		'elevation' : 'Include tilt axis elevation in refinement. It is recommended to leave this set to false for the first few iterations and possibly set this to true for later iterations (type: true/false).',	
		'elevation_switch' : 'Iteration when Tilt Axis Elevation is switched from true«»false (type: int).',		
		'rotation' : 'Include in-plane rotations in refinement. It is recommended to leave this set to true (type: true/false).',	
		'rotation_switch' : 'Iteration when In-Plane Rotations is switched from true«»false (type: int).',
		'scale' : 'Include scale factors (magnification) in refinement. It is recommended to leave this set to false for the first few iterations and possibly set this to true for later iterations. If set to true from the beginning, scaling will be skipped on the first iteration (type: true/false).',
		'scale_switch' : 'Iteration when Scale Factors is switched from true«»false (type: int).',
		'logging' : 'Enable Protomo\'s diagnostic terminal output (type: true/false).',		
		'loglevel' : 'Increase verbosity of diagnostic output (type: 1 (some) or 2 (all)).',
		'tomo3d_procs' : 'The number of threads that Tomo3D will use for reconstruction (type: int or \'all\').',
		'tomo3d_sirt_iters' : 'The number of iterations for SIRT (type: int).',
		'tomo3d_options' : 'Place any additional Tomo3D options here as if this were part of the command line.<br><br>The following options have already been used: -a, -i, -o, -x, -y, -z, -v, -S and -l (for SIRT), and -t (if procs > 1).<br><br>For Tomo3D WBP consider using -m with a value between 0.35 and 0.5 when using tomograms for single particle tomography.<br><br>For Tomo3D SIRT consider using -c.<br><br>Please refer to the Tomo3D user manual for option details. (type: string).',
		'negative' : 'Remove all images from the tilt file below this angle limit, in degrees.<br><br>High tilt angle images sometimes align poorly compared to the rest of the tilt-series, are sometimes imaged off-center, or are sometimes visually obstructed. It is recommended that all offending images be removed before Refinement (type: float).',
		'positive' : 'Remove all images from the tilt file above this angle limit, in degrees.<br><br>High tilt angle images sometimes align poorly compared to the rest of the tilt-series, are sometimes imaged off-center, or are sometimes visually obstructed. It is recommended that all offending images be removed before Refinement (type: float).',
		'negative_recon' : 'Remove all images from the tilt file below this angle limit, in degrees.<br><br>High tilt angle images sometimes align poorly compared to the rest of the tilt-series. Consider removing offending high tilt images if they meet one or more of the following criteria (type: float):<br>&nbsp&nbsp• Correction Factor (x) > 1.015<br>&nbsp&nbsp• Correction Factor (y) < 0.985<br>&nbsp&nbsp• Correction Factor for Scaling < 0.985 or > 1.015<br>&nbsp&nbsp• Correction Factor for Rotation < -1.5° or > 1.5°',
		'positive_recon' : 'Remove all images from the tilt file above this angle limit, in degrees.<br><br>High tilt angle images sometimes align poorly compared to the rest of the tilt-series. Consider removing offending high tilt images if they meet one or more of the following criteria (type: float):<br>&nbsp&nbsp• Correction Factor (x) > 1.015<br>&nbsp&nbsp• Correction Factor (y) < 0.985<br>&nbsp&nbsp• Correction Factor for Scaling < 0.985 or > 1.015<br>&nbsp&nbsp• Correction Factor for Rotation < -1.5° or > 1.5°',
		'map_size_x' : 'Size (x) of the reconstructed tomogram (in pixels) relative to Sampling, not to Sampling for Depiction. Set this equal to dimension_x/sampling for a view of the full map (type: int).',		
		'map_size_y' : 'Size (y) of the reconstructed tomogram (in pixels) relative to Sampling, not to Sampling for Depiction. Set this equal to dimension_x/sampling for a view of the full map (type: int).',		
		'map_size_z' : 'Size (z) of the reconstructed tomogram (in pixels) relative to Sampling, not to Sampling for Depiction (type: int).',
		'recon_map_size_x' : 'Size (x) of the reconstructed tomogram before requested binning, in pixels. This value will be divided by the Reconstruction Sampling. This dimension is with respect to the center of the tomogram; ie. if you reduce this value this will cause the left and right edges to be clipped relative to the full dimensions.<br><br>Default: Full dimensions of the raw tilt images (type: int).',		
		'recon_map_size_y' : 'Size (y) of the reconstructed tomogram before requested binning, in pixels. This value will be divided by the Reconstruction Sampling. This dimension is with respect to the center of the tomogram; ie. if you reduce this value this will cause the top and bottom edges to be clipped relative to the full dimensions.<br><br>Default: Full dimensions of the raw tilt images (type: int).',		
		'recon_map_size_z' : 'Size (z) of the reconstructed tomogram before requested binning, in pixels (type: int).',		
		'recon_thickness' : 'Thickness of the unbinned specimen, in angstroms. This will be converted to pixels for the reconstruction.<br><br>It is recommended that you first watch the reconstruction video of the iteration you wish to reconstruct to get an idea of how many objects of interest there are in the frames where the Window Size box is drawn. You will likely wish to use the same or slightly larger/smaller thickness value than what you refined with (type: int).',
		'recon_lowpass' : 'Apply a lowpass filter to images before reconstruction by back-projection.<br><br>If you are planning on performing single particle tomography on the resulting tomogram, set this to False. If instead you are planning to use the tomogram for segmenting or visualization purposes, set this to True and set the lowpass filters to the resolution you are hoping to be able to segment from or visualize. (type: True/False).',
		'recon_lp_diam_x' : 'Lowpass filter (x), in angstroms. This will filter out frequencies higher than the chosen value. (type: float).',
		'recon_lp_diam_y' : 'Lowpass filter (y), in angstroms. This will filter out frequencies higher than the chosen value. (type: float).',
		'filename_prefix' : 'Prefix for input and output files, with the exception of raw image files, which are specified in the geometry file (type: string).',		
		'image_file_type' : 'Filetype extension for images. Protomo supports CCP4, EM, FFF, IMAGIC, MRC, SPIDER, SUPRIM, and TIFF. Appion-Protomo has been fully tested with images in MRC format (type: string).',		
		'cachedir' : 'Directory where cache files are stored (type: string).',		
		'protomo_outdir' : 'Directory where Protomo output files are stored (type: string).',
		'gridsearch_limit' : 'Grid Search +-angle limit, in degrees, for Coarse Alignment. This value usually should not be changed.<br><br>To do a translational alignment only, set Grid Search +-Angle Limit to 0 and set Grid Search Angle Step Size to 1 (type: float).',		
		'gridsearch_step' : 'Grid Search angle step size, in degrees, for Coarse Alignment. There is usually no reason to change this value (type: float).',
		'create_reconstruction' : 'Create a reconstruction after Coarse Alignment for depiction as a video on the next page. If set to \'false\', then the remaining Depiction Parameters will be ignored (type: true/false).',
		'keep_recons' : 'Keep premilinary reconstructions used for generating a reconstruction video. Reconstructions can be found in the tiltseries\' \"out\" directory with file names ending in \"_bck\" (type: true/false).',
		'video_type' : 'Depiction videos for correlation peaks, tilt-series, and reconstructions will be made. Select HTML5 to encode videos as mp4, webm, and ogv (for compatibility). It is recommended that you only use gifs if there is any trouble with HTML5 video playback in your browser. (ffmpeg and relevant codecs are required)<br><br>If HTML5 videos don\'t loop, try refreshing the webpage (type: string).',
		'recon_iter' : 'Refinement iteration used to make final reconstructions. Either Choose BestBin1or2*, Best*, Worst*, Last, or Custom. If you choose Custom, put the desired iteration into the box on the right. *As determined by CCMS(summed).<br><br>Note: This will leave all iterations and all files in the output directories untouched (type: int).',
		'coarse_param_file' : 'Full path to Coarse Alignment Protomo param file. It is recommended that select/include and exclude are removed or set to 0-999999 and 999999, respectively. pathlist, cachedir, and outdir will be altered per tilt-series.<br><br>All Coarse Alignment parameters will be taken from this param file (type: string).',
		'refine_param_file' : 'Full path to Refinement Protomo param file. It is recommended that select/include and exclude are removed or set to 0-999999 and 999999, respectively. pathlist, cachedir, and outdir will be altered per tilt-series.<br><br>All Refinement parameters not included in this section will be taken from this param file (type: string).',
		'recon_param_file' : 'Full path to Reconstruction Protomo param file. It is recommended that select/include and exclude are removed or set to 0-999999 and 999999, respectively. pathlist, cachedir, outdir, map size, and map sampling will be altered per tilt-series.<br><br>All Reconstruction parameters not included in this section will be taken from this param file (type: string).',
		'procs' : 'Number of processors to use for parallel Alignment and Reconstruction. Batch processing is embarrasingly parallel; each processor goes linearly through the steps that you choose above (Preparation, Coarse Alignment, Refinement, and Reconstruction). For highest efficiency, choose a number that evenly divides the number of tilt-series to be processed. This value is limited by the number of processors on the machine protomo2batch.py will be run on.<br><br>Power-user tip: Append \'--parallel=True\' to your protomo2batch.py command to parallelize video depiction processing during Refinement (double parallelization). Warning: this might break the machine you are running on if it does not have sufficient resources (type: int or \'all\').',
		'stack_procs' : 'Number of processors to use when creating the stack (type: int or \'all\').',
		'link_recon' : 'Hardlink the final normalized .mrc reconstruction file to a directory. Provide full path. If no directory is provided, the reconstruction can be found in the tilt-series Output directory\'s \'recons/out\' folder (type: string).',
		'link_recons' : 'Hardlink the final normalized .mrc reconstruction files to a single directory. Provide full path (type: string).',
		'tiltseriesranges' : 'One or more ranges of tilt-series to be processed. Only use numbers, commas, and hyphens. Eg. 3,4,6-30 (type: int selection).',
		'restart_cycle' : 'Restart a Refinement at this iteration. Only use if a Refinement has previously been run to or past the chosen iteration. All files for subsequent iterations will be removed before restarting the Refinement (type: int).',
		'restart_from_run' : 'Run name (if in same Output directory) or full path (if not in same Output directory) of previously Refined Appion-Protomo run from which you wish to restart the Refinement using the current, new Run name and/or Output directory (type: string or full path).',
		'restart_from_iteration' : 'Refinement iteration of specified previously Refined Appion-Protomo run from which you would like to restart the Refinement. If you manually aligned an iteration from a previous run, input \'MoreManual\' (type: int or \'MoreManual\').',
		'defocus_min' : 'Initial defocus, in micrometers, where the search will begin. TomoCTF will begin its defocus search slightly before this value and continue on to the maximum defocus in step sizes of 1 angstrom. By default the nominal defocus minus 20% for the first image of the tilt-series will be used.<br><br>If the estimated defoci presented on the subsequent summary webpage do not match at the first zero, you may need to change this value to exclude this wrong defocus value from the range (type: float).',
		'defocus_max' : 'Maximum defocus, in micrometers, allowed in the search range. By default the nominal defocus plus 20% will be used (type: float).',
		'defocus_difference' : 'Defocus Difference (∆D) for strip extraction, in angstroms. This is the value of height under which negligible difference in CTF (defocus) is assumed. It is used for the stripping process. The larger this value is, the wider the strips are through the tilt series, and consequently the more tiles there are (type: float).',
		'defocus_ang_negative' : 'Negative angle, in degrees, beyond which images will be excluded before defocus estimation by TomoCTF.<br><br>It is recommended that images that have shifted substantially from the intended exposure area (> 50%) be removed (type: float).',
		'defocus_ang_positive' : 'Positive angle, in degrees, beyond which images will be excluded before defocus estimation by TomoCTF.<br><br>It is recommended that images that have shifted substantially from the intended exposure area (> 50%) be removed (type: float).',
		'amp_contrast_defocus' : 'The fraction of amplitude contrast. For Cryo-EM, it should be 0.07. Protein-nucleic acid complexes should use 0.1. A value of 0.14 or 0.15 should be used for negative stain (type: float).',
		'defocus_diference' : 'The height in the beam direction, in angstroms, used to determine strip width. Each strip will be corrected for with a constant defocus.<br><br>It is recommended that this value remain above 200 angstroms otherwise artifacts might appear (type: float).',
		'amp_correct' : 'Correct for amplitude in addition to phase flipping? If turned on, a Wiener filter will be applied during CTF correction by strips, which is controlled by the two Wiener filter parameters to the right, w1 and w2 (see TomoCTF documentation) (type: selection).',
		'amp_correct_w1' : 'The minimum value of CTF from which restoration by inverse filter (ie. division by the CTF) is to be applied.<br><br> Values between 0.5 and 0.75 might be considered safe in that one should avoid noise overshooting (type: float between 0 and 1).',
		'amp_correct_w2' : 'The maximum value of CTF below which the standard Wiener filter is to be applied.<br><br>Values between 0.25 and 0.5 might be considered safe in that one should avoid noise overshooting (type: float between 0 and 1).',
		'res_min' : 'Lowest resolution information, in angstroms, to use to fit the signal falloff before defocus estimation.<br><br>Typically setting this value to a very low resolution is appropriate (type: float).',
		'res_max' : 'Highest resolution information, in angstroms, to use to fit the signal falloff before defocus estimation.<br><br>This value should be set to the maximum amount of information you believe the instrumentation used to collect the tilt-series is capable of producing given the contents of the tilt images.<br><br>Default: 2xNyquist (type: float).',
		'defocus_save' : 'Save this defocus value (in angstroms, positive for underfocus) instead of estimating defocus of the untilted tilt-series plane<br><br>Example: input 30000 for 3 microns underfocus (type: float).',
		'defocus_save_recon' : 'Save this defocus value (in angstroms, positive for underfocus) before reconstruction/stack creation.<br><br>Example: input 30000 for 3 microns underfocus (type: float).',
		'defocus_tlt' : 'Which iteration to use for determining the tilt-azimuth for defocus estimation.<br><br>TomoCTF defocus estimation requires the tilt-azimuth to be defined as accurately as possible. Luckily, Protomo refines the tilt-azimuth during tilt-series Refinement. Choose which iteration should be used to extract the tilt-azimuth.<br><br>Options: Best (by CCMS value), Best with binning of 1 or 2 (by CCMS value), Original (ie. as recorded in the database before alignment), or choose Iteration and enter an iteration number to the right (type: selection).',
		'defocus_tlt_iteration' : 'If Iteration is chosen to the left, enter an iteration number here from which the tilt-azimuth will be extracted for defocus estimation (type: int).',
		'amp_contrast_ctf' : 'The fraction of amplitude contrast. For Cryo-EM, it should be 0.07. Protein-nucleic acid complexes should use 0.1. A value of 0.14 or 0.15 should be used for negative stain (type: float).',
		'iWidth' : 'The distance in pixels between the center lines of two consecutive strips.  A pixel inside the region between those two centerlines resides in both strips. As the two strips are corrected separately, that pixel will have 2 corrected values. The final value for that pixel is a linear interpolation of the 2 corrected values (type: int).',
		'DefocusTol' : 'Defocus tolerance that limits the width of the strips, in nanometers. An image region with defocus difference less than this tolerance is considered to have constant defocus and can be corrected as one strip. The strip width is either the width of this region or the maxmimum strip width (256 pixels by default), whichever is smaller; but strips will also be constrained to be at least 128 pixels wide.  Each strip is corrected based on the defocus at the center of the strip (type: int).',
		'dose_a' : 'The variable \'a\' in the function<br>lowpass=(a/(dose-c))^(1/b)<br>which is the inverse of equation (3) in Grant & Grigorieff, 2015 (citation below).<br><br>Choose Custom under \'Dose Compensation Type\' for your value to be accepted (type: float and > 0).',
		'dose_b' : 'The variable \'b\' in the function<br>lowpass=(a/(dose-c))^(1/b)<br>which is the inverse of equation (3) in Grant & Grigorieff, 2015 (citation below).<br><br>Choose Custom under \'Dose Compensation Type\' for your value to be accepted (type: float and < 0).',
		'dose_c' : 'The variable \'c\' in the function<br>lowpass=(a/(dose-c))^(1/b)<br>which is the inverse of equation (3) in Grant & Grigorieff, 2015 (citation below).<br><br>Choose Custom under \'Dose Compensation Type\' for your value to be accepted (type: float).',
		'screening_start' : 'This is the first tilt-series that will be processed followed by the next tilt-series incrementally until the used stops the command (type: int).',
		'template_location' : 'Location of the 3D template to be convoluted with the tomogram (type: full path).',
		'estimated_particles' : 'Estimated number of particles in the tomograms.<br><br>The template-tomogram convolution map will first be rastered with a box the size of the template where the maximum correlation value for each box location will be recorded. Then this number will be used to filter the picks based on correlation value. After this filtering, junk particles will be sorted out (type: int).',
		'distance_from_edges' : 'Minimum distance from the edge that will be considered a pickable location, in pixels (type: int).',
		'junk_tolerance' : 'Attempts to remove junk particle picks by checking the real space map at the pick locations and removing them if the real space average density in the particle is too high (type: float; higher = remove more particles).',
	},
	'upload_external_recon' : {
		'stackid' : 'Unique Appion database id of the stack used for the refinement',
		'modelid' : 'Unique Appion database id of the model used for the refinement',
		'numiter' : 'Total number of succesful refinement iterations located in the uplaod directory.',
		'uploadIterations' : 'ex. 1,2,3,4,5 - The specific iterations that you would like to upload to the Appion database.',
		'timestamp' : 'Define a timestamp, e.g. "11jun03a" or "my_favorite_refinement_procedure_june03" or whatever you want. This is the timestamp that is part of your file names. 3D mrc file titled: recon_"timestamp"_it#_vol#.mrc (it# and vol# have 3 integers), as for example "recon_11jul18z_it001_vol001.mrc".',
		'numberOfReferences' : 'Number of output models / references',
		'symid' : 'The Appion database id for your Symmetry. For example, 25 is the id for C1 symmetry.',
		'mass' : 'The size of the window for the blur function.',
		'apix' : 'The pixelsize, in Angstroms.',
		'box' : 'The boxsize, in pixels.',
	}		
	,		
	'isac' : {
		'ir' : 'Inner radius of the resampling to polar coordinate, colon separate for different generations,e.g. 4x1:2x5 means ir=0 for 4 generations and ir=5 for 2 generations (default 1)',
		'ou' : 'Outer radius of the resampling to polar coordinate, colon separate for different generations, e.g. 4x24:2x20 means ou=24 for 4 generations and ou=20 for 2 generations (default box/2-2',
		'rs' : 'Ring step of the resampling to polar coordinate, colon separate for different generations. e.g. 4x1:2x2 means rs=1 for 4 generations and rs=2 for 2 generations (default 1)',
		'ts' : 'Search step of translational search, colon separate for different generations. e.g. 4x1:2x2 means ts=1 for 4 generations and ts=2 for 2 generations (default 1)',
		'xr' : 'x range of translational search, colon separate for different generations,e.g. 4x1:2x2 means xr=1 for 4 generations and xr=2 for 2 generations (default 1).',
		'yr' : 'y range of translational search, colon separate for different generations,e.g. 4x1:2x2 means yr=1 for 4 generations and yr=2 for 2 generations (default 1)',
		'maxit' : 'number of iterations for reference-free alignment, colon separate for different generations,.e.g. 4x30:2x20 means maxit=30 for 4 generations and maxit=20 for 2 generations (default 30)',
		'FL' : 'lowest stopband frequency used in the tangent filter, colon separate for different generations.e.g. 4x0.1:2x0.08 means FL=0.1 for 4 generations and FL=0.08 for 2 generations (default 0.1)',
		'FH' : 'highest stopband frequency used in the tangent filter, colon separate for different generations,e.g. 4x0.3:2x0.4 means FH=0.3 for 4 generations and FH=0.4 for 2 generations (default 0.3)',
		'FF' : 'falloff of the tangent filter, colon separate for different generations,.e.g. 4x0.2:2x0.3 means FF=0.2 for 4 generations and FF=0.3 for 2 generations (default 0.2)',
		'init_iter' : 'number of runs of ab-initio within-cluster alignment for stability evaluation in SAC initialization,colon separate for different generations, e.g. 4x3:2x2 means init_iter=3 for 4 generations and init_iter=2 for 2 generations (default 3)',
		'main_iter' : 'number of runs of ab-initio within-cluster alignment for stability evaluation in SAC, colon separate for different generations, e.g. 4x3:2x2 means main_iter=3 for 4 generations and main_iter=2 for 2 generations (default 3)',
		'iter_reali' : 'every iter_reali iterations of SAC stability checking is performed, colon separate for different generations, e.g. 4x1:2x2 means iter_reali=1 for 4 generations and iter_reali=2 for 2 generations (default 1)',
		'match_first' : 'number of iterations to run 2-way matching in the first phase, colon separate for different generations, e.g. 4x1:2x2 means iter_reali=1 for 4 generations and iter_reali=2 for 2 generations (default 1)',
		'max_round' : 'maximum rounds of generating candidate class averages in the first phase, colon separate for different generations, e.g. 4x20:2x10 means max_round=20 for 4 generations and max_round=10 for 2 generations (default 20)',
		'match_second' : 'number of iterations to run 2-way (or 3-way) matching in the second phase, colon separate for different generations, e.g. 4x5:2x3 means match_second=5 for 4 generations and match_second=3 for 2 generations (default 5)',
		'stab_ali' : 'number of alignments when checking stability, colon separate for different generations, e.g. 4x5:2x3 means stab_ali=5 for 4 generations and stab_ali=3 for 2 generations (default 5)',
		'thld_err' : 'the threshold of pixel error when checking stability, equals root mean square of distances between corresponding pixels from set of found transformations and theirs average transformation, depends linearly on square of radius (parameter ou), colon separate for different generations, e.g. 4x1:2x3 means thld_err=1 for 4 generations and thld_err=3 for 2 generations (default 0.7)',
		'indep_run' : 'specifies the level of m-way matching for reproducibility tests. The default = 4 will perform full ISAC to 4-way matching. Value indep_run=2 will restrict ISAC to 2-way matching and 3 to 3-way matching. Note the number of used MPI processes requested in mpirun must be a multiplicity of indep_run, colon separate for different generations, e.g. 4x4:2x2 means indep_run=4 for 4 generations and indep_run=2 for 2 generations (default 4)',
		'generations' : 'number of approaches on the dataset',
		'alignstack' : 'Aligned stack of particles to use',
		'img_per_grp' : 'number of images per class in the ideal case (essentially maximum size of class), colon separate for different generations, e.g. 4x100:2x50 means thld_grp=100 for 4 generations  and thld_grp=50 for 2 generations (default 100)',
		'use_align_stack' : 'Check this box to enable the aligned stack selector. The selected aligned stack will then be used for this ISAC run.',
		'thld_err' : 'the threshold of pixel error when checking stability, equals root mean square of distances between corresponding pixels from set of found transformations and theirs average transformation, depends linearly on square of radius (parameter ou), colon separate for different generations, e.g. 4x1:2x3 means thld_err=1 for 4 generations and thld_err=3 for 2 generations (default 0.7)',
	}
	,		
	'departalign' : {
		'stackid' : 'Stack on which to do frame alignment.',
		'output_rotation' : 'Rotate output particles by the specified angle',
		'darkreference_transform' : 'Please edit help.js to add help info for this parameter.',
		'gainreference_transform' : 'Please edit help.js to add help info for this parameter.',
		'defects_columns' : 'Please edit help.js to add help info for this parameter.',
		'defects_rows' : 'Please edit help.js to add help info for this parameter.',
		'alignment_correct' : 'Please edit help.js to add help info for this parameter.',
		'boxes_transform' : 'Please edit help.js to add help info for this parameter.',
		'radiationdamage_compensate' : 'Please edit help.js to add help info for this parameter.',
		'radiationdamage_exposurerate' : 'Please edit help.js to add help info for this parameter.',
		'radiationdamage_apix' : 'Please edit help.js to add help info for this parameter.',
		'alignment_target' : 'Please edit help.js to add help info for this parameter.',
	},
	
	'gctf' : {
		
		'kV' : 'Typically 300, 200 or 120',
		'ac' : "Normal range 0.04~0.1; pure ice 0.04, carbon 0.1. A wrong value doesn't matter much.",
		'dstep' : 'Use default if unknown',
		'astm' : "Doesn't need to be accurate, within 0.1~10 times is OK",
		'bfactor' : "Suggested range 50~300 except using 'REBS method'",
		'boxsize' : '512 or 1024 highly recommended',
		'do_basic_rotave' : 'Do rotational averaging, used for output CTF file. Only effects the output and is not used for CTF determination.',
		'overlap' : 'Overlapping factor for grid boxes sampling. For boxsize=512, use 0.5',
		'convsize' : 'Suggested 1/5 ~ 1/20 of bosize in pixels, e.g. a value of 99 for boxsize=512',
		'mdef_fit' : 'Linear fitting defocus changes in Z-direction',
	},	

	'relion2DMaxlike' : {
		'mpinodes' : 'Total number of nodes allocated for rmaxlike run. Set to equal the number of nodes in processing parameters.',
		'mpiprocessors' : 'Number of processors used on each node. For memory intensive jobs, decrease this value and increase memory per thread.',
		'mpithreads' : 'Number of threads per process. Default is 1, only adjust this value if you know what you\'re doing.',
		'memoryperthread' : 'Amount of memory allocated per thread. For memory intensive jobs, increase this value and decrease the number of processors. Memory per thread * number of processors <= Total memory per node.',
		'unbinnedclipdiameter' : 'Rescale the unbinned box size. Measured in pixels.',
		'particlebinning' : 'Binning the particle images. This quickly shrinks the image to help make the processing faster.',
		'numberofparticles' : 'Number of particles to use.',
		'lowpassfilterradius' : 'Low pass filter applied to individual particles',
		'highpassfilterradius' : 'High pass filter applied to individual particles',
		'particlediameter' : 'Diameter of the circular mask that will be applied to the experimental images (in Angstroms)',
		'numberofreferences' : 'Number of references to generate in an ab initio manner. This will depend on the amount of preferred orientation within your data. A good range to aim for could be ~100-1000 particles per reference, but because ML algorithms are computationally intense, this may not always be feasible, depending on the size of your dataset. Defaults to square root of number of particles',
		'maxnumberofiterations' : 'Maximum number of iterations to perform without converging before giving up.',
		'angleinc' : 'angular increment for alignment, the smaller the increment the longer it takes to run, default 5, rough run use 10 degrees',
		'tau2fudge' : 'The regularisation parameter determines the relative weight between the experimental data and the prior. Bayes law dictates it should be 1, but sometimes better results are obtained using slightly higher values. 2D classifications seem to go better with values of 1-2.',
		'flattensolvent' : 'Perform masking on references',
		'zeromasking' : ' Mask surrounding background in particles to zero (by default the solvent area is filled with random noise)',
		'correctnorm' : 'Perform normalisation error correction'

	}
		
}

