<?php
/**
 *	The Leginon software is Copyright under 
 *	Apache License, Version 2.0
 *	For terms of the license agreement
 *	see  http://leginon.org
 *
 */

require_once "inc/particledata.inc";
require_once "inc/leginon.inc";
require_once "inc/project.inc";
require_once "inc/viewer.inc";
require_once "inc/processing.inc";
  
// check if coming directly from a session
$expId = $_GET['expId'];
if ($expId) {
        $sessionId=$expId;
        $formAction=$_SERVER['PHP_SELF']."?expId=$expId";
}
else {
        $sessionId=$_POST['sessionId'];
        $formAction=$_SERVER['PHP_SELF'];
}

if ($_GET['showHidden'])
	$formAction.="&showHidden=1";
$projectId = getProjectId();

$javascript = "<script src='../js/viewer.js'></script>\n";
$javascript.= editTextJava();

processing_header("Tomographic Reconstruction Summary","Tomogram Summary Page", $javascript);

// edit description form
echo "<form name='templateform' method='post' action='$formAction'>\n";

$particle = new particledata();
$alltomoaligns = $particle->getTomoAlignmentRunsFromSession($sessionId, True);
if (hasPatternInArrayKeys($_POST,'/updateDesc/')) {
	foreach ($alltomoaligns as $t)
		$particle->updateTableDescriptionAndHiding($_POST,'ApTomoAlignmentRunData',$t['alignrun id']);
}

// --- Get Averaged tomograms
if (!$_GET['showHidden']) {
	$showntomoaligns = $particle->getTomoAlignmentRunsFromSession($sessionId, False);
	$alltomoaligns = $particle->getTomoAlignmentRunsFromSession($sessionId, True);
} else {
	$showntomoaligns = $particle->getTomoAlignmentRunsFromSession($sessionId, True);
	$alltomoaligns = $alltomoaligns;
}
echo $particle->displayHidingOption($expId,$alltomoaligns,$showntomoaligns,$_GET['showHidden']);
if ($showntomoaligns) {
	$html = "<h4>TiltSeries Alignment Runs</h4>";
	$html .= "<table class='tableborder' border='1' cellspacing='1' cellpadding='5'>\n";
	$html .= "<TR>\n";
	$display_keys = array ( 'tilt number','alignrun id','alignrun name','method','description','bad align');
	foreach($display_keys as $key) {
		$html .= "<td><span class='datafield0'>".$key."</span> </TD> ";
	}
	$html .= "</TR>\n";
	foreach ($showntomoaligns as $t) {
		$aligninfo = $particle->getTomoAlignmentInfo($t['alignrunid']);
		$t['bad align'] = $aligninfo['badAlign'];
		$t['method'] = $aligninfo['method'];
		$html .= $particle->displayParametersInSummary($t,$display_keys,$expId,$hide_button_field='alignrun id');
	}
	$html .= "</table>\n";
	$html .= "<br>\n";
	echo $html;
} else {
	$html = "<p>no tilt series alignment available</p>";
	echo $html;
}
echo $particle->displayHidingOption($expId,$alltomoaligns,$showntomoaligns,$_GET['showHidden']);
// --- 

processing_footer();
?>
